#include <inrimage/image.h>
#include <stdio.h>
#include <stdlib.h>

#define NCMD	14


static char Ucmd0[]=
"[image-in | -] [image-out] ";
static char Ucmd1[]=
"[image-in | -] [image-out] -n coeff";
static char Ucmd2[]=
"[image-in | -] [image-out] -n seuil";
static char Ucmd3[]=
"[image-in | -] [image-out] -n seuil val";
static char Udetail[]=
"\tsi les 2 arguments image sont absents on prendra stdin et stdout\n\
\tsi 'image-out' absent, il faut remplacer 'image-in' par '-' pour stdin\n\
\tcette commande est une variante de 'arit1' : le parametre numerique depend\n\
\t  de la variante en question";

extern int debug_;

static struct multi_cmd cmds[] = {
		"bi",Ucmd1,Udetail,	/*  1 */
		"sc",Ucmd1,Udetail,	/*  2 */
		"lo",Ucmd0,Udetail,	/*  3 */
		"exp",Ucmd0,Udetail,	/*  4 */
		"ra",Ucmd0,Udetail,	/*  5 */
		"sba",Ucmd2,Udetail,	/*  6 */
		"sha",Ucmd2,Udetail,	/*  7 */
		"sd",Ucmd1,Udetail,	/*  8 */
		"mb",Ucmd2,Udetail,	/*  9 */
		"mh",Ucmd2,Udetail,	/* 10 */
		"mo",Ucmd0,Udetail,	/* 11 */
		"car",Ucmd0,Udetail,	/* 12 */
		"vb",Ucmd3,Udetail,	/* 13 */
		"vh",Ucmd3,Udetail,	/* 14 */
		0,0,0,
		};

fcmain_()
{
	register struct multi_cmd *ppcmd;

	char in[128],out[128];
	float sc = 0. , val = 0. ;
	Fort_int choix;

	choix = inr_initm(0,0,"2.1",cmds);
	ppcmd = &cmds[choix];

	if ( debug_ ) fprintf(stderr,"fonction %s\n",ppcmd->name);

	switch ( ++choix ) {
	case 1 : /* biais */
	case 2 : /* scale */
	case 6 : /* seuil bas */
	case 7 : /* seuil haut */
	case 8 : /* division */
	case 9 : /* masque bas */
	case 10 : /* masque haut */
		
		if ( !igetopt("-n","",0,"%f",&sc,"",0) ) {
			/* scalaire obligatoire */
			fprintf(stderr,"%s:scalaire obligatoire\n",
				xargv[0]);
			iusage_(ppcmd->ucmd,ppcmd->udetail);
			exit(-1);
		}
		break;
		
	case 3 : /* logarithme */
	case 4 : /* exponentielle */
	case 5 : /* racine carree */
	case 11 : /* module */
	case 12 : /* carre */
		break;
		
	case 13 : /* seuil variable bas */
	case 14 : /* seuil variable haut */
		
		if ( !igetopt("-n","",0,"%f",&sc,"%f",&val) ) {
			/* scalaire obligatoire */
			fprintf(stderr,"%s:2 scalaires obligatoires (-n seuil val)\n",
				xargv[0]);
			iusage_(ppcmd->ucmd,ppcmd->udetail);
			
			exit(-1);
		}
		break;
		
	}
	
	fileopt(in,"i");
	fileopt(out,"o");


	if(tstopts())
		iusage_(ppcmd->ucmd,ppcmd->udetail);

	if (debug_) fprintf(stderr,
		"sc=%f val=%f\n",sc,val);

	sarit1_(&choix,in,out,&sc,&val);
	return 0;

}


