#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"[-el n1 n2] [image-ligne-in | -] [image-out] [options-de-dim.]";
static char Udetail[]=
"\tconstruit 'image'out' par rotation de 'image-ligne'\n\
\t  -el : forme elliptique avec rapport d'axes 'n1' et inclinaison 'n2' degres";


fcmain_()
{
	char inname[128],outname[128];
	float b = 1. , teta = 0.; /* cercle par defaut */

	inr_init(0,0,"2.1",Ucmd,Udetail);

	/* get files for input and output (stdin, stdout by default) */
	infileopt(inname);
	outfileopt(outname);

	/* option : -el n1 n2 */
	igetopt2("-el","%f",&b  ,"%f",&teta);

	/* check options, but ignore dim opt. (used if output image must be created */
	if(gtstopts(0,1,0))  
		iusage_(Ucmd,Udetail);

	stourn_(inname,outname,&b,&teta);
	return 0;

}


