#include <stdio.h>
#include <inrimage/image.h>

#define MAXCOL 256

static char tabr[MAXCOL], tabg[MAXCOL], tabb[MAXCOL];
static char outtab[3*MAXCOL];
static char compr[MAXCOL], compg[MAXCOL], compb[MAXCOL];

static char *pcol[3] = {tabr,tabg,tabb};
static char *pcomp[3] = {compr,compg,compb};

#define O_BW 0
#define O_C8 1
#define O_C24 2
#define O_C3V 3
#define O_HSV 4
#define O_Q8 5
#define O_Q8ND 6

static int un= 1;
#define ALIGN4(x) ((x + 3) & ~3)

static int ecr_lect3();
extern int debug_;
/* si *nf_ct != NULL, on compose les t.c. avec le fichier nf_ct */

/* lfmti: format d'entree, lfmto = format de sortie
nfi et nfo tableaux de 3 nf
si 1 seule image les 3 elements du tableau nf sont egaux
*/
scnvcol(buffer,ndims,nfi,nfo,nf_ct,lfmti,lfmto,pflg_out,HSVmax,pncols)
char *buffer;
Fort_int *ndims;
struct image **nfi, **nfo, **nf_ct;
Fort_int lfmti[9], lfmto[9], *pncols;
int *pflg_out;
float *HSVmax;
{
	int nbtab1, nbtab2, nbtab, ncols, newnc, flg_q;
	int i0, nbcol;
	int flg_in, flg_out;
	int nzo, nzi, nvi, nvo, ibsize;
	int nbi, nbo;
	int iy, flag;
	register n, n1, n2, i, nbl;
	register char **pc;
	int nblig;
	int nmax, incrgb;
	float Hmax;
	char *bufr, *bufg, *bufb, *buff2;
	char *outbuf[3], *inbuf[3], *hsvbuf[3], *rgbbuf[3];
	nbi = nfi[0] == nfi[1] ? 1 : 3;
	nbo = nfo[0] == nfo[1] ? 1 : 3;
	ncols = *pncols;
	flg_out = *pflg_out;
	flg_q = 0;
	if(flg_out == O_Q8ND) {
		flg_q= 1;
		flg_out = O_Q8;
	}
	if(nbi == 1) {
		nbtab1 = ird_ctrgb(*nfi,&i0,&nbcol,tabr,tabg,tabb,MAXCOL);
	} else {
		ird_ctrgb(nfi[0],&i0,&nbcol,tabr,NULL,NULL,MAXCOL);
		ird_ctrgb(nfi[0],&i0,&nbcol,NULL,tabg,NULL,MAXCOL);
		ird_ctrgb(nfi[0],&i0,&nbcol,NULL,NULL,tabb,MAXCOL);
		nbtab1 = icmp_ct(tabr,tabg,tabb,MAXCOL);
	}
	nbtab = nbtab1;
	if(*nf_ct != NULL) { /* il y a 2e table couleur */
		nbtab2 = ird_ctfile(*nf_ct,&i0,&nbcol,compr,compg,compb,MAXCOL);
		nbtab = nbtab2 > nbtab1 ? nbtab2 : nbtab1;
		/* compose 2 tables */
		apply_1ct(tabr,tabr,MAXCOL,compr);
		apply_1ct(tabg,tabg,MAXCOL,compg);
		apply_1ct(tabb,tabb,MAXCOL,compb);
	}
	nzo = lfmto[I_NDIMZ];
	nzi = lfmti[I_NDIMZ];
	nvo = lfmto[I_NDIMV];
	nvi = lfmti[I_NDIMV];
	if(Hmax = *HSVmax) {
		flag = 1;  /* utiliser NDIMV */
		if((nvi == 1) && (nzi <= 3))
			flag = nzi;
		else if(nvi > 3) {
			if(nzi <= 3)
				flag = nzi;
			else
				Hmax = 0.;
		}
	}
	ibsize = 1;
	if(nbi > 1)
		flg_in = O_C24;
	else if(Hmax) {
		flg_in = O_HSV;
		ibsize = sizeof(float);
		if(ibsize < lfmti[I_BSIZE])
			ibsize = lfmti[I_BSIZE];
	} else if(nvi == 3)
		flg_in = O_C3V;
	else if(nzi == 3)
		flg_in = O_C24;
	else {
		if(nbtab <= 1)
			flg_in = O_BW;
		else
			flg_in = O_C8;
	}
	n = *ndims * sizeof(t_aligned);
	nbl = lfmti[I_DIMX];
	/* determination du nb de buffers */
	if(flg_out == O_Q8) {
		n1 = flg_in == O_C24 ? lfmti[I_NDIMY] : lfmti[I_DIMY];
		n = ibsize * nbl * n1;
		if((flg_in == O_C24) || (flg_in == O_BW) || (flg_in == O_C8)) {
			n1 = 3 * ALIGN4(n);
			if(flg_in != O_C24) n = n1;
		} else n1 = n;
		n2 = lfmto[I_DIMX] * lfmti[I_DIMY];
		buffer = i_malloc(n1 + n2);
	} else if((flg_in == O_C8) || (flg_in == O_BW)) {
		if(flg_out == O_C24)
			nbl = 3 * (lfmti[I_DIMX] + sizeof(int));
		else 
			nbl += lfmto[I_DIMX] + 2 * sizeof(int);
	} else if(flg_in == O_C24) {
		nbl = 3 * (lfmti[I_DIMX] + sizeof(int));
		if(flg_out == O_C3V)
			nbl += lfmto[I_DIMX] + sizeof(int);
	} else if(flg_in == O_HSV) {
		nbl = lfmti[I_DIMX] * ibsize * flag + 3 * (lfmti[I_NDIMX] + sizeof(int));
	} else {  /* O_C3V */
		if(flg_out == O_C24)
			nbl += 3 * lfmti[I_DIMX] + 4 * sizeof(int);
	}
	nblig = n / nbl;
	if(nblig <= 0)
		imerror(8,"scnvcol: pas assez de memoire\n");
	nmax = lfmti[I_DIMY];
	if(((flg_out != O_Q8) && (flg_in == O_C24)) || ((flg_in == O_HSV) && (flag > 1)))
		nmax = lfmti[I_NDIMY];
	else if(flg_out == O_C24)
		nmax = lfmto[I_NDIMY];
	if(nblig > nmax)
		nblig = nmax;
	if((flg_in == O_C24) && (flg_out == O_C24)){  /* cas particulier : simple copie */
		if(debug_) {
			fprintf(stderr,"scnvcol : copie, nbtab= %d, nzi=%d, nbi=%d nblig=%d\n",
				nbtab,nzi,nbi,nblig);
		}
		pc = pcol;
		for(i=0;i<3;i++) {
			nbl = nblig;
			nmax = lfmti[I_NDIMY];
			while(nmax > 0) {
				if(nbl > nmax) nbl = nmax;
				c_lect(nfi[i],nbl,buffer);
				if(nbtab >= 1) {  /* apply ct */
					apply_1ct(buffer,buffer,lfmti[I_NDIMY] * nbl,*pc);
				}
				c_ecr(nfo[i],nbl,buffer);
				nmax -= nbl;
			}
			pc++;
		}
		return 1 /* makes c99 happy */;
	}
	pc = nbtab >= 1 ? pcol : NULL;
	if((flg_out == O_C8) && (flg_in != O_BW)) {
		if(debug_) {
			fprintf(stderr,"scnvcol : call set_c8_ct\n");
		}
		set_c8_ct(outtab,&outtab[MAXCOL],&outtab[2*MAXCOL]);
		iwr_ctrgb(*nfo,0,MAXCOL,outtab,&outtab[MAXCOL],&outtab[2*MAXCOL]);
	}
	iy = 1;
	if(debug_) {
		fprintf(stderr,"scnvcol : flg_in=%d, flg_out=%d, nbtab %d, nblig %d\n",
			flg_in, flg_out,nbtab,nblig);
	}
	if(nbi == 3)
		nzi = 3;
	if(nbo == 3)
		nzo = 3;
	n = nblig * lfmti[I_DIMX];
	buff2 = buffer;
	if(flg_in == O_HSV) {
		buff2 = buffer + ALIGN4((n * ibsize * flag));
		hsvbuf[0] = buffer;
		if(flag == 1) {
			hsvbuf[1] = nvi < 2 ? NULL : (buffer + ibsize);
			hsvbuf[2] = nvi < 3 ? NULL : (buffer + 2 * ibsize);
			nzi = 1;
		} else {
			inbuf[1] = hsvbuf[1] = buffer + ( n * ibsize);
			inbuf[2] = hsvbuf[2] = nzi < 3 ? NULL : (buffer + 2 * n *ibsize);
			nvi = 1;
		}
		bufr = buff2;
		rgbbuf[0] = bufr;
		if(flg_out == O_C24) {
			rgbbuf[1] = bufg = bufr + ALIGN4(n);
			rgbbuf[2] = bufb = bufg + ALIGN4(n);
			incrgb = 1;
		} else {
			incrgb = 3;
			rgbbuf[1] = bufr + 1;
			rgbbuf[2] = bufr + 2;
		}
	} else if(flg_in != O_C3V) {
		if((flg_out == O_C24) || (flg_in == O_C24)) {
			bufr = buffer;
			bufg = bufr + ALIGN4(n);
			bufb = bufg + ALIGN4(n);
		}
		if((flg_in == O_C24) && (flg_out == O_C3V))
			buff2 = bufb + ALIGN4(n);
		else if((flg_in != O_C24) && (flg_out == O_C3V))
			buff2 = buffer + ALIGN4(n);
	} else if(flg_out == O_C24) {
		bufr = buffer;
		bufg = bufr + ALIGN4(n);
		n = nblig * lfmto[I_DIMX];
		bufb = bufg + ALIGN4(n);
	}
	if(flg_out == O_Q8) 
		buff2 = buffer + n1;
	inbuf[0] = buffer;
	outbuf[0] = buffer;
	if(flg_in == O_HSV) {
		outbuf[0] = buff2;
	} else if(flg_in == O_C24) {
		inbuf[0] = bufr;
		inbuf[1] = bufg;
		inbuf[2] = bufb;
		nbi = 3;
	}
	if(flg_out == O_C24) {
		outbuf[0] = bufr;
		outbuf[1] = bufg;
		outbuf[2] = bufb;
		nbo = 3;
	} else if(flg_out == O_C3V)
		outbuf[0] = buff2;
	else if (flg_out == O_Q8) {
		outbuf[0] = buff2;
		if((flg_in == O_C8) || (flg_in == O_BW))
			inbuf[0] = buff2;
	}
	while (nmax > 0) {
		if(nblig > nmax)
			nblig = nmax;
		nmax -= nblig;
		flag = (flg_in == O_HSV) ? 0x20 : 0;
		ecr_lect3(flag,nfi,iy,nbi,nblig,inbuf);
		switch(flg_in) {
		case O_BW:
			n = nblig * lfmti[I_DIMX];
			switch (flg_out) {
			case O_BW :
			case O_C8:
				if(nbtab >= 1)
					apply_1ct(buffer,buffer,n,*pc);
					break;
				
			case O_C24:
				bwc8_to_c24(buffer,bufr,bufg,bufb,n,pc);
				break;
			case O_C3V :
				bwc8_to_cvec(buffer,buff2,n,pc);
				break;
			case O_Q8:
				bwc8_to_cvec(buff2,buffer,n,pc);
				quantize(buffer,buff2,lfmto[I_DIMX],lfmto[I_DIMY],ncols,&newnc,flg_q,compr,compg,compb);
				break;

			}
			break;
		case O_C8:
			n = nblig * lfmti[I_DIMX];
			switch (flg_out) {
			case O_BW:
				c8_to_bw(buffer,buffer,n,pc);
				break;
			case O_C8:
				c24_to_c8(buffer,buffer,buffer,buffer,n,pc);
				break;
			case O_C24:
				bwc8_to_c24(buffer,bufr,bufg,bufb,n,pc);
				break;
			case O_C3V :
				bwc8_to_cvec(buffer,buff2,n,pc);
				break;
			case O_Q8:
				bwc8_to_cvec(buff2,buffer,n,pc);
				quantize(buffer,buff2,lfmto[I_DIMX],lfmto[I_DIMY],ncols,&newnc,flg_q,compr,compg,compb);
				break;
			}
			break;
		case O_C24:
			n = nblig * lfmti[I_DIMX];
			switch (flg_out) {
			case O_C8:
				c24_to_c8(bufr,bufg,bufb,buffer,n,pc);
				break;
			case O_BW:
				c24_to_bw(bufr,bufg,bufb,buffer,n,pc);
				break;
			case O_C3V:
				c24_to_cvec(bufr,bufg,bufb,buff2,n,pc);
				break;
			case O_Q8:
				imerror(9,"-q8 non disponible pour couleur 3 plans\n");
			}
			break;
		case O_C3V:
			n = nblig * lfmti[I_NDIMX];
			switch(flg_out) {
			case O_C8:
				cvec_to_c8(buffer,buffer,n,pc);
				break;
			case O_BW:
				cvec_to_bw(buffer,buffer,n,pc);
				break;
			case O_Q8:
				quantize(buffer,buff2,lfmto[I_DIMX],lfmto[I_DIMY],ncols,&newnc,flg_q,compr,compg,compb);
				break;
			case O_C24:
				cvec_to_c24(buffer,bufr,bufg,bufb,n,pc);
				break;
			}
			break;
		case O_HSV:
			n = nblig * lfmti[I_NDIMX];
			hsvtorgb8(n,hsvbuf[0],hsvbuf[1],hsvbuf[2],nvi,Hmax,rgbbuf[0],rgbbuf[1],rgbbuf[2],incrgb);
			switch(flg_out) {
			case O_C8:
				cvec_to_c8(buff2,buff2,n,pc);
				break;
			case O_BW:
				cvec_to_bw(buff2,buff2,n,pc);
				break;
			case O_Q8:
				imerror(9,"-q8 non disponible pour couleur 3 plans\n");
			}
			break;
		default:
			imerror(9,"scnvcol: unexpected switch case %d %d\n",flg_in,flg_out);
		}
		if(flg_out == O_Q8)
			iwr_ctrgb(*nfo,0,newnc,compr,compg,compb);
		ecr_lect3(1,nfo,iy,nbo,nblig,outbuf);
		iy += nblig;
	}
}


/* flag != 0 => ecr ,  | 0x20 si lecflt ou ecrflt */
static int ecr_lect3(flag,nf,iy,nbi,nbl,abuf)
register struct image **nf;
register iy, nbi, nbl;
char **abuf;
int flag;
{
	Fort_int lfmt[9];
	register i;
	c_getgfm(*nf,lfmt,0);
	for(i=0;i<nbi;i++) {
		c_lptset(nf[i],iy);
		if(flag & 1) {
			if(flag & 0x20) {
				c_ecrflt(nf[i],nbl,abuf[i]);
			} else {
				c_ecr(nf[i],nbl,abuf[i]);
			}
		} else {
			if(flag & 0x20) {
				c_lecflt(nf[i],nbl,abuf[i]);
			} else {
				c_lect(nf[i],nbl,abuf[i]);
			}
		}
		if(NDIMZ != 1)
			iy += NDIMY;
	}
}
