/*sfmed
===============================================================+
	subroutine sfmed(nom,nom1,idim,kdim)	
								!
===============================================================+
								!
	Programme d'appel de la routine filmed par exec		!
								!
	Parametres d'entree :					!
	--------------------					!
	- NOM     :   nom de l'image d'entree dont les valeurs  !
                     doivent etre comprises entre 0 et 1       !        
	- NOM1    :   nom de l'image de sortie 			!
	- IDIM    :   taille en X du filtre		          !
	- KDIM    :   taille en Y du filtre          !
								!
===============================================================+
*/

#include <inrimage/image.h>
extern int medfil_();

sfmed_(in,out,idim,kdim)
char *in, *out;
Fort_int *idim, *kdim;
{
	Fort_int lfmt[9];
	Fort_int ier;
	Fort_int ifixe, ivar[2];
	struct image *nfi, *nfo;
	int nbfix= 0, nbvar= 2;
	nfi = image_(in,"e"," ",lfmt);
	nfo = image_(out,"s","a",lfmt);
	if(TYPE != FIXE || BSIZE != 1)
		imerror(9,"images 8 bits seulement\n");
	ivar[0] = ivar[1] = 1;
	ifixe = *idim * *kdim;
	if(!(*idim & 1) || !(*kdim & 1))
		imerror(9,"les dimensions de la fenetre doivent etre impaires!\n");
	exec_(&ier,&nbfix,&ifixe,&nbvar,ivar,medfil_,&nfi,&nfo,lfmt,idim,kdim,&ier);
	return 0;
}
