C* AFFIN
	 SUBROUTINE AFFIN(B,C,N,IDIMX,NLIG,NCT,IPAS)
C   EFFECTUE UN AFFINAGE DU TABLEAU B (RES. DANS C) DE NLIG LIGNES
C      IDIMX POINTS, SELON LA DIRECTION INDIQUEE PAR NCT : 0=GAUCHE,
C      1=DROITE, 2=HAUT, 3=BAS
C  IPAS EST LE NUMERO DE LA PASSE
C   MET A JOUR N, LE NB DE MODIFS
	EXTERNAL BTEST
	 INTEGER B(1),C(1)
	 INTEGER*2 ICVX(14),ICVY(14),ICV(14)
	 LOGICAL  A(14),BTEST
	 LOGICAL K100,K001,K010,KX
	 DATA ICVX/1,1,0,-1,-1,-1,0,1,1,1,0,-1,-1,-1/
	 DATA ICV/0,-1,-1,-1,0,1,1,1,0,-1,-1,-1,0,1/
	DO 300 I=1,14
300    ICVY(I)=IDIMX*ICV(I)
	 ILG=NLIG-1
	 IFX=IDIMX-1
	 IF(NCT.EQ.0) IRT=0
	 IF(NCT.EQ.1) IRT=4
	 IF(NCT.EQ.2) IRT=6
	 IF(NCT.EQ.3) IRT=2
C
C      IRT=0  GAUCHE
C      IRT=2  BAS
C      IRT=4  DROIT
C      IRT=6  HAUT
C
	J0=5+IRT
	II1=ICVY(J0)+ICVX(J0)
	L1=0
	 DO 10 I=2,ILG
	L1=L1+IDIMX
	I1=L1+II1
	I0=L1
	 DO 10 J=2,IFX
	I0=I0+1
	I1=I1+1
C  SAUTER SI LE POINT COURANT EST A 0
	IF(.NOT.BTEST(B,I0)) GOTO 10
C   PAS D'ELIMINATION SI LE POINT PRECEDENT DANS LA MEME DIRECTION EST A
	IF(BTEST(B,I1)) GOTO 10
C
C ELIMINATION DES POINTS ISOLES (AU 1ER PASSAGE)
C
	IF(NCT.NE.0.OR.IPAS.NE.0) GOTO 21
	 ISOM=0
	 DO 20 M0=1,8
	I2=L1+ICVY(M0)+J+ICVX(M0)
	IF(BTEST(B,I2-1)) ISOM=ISOM+1
 20    CONTINUE
	 IF(ISOM.GT.0) GOTO 21
	CALL BCLR(C,I0)
	CALL BCLR(B,I0)
	 N=N+1
	 GOTO 10
C
21    I3=L1+J-1
C  CALCULER LA FONCTION A EN CHAQUE POINT DE LA FENETRE (TRUE SI POINT A
	 DO 30 M=1,8
	 A(M)=.FALSE.
	I2=I3+ICVY(M)+ICVX(M)
	IF(BTEST(B,I2)) A(M)=.TRUE.
 30    CONTINUE
C  RECOPIER UNE PARTIE DE A POUR LA PERMUTATION DES POINTS
	ITS=8
	 DO 100 IT=1,6
	 ITS=ITS+1
	 A(ITS)=A(IT)
 100   CONTINUE
	 J1=1+IRT
	 J2=J1+1
	 J3=J2+1
	 J4=J3+1
	 J5=J4+1
	 J6=J5+1
	 J7=J6+1
	 J8=J7+1
	K100=.NOT.A(J6).AND..NOT.A(J4).AND.(A(J2).OR.A(J8))
	K001=.NOT.A(J6).AND..NOT.A(J8).AND.(A(J2).OR.A(J4))
	K010=.NOT.A(J2).AND..NOT.A(J4).AND.(A(J6).OR.A(J8))
	 KX=(.NOT.A(J7).OR..NOT.A(J3)).AND.(A(J7).OR.A(J3))
	 IF(A(J1)) GOTO 31
	 IF(KX) GOTO 22
	 GOTO 10
22    IF(A(J7).OR..NOT.A(J3)) GOTO 24
	 IF(K001) GOTO 80
	 GOTO 10
24     IF(K010) GOTO 80
	 GOTO 10
31     IF(A(J7).OR.A(J3)) GOTO 41
	 IF(K100) GOTO 80
	 GOTO 10
41     IF(.NOT.A(J7).OR..NOT.A(J3)) GOTO 51
	 GOTO 80
 51    IF(A(J7).OR..NOT.A(J3)) GOTO 71
	 IF(.NOT.A(J6)) GOTO 80
	 GOTO 10
 71    IF(A(J4)) GOTO 10
80     CALL BCLR(C,I0)
	 N=N+1
 10    CONTINUE
	 RETURN
	 END
C
C
