#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>
#include <string.h>

unsigned char *anac_heap, *anac_imbuf;
struct iseg  *anac_iseg;
struct anac_info anac_info;
struct chn *anac_chn;
struct cont_desc *anac_desc;

int c_ancont(iseg,ifdm,ichn,idim,nf,lfmt)
struct iseg *iseg;
Fort_int *ifdm, *idim, *lfmt;
unsigned char *ichn;
struct image *nf;
{
	Fort_int lgl, ibs;
	register int nblig, n, i;
	int nseg1, nseg2, ntot, ny, ii0, y0, nmax;
	
	lgl = ligbit_(lfmt,&ibs);
	/*On essaie d'attribuer 1/10 mem pour image */
	n = *idim /10;
	nblig = (8 * sizeof(int4) * n) / lgl;
	if(nblig <= 0) nblig = 1;
	else if(nblig > anac_info.dy) nblig = anac_info.dy;
	anac_imbuf = ichn;
	anac_info.max_iseg = (sizeof(int4) * *ifdm / sizeof (struct iseg)) & ~1;
	n = ((nblig * lgl) + 7) / 8;
	n += buffer_align(ichn + n);
	anac_heap = ichn + n;
	anac_info.ix_chn = 0;
	anac_info.ix_cont_desc = (*idim * sizeof(int4) - n) & ~(sizeof(long) - 1);
	anac_info.ix0_desc = anac_info.ix_cont_desc;
	anac_info.ipvid = 0;
	anac_info.idesc_min = anac_info.ix0_desc;
	anac_info.ix_chn_max = 0;
	anac_info.num_max = 0;
	anac_info.tot_blocs = 0;
	anac_iseg = iseg;
	anac_desc = (struct cont_desc *)(anac_heap + anac_info.ix0_desc);
	anac_chn = (struct chn *) anac_heap;

	c_lptset(nf,anac_info.y0);
	for(i=0;i<anac_info.lg_bmap;i++)
		anac_info.bitmap[i] = 0;
	nseg1 = 0;nseg2 = 0;   /* nb de pts cont lignes i-1 et i */
	ntot = anac_info.dy;
	ny = 0;
	for(y0 = anac_info.y0;y0 < (anac_info.y0 + anac_info.dy);y0++) {
		if(ny <= 0) {
			if(nblig > ntot) nblig = ntot;
			c_lect(nf,nblig,ichn);
			ntot -= nblig;
			ny = nblig;
			ii0 = anac_info.x0 - 1;
		}
		ny--;
		nmax = anac_info.max_iseg - nseg1;
		c_chrseg(ichn,ii0,anac_iseg + nseg1,&nseg2,nmax);
		ii0 += lfmt[I_DIMX];
		if((nseg1 == 0) && (nseg2 == 0)) continue;
		c_anaseg(nseg1,nseg2,y0,anac_info.iconn);
		if(nseg2) {
			i = nseg2 * sizeof(struct iseg);
			memcpy(anac_iseg,anac_iseg + nseg1,i);
		}
		nseg1 = nseg2;
	}
	/* terminer derniere ligne */
	c_anaseg(nseg1,0,y0,anac_info.iconn);
	
	return 0;
}
