#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

static Fort_int er9= 9, er99= 99;

extern int debug_;
void wrindx(), skpind(), gomot(), putmot(), xread_indx(), xread();
void swap4buf(), swap2buf(), xwrit();

/* selectionne le secteur d'index pointant vers le contour de numero n
et renvoie l'adresse de son index dans fc_cont
si flag=1, et que le sect. n'existe pas, on le cree
retourne 0 si ok,
envoie en erreur sinon
*/
int go_indx(nfc,nc,flag)
register struct fc_cont *nfc;
int nc, flag;
{
register int num, i0, fd, ad, i;
int n, adw;
	fd = nfc->fc_fd;
	if((n = nc) == nfc->fc_num) return 1;
	if((n > nfc->c_nmax) && (flag != 1)) ermesf_(&er9);
	nfc->fc_numd = -1;
	n--;
	num = n / (NBINT4-2);	/* adr secteur index */
	i0 = n % (NBINT4-2);
	nfc->pt_datn = &nfc->fc_indx.i_pt[i0];
	if(num == nfc->n_ind) {		/* deja index courant */
		nfc->fc_num = nc;
		return 0;
	}
	if(num < nfc->c_nbsi) {	/* le secteur index existe deja */
		wrindx(nfc);	/* ecrire sect. courant si necessaire */
		if((n = num - nfc->n_ind) >= 0) { /* deplacement a effectuer */
			skpind(nfc,&nfc->fc_indx.i_next,n);
		} else {
			n = -n;
			if(n > num) { /* il vaut mieux commencer par debut */
				xread_indx(nfc,nfc->c_si1);
				nfc->s_ind = nfc->c_si1;
				skpind(nfc,&nfc->fc_indx.i_next,num);
			} else {
				skpind(nfc,&nfc->fc_indx.i_prev,n);
			}
		}
		nfc->n_ind = num;
		nfc->fc_num = nc;
		return 0;
	}
	/* creer nouveau secteur index */
	if(nfc->s_ind != (ad = nfc->c_sin)) {	/* relire dernier sect */
		wrindx(nfc);
		xread_indx(nfc,ad);
	}
	adw = nfc->c_nbs + 1;
	nfc->fc_indx.i_next = adw;
	nfc->flg_i = 1;
	nfc->s_ind = ad;
	wrindx(nfc);
	i = num - nfc->c_nbsi + 1;
	while (1) {
		z_buf(&nfc->fc_indx,NBINT4);
		nfc->fc_indx.i_prev = ad;
		i--;
		nfc->c_nbsi++;
		nfc->c_nbs++;
		if(i <= 0)
			break;
		ad = adw;
		nfc->fc_indx.i_next = adw + 1;
		xwrit(fd,&nfc->fc_indx,adw++);
		nfc->fc_nbwr++;
	}
	nfc->s_ind = nfc->c_sin = adw;
	nfc->flg_i = 1;
	nfc->flg_s0 = 1;
	nfc->n_ind = num;
	nfc->fc_num = nc;
	return 0;
}

	
/* ecrire sect. index si nec. */
void wrindx(nfc)
register struct fc_cont *nfc;
{
register int ad, fd;
	if(nfc->flg_i == 0) return;
	fd = nfc->fc_fd;
	if((ad = nfc->fc_nbwr) == nfc->s_dat) {
			xwrit(fd,nfc->fc_dat,ad);
			ad++;
			nfc->fc_nbwr++;
		}
	xwrit(fd,&nfc->fc_indx,nfc->s_ind);
	nfc->flg_i = 0;
	if(ad == nfc->s_ind) 
		nfc->fc_nbwr++;
}

/* sauter n secteurs d'index en se servant du pointeur donne (ptr)
*/
void skpind(nfc,ptr,n)
register int n, *ptr;
register struct fc_cont *nfc;
{
register int ad, fd;
	if(n < 0) ermesf_(&er99);
	if(n == 0) return;
	fd = nfc->fc_fd;
	while (n-- > 0) {
		if((ad = *ptr) == 0) ermesf_(&er9);
		xread(fd,&nfc->fc_indx,ad);
	}
	if( nfc->fc_swap_needed)
	  swap4buf(&nfc->fc_indx,sizeof(struct ct_indx)/4);
	nfc->s_ind = ad;
}

/* aller sur datas du contour courant :
renvoie 0 si non presente,
	1 si presente
	-1 si impossible (data contour avec param. non presents)
option 0 : si debut, 1 si debut autres param, 2 si debut contour
flag : 1 s'il faut creer la zone datas
*/

int go_dat(nfc,opt,flag)
int opt, flag;
register struct fc_cont *nfc;
{
register int4 pt, ad, n, *ph, nm;
union hdrdata hdrd[2];
struct hdrdn hdrdn;
register int x;
	ad = *nfc->pt_datn  >> 8;
	if(nfc->fc_typ) {
		nm = (sizeof (hdrdn)) >> 2;
		ph = (int4 *)&hdrdn;
	} else {
		nm = (sizeof (hdrd)) >> 2;
		ph = (int4 *)hdrd;
	}
	if(ad == 0) {	/* creer nouveau sect. data */
		if(flag == 0) return -1;
		nfc->fc_numx = nfc->fc_num;
		ad = nfc->c_fdat >> 8;
		pt = nfc->c_fdat & 0xff;
		if(pt >= NBINT4) {	/* new data */
			cr_newbd(nfc);
			pt = 2;
			ad = nfc->s_dat;
		} else {
			sw_bdat(nfc,ad);
			nfc->i_dat = --pt;
		}
		nfc->flg_i = 1;
		nfc->fc_numd = nfc->fc_num;
		nfc->ct_lgr = nfc->fc_flag = 0;
		nfc->ct_pos = 0;
		nfc->ct_loc = 1;
		z_buf(ph,nm);
		if(opt == 0) {
			*nfc->pt_datn = nfc->c_fdat;
			putmot(nfc,ph,nm);
			gomot(nfc,0);
			return 0;
		}
		if(opt == 2) return -1;
		if(opt == 1) {	/* init zone param */
			*nfc->pt_datn = nfc->c_fdat;
			putmot(nfc,ph,nm);
			gomot(nfc,nfc->fc_posp);
			nfc->ct_loc = 2;
			return -1;
		}
		return -1;
	}
	if(nfc->fc_numd == nfc->fc_num) {
		switch(opt) {
		case 0 :
			if(nfc->ct_loc != 1) break;
			if(nfc->fc_flag < 1) return 0;
			return 1;
		case 1 :
			if(nfc->ct_loc != 2) break;
			if(nfc->fc_flag < 1) return 0;
			return 1;
		case 2 :
			if(nfc->ct_loc < 2) break;
			if(nfc->fc_flag < 1) return -1;
			if(nfc->ct_loc <= 1) break;
			if(nfc->fc_flag == 1) {
				if(nfc->ct_loc != 2) break;
				return 0;
			} else {
				if(nfc->ct_loc != 3) break;
				return 1;
			}
		}
	}
	sw_bdat(nfc,ad);
	nfc->fc_numd = nfc->fc_num;
	nfc->i_dat = (*nfc->pt_datn & 0xff) - 1;
	nfc->ct_pos = 0;
	if(nfc->fc_typ) {
		nfc->ct_lgr = nfc->fc_dat[nfc->i_dat];
		if(nfc->fc_swap_needed) swap4(x,nfc->ct_lgr);
	} else {
		hdrd[0].d_l = nfc->fc_dat[nfc->i_dat];
		nfc->ct_lgr = hdrd[0].d1.d_lgr;
	}
	if(nfc->ct_lgr == 0) nfc->fc_flag = 0;
	else	nfc->fc_flag = 2;
	if(opt == 0) {
		nfc->ct_loc = 1;
		return 1;
	}
	if(opt < 0 || opt > 2) return -1;
	gomot(nfc,nfc->fc_posp);
	*ph =  getdat(nfc);
	if(nfc->fc_typ)
		n = *ph;
	else
		n = hdrd[0].d2.d_nbpar;
	if(opt == 1) {
		nfc->ct_loc = 2;
		if(n == 0) return 0;
		if(nfc->ct_lgr == 0) nfc->fc_flag = 1;
		return 1;
	}
	nfc->ct_loc = 0;
	if(nfc->ct_lgr > 0) {
		gomot(nfc,nfc->fc_posp2 + n);
		nfc->ct_loc = 3;
		return 1;
	}
	/* on ne peut aller vers datas, si on n'a pas ecrit les param. */
	if(n == 0) return -1;
	gomot(nfc,nfc->fc_posp2 + n);
	nfc->ct_loc = 3;
	return 0;
}

/* aller jusqu'au mot n du contour courant */
void gomot(nfc,n)
int n;
register struct fc_cont *nfc;
{
register int n1, nb;
	if(nfc->ct_pos < 0) ermesf_(&er9);
	if(n == nfc->ct_pos) return;
	nfc->ct_loc = 0;
	if(n < nfc->ct_pos)
		if(go_dat(nfc,0,0) != 1) ermesf_(&er9);
	n1 = n - nfc->ct_pos;
	nb = NBINT4 - nfc->i_dat;
	while ((n1 - nb) > 0) {
		nxt_bdat(nfc,0);
		n1 -= nb;
		nb = NBINT4 - 1;
	}
	nfc->ct_pos = n;
	nfc->i_dat += n1;
}

/* ecrit les n mots du tableau tab dans le contour courant
*/
void putmot(nfc,tab,n)
int n;
register int4 *tab;
register struct fc_cont *nfc;
{
  int i, n1, nb;
  int4 *pl;
	if(nfc->ct_pos < 0) ermesf_(&er9);
	nfc->ct_loc = 0;
	n1 = n;
	nb = NBINT4 - nfc->i_dat;
	while ((n1 - nb) > 0) {
		pl = &nfc->fc_dat[nfc->i_dat];
		for(i=0;i<nb;i++)
			*pl++ = *tab++;
		nfc->flg_d = 1;
		nxt_bdat(nfc,1);
		n1 -= nb;
		nb = NBINT4 - 1;
	}
	pl = &nfc->fc_dat[nfc->i_dat];
	for(i=0;i<n1;i++)
		*pl++ = *tab++;
	nfc->ct_pos += n;
	nfc->i_dat += n1;
	if((n1 > 0) && (nfc->fc_flag <= 2)) {
		nfc->flg_d = nfc->flg_s0 = 1;
		if(nfc->s_dat == (nfc->c_fdat >> 8))
			nfc->c_fdat = (nfc->c_fdat & 0xffffff00) + nfc->i_dat + 1;
	}
}
		
int getdat(nfc)
register struct fc_cont *nfc;
{
  register int x, y;
  if(nfc->i_dat >= NBINT4)
    nxt_bdat(nfc,0);
  y = nfc->fc_dat[nfc->i_dat];
  if(nfc->fc_swap_needed) swap4(x,y);
  return y;
}

/* lit n mots dans tableau tab dans le contour courant
*/
void gettab(nfc,tab,n)
int n;
register int4 *tab;
register struct fc_cont *nfc;
{
register int i, n1, nb;
register int4 *pl;
	if(nfc->ct_pos < 0) ermesf_(&er9);
	nfc->ct_loc = 0;
	n1 = n;
	nb = NBINT4 - nfc->i_dat;
	while ((n1 - nb) > 0) {
		pl = &nfc->fc_dat[nfc->i_dat];
		for(i=0;i<nb;i++)
			*tab++ = *pl++;
		nxt_bdat(nfc,0);
		n1 -= nb;
		nb = NBINT4 - 1;
	}
	pl = &nfc->fc_dat[nfc->i_dat];
	for(i=0;i<n1;i++)
		*tab++ = *pl++;
	nfc->ct_pos += n;
	nfc->i_dat += n1;
}

int nxt_bdat(nfc,flag)
register struct fc_cont *nfc;
int flag;
{
register int ad;
	if((ad = nfc->fc_dat[0]) == 0) { /* creer secteur suite */
		if(flag != 1) ermesf_(&er9);
		cr_newbd(nfc);
		return 0;
	}
	/*!! 	if(nfc->fc_swap_needed) swap4(x,ad);*/
	sw_bdat(nfc,ad);
	return 0;
}


cr_newbd(nfc)
register struct fc_cont *nfc;
{
register int ad, fd;
	fd = nfc->fc_fd;
	ad = nfc->c_fdat >> 8;
	sw_bdat(nfc,ad);
	if(nfc->s_ind == nfc->fc_nbwr) { /* faut-il ecrire bloc index? */
		xwrit(fd,&nfc->fc_indx,nfc->fc_nbwr);
		nfc->fc_nbwr++;
		nfc->flg_i = 0;
	}
	if(ad == nfc->fc_nbwr) nfc->fc_nbwr++;
	nfc->fc_dat[0] = nfc->fc_nbwr;
	xwrit(fd,nfc->fc_dat,ad);
	ad = nfc->fc_nbwr;
	nfc->s_dat = ad;
	nfc->fc_dat[0] = 0;
	nfc->c_nbs++;
	nfc->c_fdat = (ad << 8) + 2;
	nfc->i_dat = 1;
	nfc->flg_s0 = 1;
	nfc->flg_d = 1;
}



sw_bdat(nfc,ad)
register struct fc_cont *nfc;
register int4 ad;
{
  register int fd, adw, x;
  fd = nfc->fc_fd;
  if(ad != (adw = nfc->s_dat)) {
    if(nfc->flg_d) {
      if(adw == nfc->fc_nbwr)
	nfc->fc_nbwr++;
      nfc->flg_d = 0;
      xwrit(fd,nfc->fc_dat,adw);
    }
    xread(fd,nfc->fc_dat,ad);
    if(nfc->fc_swap_needed)
      swap4(x,nfc->fc_dat[0]);
    nfc->s_dat = ad;
    nfc->i_dat = 1;
  }
}

/*	***************
	z_buf(buf,nmots)
raz nmots mots de buf
*/
z_buf(buf,nmots)
register int4 nmots, *buf;
{
	while (nmots-- > 0)
		*buf++ = 0;
}

/* 
	nouveau bloc de data 
*/

ct_newbd(nfc)
register struct fc_cont *nfc;
{
	xwrit(nfc->fc_fd,nfc->fc_dat,nfc->s_dat);
	if(nfc->s_dat == (nfc->fc_nbwr - 1)) {
		nfc->s_dat++;
		nfc->fc_nbwr++;
		nfc->c_nbs++;
		nfc->c_fdat = (nfc->s_dat << 8) + 1;
	} else	ermesf_(&er9);
}


void xwrit(fd,buf,sect)
int fd, sect;
char *buf;
{
int er1= 1;

	if(lseek(fd,(off_t)(sect * NBYTE),0L) < 0) {
		if(debug_)
			fprintf(stderr,"write fichier contour : seek err %d\n",
				errno);
		ermesf_(&er1);
	}
	if(write(fd,buf,NBYTE) != NBYTE) {
		if(debug_)
			fprintf(stderr,"fichier contour : write err %d\n",
				errno);
		ermesf_(&er1);
	}
}


void xread_indx(nfc,n)
register struct fc_cont *nfc;
register int n;
{
  xread(nfc->fc_fd,&nfc->fc_indx,n);
  if(! nfc->fc_swap_needed) return;
  swap4buf(&nfc->fc_indx,sizeof(struct ct_indx)/4);
}

void xread(fd,buf,sect)
int fd, sect;
char *buf;
{
int er1= 1;
register int i;

	if((i = lseek(fd,(off_t)(sect * NBYTE),0L)) < 0) {
		if(debug_)
			fprintf(stderr,"read fichier contour : seek err (%d) %d\n",
				i,errno);
		ermesf_(&er1);
	}
	if((i = read(fd,buf,NBYTE)) != NBYTE) {
		if(debug_)
			fprintf(stderr,"fichier contour : read err %d (%d bytes)\n",
				errno,i);
		ermesf_(&er1);
	}
}

void swap4buf(buf,n)
register int4 *buf;
register n;
{
  register x;
  while(n-- > 0) {
    swap4(x,*buf);
    buf++;
  }
}
void swap2buf(buf,n)
register short *buf;
register n;
{
  register x;
  while(n-- > 0) {
    swap2(x,*buf);
    buf++;
  }
}
