#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

extern int koctet_;
/*
   c_newchn(pdesc,iext,isig)
iext: num enveloppe, isig : +- 1 selon sens
cree un nouveau contour
retour : ipdesc: indice +1 de descripteur de contour
*/
void c_newchn(ipdesc,iext,isig)
int *ipdesc;
int iext, isig;
{
	int nchn, k1, k2, idesc, i;
	struct chn *pchn;
	struct cont_desc *pdesc;
	if(! (nchn = tst_bitmap())) imerror(8,"Trop de contours : utiliser -maxc\n");
	if(nchn > anac_info.num_max) anac_info.num_max = nchn;

	idesc = anac_info.ix_cont_desc - sizeof(struct cont_desc);
	*ipdesc = (anac_info.ix0_desc - idesc) / sizeof(struct cont_desc);
	if((i = anac_info.ipvid) <= 0) {
		i = anac_info.ix_chn;
		if((i + 2 * sizeof(struct chn)) >= idesc)
			c_libchn();
	} else {
		pchn = (struct chn *)anac_heap + i -1;
		if(! pchn->inext) c_libchn();
	}
	anac_info.ix_cont_desc = idesc;
	if(idesc < anac_info.ix_chn) imerror(8,"pas assez de memoire (-k %d)\n",koctet_);
	k1 = c_gtbloc();
	k2 = c_gtbloc();
	set_bitmap(nchn,1);  /* marquer le cont. dans bitmap */
	pdesc = (struct cont_desc *) (anac_heap + idesc);
	pdesc->num = isig > 0 ? nchn : -nchn;
	pdesc->numext = iext;
	pdesc->p_bloc = k1;
	pdesc->d_bloc = k2;
	pdesc->surf = 0;
	pchn = anac_chn + k1 -1;
	pchn->ip0 = NBPTS_BLOC;
	pchn->inext = k2;
	pchn = anac_chn + k2 -1;
	pchn->ip0 = 1;
	pchn->inext = 0;
	if(idesc < anac_info.idesc_min) anac_info.idesc_min = idesc;
}
