#include <stdio.h>
#include <inrimage/image.h>
#include <inrimage/contour.h>

extern char *i_malloc(), *strchr();
static int getnb();

/* liste : string de la forme "1,3,5-7,10"
cmax: numero max (compte a partir de 1)
pct_select : adresse de la structure a remplir (pct_select->cnt_marks est realloue )
*/
void parse_ctselec(liste,cmax,pct_select)
char *liste;
register struct ct_select *pct_select;
{
	register n1, n2, nmax;
	register char *p1, *p2, *p3;
	register ix;
	char *p_marks;
	int minc, maxc;
	if(pct_select->cnt_marks != (char *)0) {
		i_Free(&pct_select->cnt_marks);
	}
	maxc = 0;
	minc = -1;
	pct_select->cnt_marks = p_marks = i_malloc(cmax);
	if(*liste == 0) {
		for(ix=0;ix<cmax;ix++)
			*(p_marks+ix) = 1;
		pct_select->cnt_min = 0;
		pct_select->cnt_max = cmax -1;
		return;
	}
	for(ix=0;ix<cmax;ix++)
		*(p_marks+ix) = 0;
	p1 = liste;
	while(1) {
		if((p2 = strchr(p1,',')) != NULL)
			*p2++ = 0;
		if(p1 == p2)
			break;
		n1 = getnb(p1) -1;
		if(minc < 0)
			minc = n1;
		if((p1 = strchr(p1,'-')) != NULL) {
			n2 = getnb(p1+1) -1;
		} else
			n2 = n1;
		if((n2 < n1) || (n1 < 0) || (n1 < maxc))
			imerror(9,"contour range error (must be in increasing order\n");
		maxc = n2;
		if(n1 < cmax) {
			if(n2 >= cmax)
				n2 = cmax -1;
			for(;n1<=n2;n1++)
				*(p_marks+n1) = 1;
		}
		if(p2 == NULL)
			break;
		p1 = p2;
	}
	pct_select->cnt_min = minc;
	pct_select->cnt_max = maxc;

}


static int getnb(s)
register char *s;
{
	register n, c;
	if((n = atoi(s)) <= 0)
		imerror(9,"page number error\n");
	
	while((c = *s++)) {
		if(c == '-')
			break;
		if(!isdigit(c))
			imerror(9,"syntax error in page range\n");
	}
	return n;
}

