/*
	iprinttb(a,lglig,nlig,iyi,izi,file,iform1,iform2,lgout,compactf,ibs,isig);

 impression sur fichier FILE, du tableau A de NLIG lignes de LGLIG
 points codes sur IBS octets. avec signe si ISIG > 0
 IYI, IZI : numero plan et 1e ligne (IZI == 0 si pas de plans)
 IFORM1 :  format pour printf d'une valeur
 IFORM2 :  format pour printf de la derniere valeur de la ligne d'impression
   dans ces 2 formats les caracteres speciaux doivent etre donnes par leur code
   et non par une sequence '\'
 LGOUT : nb max de valeurs par ligne d'impression
 COMPACTF != 0 => format  compact : sans num ligne ni plan si >0, avec num plans si < 0
*/

#include <stdio.h>

#define DOPR(type) {register type *p1; p1 = (type *)a;for(j=0;j<lglig;j++) { \
    k++; if(k >= lgout) {fprintf(file,iform2,*p1++);k=0;} else fprintf(file,iform1,*p1++);}}

iprinttb(a,lglig,nlig,iyi,izi,file,iform1,iform2,lgout,compactf,ibs,isig)
char *a;
int lglig, nlig, iyi, izi, ibs, isig;
register char *iform1, *iform2;
FILE *file;
int lgout, compactf;
{
	register lgl;
	register i, j, k;
	if(ibs < 0 || ibs > 4)
		imerror(9,"iprinttb: byte size incorrecte\n");
	if(ibs == 3)
		imerror(9,"iprinttb: byte size 3 not accepted\n");
	lgl = lglig * ibs;
	if(isig)
		ibs = -ibs;
	for(i=0;i<nlig;i++) {
		if(!compactf) {
			if(izi)
				fprintf(file,"plan %d, ligne %d\n",izi,iyi +i);
			else
				fprintf(file,"ligne %d\n",iyi +i);
		} else if((compactf < 0) && (i == 0) && izi)
			fprintf(file,"plan %d\n",izi);
		k = 0;
		switch(ibs) {
		case -1:
			DOPR(char);
			break;
		case -2:
			DOPR(short);
			break;
		case -4:
			DOPR(long);
			break;
		case 1:
			DOPR(unsigned char);
			break;
		case 2:
			DOPR(unsigned short);
			break;
		case 4:
			DOPR(unsigned long);
			break;
		}
		if(k > 0)
			fprintf(file,"\n");
		a += lgl;
	}
}
