/*
	ireadtb(a,nb,file,iform,ibs,isig);

 entree ascii sur fichier FILE, du tableau A de 
 NB points codes sur IBS octets. avec signe si ISIG > 0
 IFORM :  format pour scanf d'une valeur
   dans ce format les caracteres speciaux doivent etre donnes par leur code
   et non par une sequence '\'
*/

#include <stdio.h>
#include <errno.h>

extern int errno;

#define DORD(type) {register type *p1; p1 = (type *)a;for(j=0;j<nb;j++) { \
    if(fscanf(file,iform,&val) != 1) imerror(1,"ireadtb : data read error %d\n",errno); *p1++ = (type)val;}}

ireadtb(a,nb,file,iform,ibs,isig)
char *a;
int nb, ibs, isig;
register char *iform;
FILE *file;
{
	register j;
	int val;
	if(ibs < 0 || ibs > 4)
		imerror(9,"ireadtb: byte size incorrecte\n");
	if(ibs == 3)
		imerror(9,"ireadtb: byte size 3 not accepted\n");
	if(isig)
		ibs = -ibs;
	switch(ibs) {
	case -1:
		DORD(char);
		break;
	case -2:
		DORD(short);
		break;
	case -4:
		DORD(long);
		break;
	case 1:
		DORD(unsigned char);
		break;
	case 2:
		DORD(unsigned short);
		break;
	case 4:
		DORD(unsigned long);
		break;
	}
}
