/**
 * (c) 2007 Dominique Brziat
 */

/* donnes */
#define GVIS_TABLE   "gvis_table"
#define GVIS_INRGVIS "gvis_inrgvis"
#define GVIS_API     "gvis_api"
#define GVIS_PIXMAP  "gvis_pixmap"

/* widget */
#define GVIS_ROOT      "gvis_root"
#define GVIS_TOOLBAR   "gvis_toolbar"
#define GVIS_PAR       "gvis_par"
#define GVIS_IMAGE     "gvis_image"
#define GVIS_STATUSBAR "gvis_statusbar"
#define GVIS_NDIMZ     "gvis_ndimz"
#define GVIS_BASEZ     "gvis_basez"
#define GVIS_LOOPZ     "gvis_loopz"
#define GVIS_NDIMV     "gvis_ndimv"
#define GVIS_BASEV     "gvis_basev"
#define GVIS_LOOPV     "gvis_loopv"
#define GVIS_PREVI     "gvis_previ"
#define GVIS_NEXTI     "gvis_nexti"
#define GVIS_LOOPI     "gvis_loopi"

/*
 * macros d'accs aux donnes 
 */

/** table de haschage */
#define WINDOW_TABLE(widget) g_object_get_data(G_OBJECT(widget),GVIS_TABLE)
/** accs depuis la table de haschage */
#define TABLE_GET(table,key)   g_hash_table_lookup( (GHashTable *)(table),key)
/** accs depuis une fentre gvis (widget window) */
#define WINDOW_GET(widget,key) TABLE_GET(g_object_get_data(G_OBJECT(widget),GVIS_TABLE),key)
/** accs depuis un widget quelconque d'une fentre gvis */
#define WIDGET_GET(widget,key) WINDOW_GET(gtk_widget_get_toplevel(widget),key)
