/**
 * (c) 2007 Dominique Brziat
 */

/* valeurs pour inrdata.display */
#define DISP_GRAY    0
#define DISP_RGB     1
#define DISP_INDEXED 2
#define DISP_RGBA    3

struct inrgvis {
  char name[256];    /* nom de l'image sur le disque */
  int test;     

  Fort_int lfmt[9];  /* format et codage de l'image */
  uchar *buf;        /* tampon image (format cran) */
  int  display;      /* DISP_GRAY : tampon en niveau de gris, 
			DISP_RGB : tampon 24 bits 
		        DISP_INDEXED : tampon avec table couleur */
  short reorderv;    /* vaut TRUE si l'images est vectorielle et rordonne */
  short rgb3z;       /* vaut TRUE si l'image est RGB code en 3z : permet
		      * de diffrentier les 3z des 3v */
  short sln;         /* vaut TRUE si on a fait un lien symbolique (nom image illgal) */
  uchar tcol[256+4][4];/* table des couleurs (si display==DISP_INDEXED) */
  
  int iv;            /* composante affiche */
  int iz;            /* plan affich */
  int ix, iy, x, y;  /* zone d'intrt dans l'image 
		      * si x=y=0 pas de slection */
};



enum {
  BLUE = 0, GREEN, CYAN, RED, MAGNENTA, YELLOW, WHITE, BLACK
};

/* (prive ?) */
struct gvis {
#define OPT_XVIS_SCROLL  0x1
#define DRAW_PIXMAP      0x100
#define ZLOOP_IS_RUNNING 0x200
#define VLOOP_IS_RUNNING 0x400
  int flags;
  int roi_color;
  int zloop_time;
  int vloop_time;
};
