C* ARIG2
	SUBROUTINE ARIG2(A1,A2,NTABA,NF1,ISF1,NF2,ISF2,NFO,ISFO,
     %LFMT1,LFMT2,LFMTO,NTYP,NZ)
C  A1,A2= TABLEAUX D'ENTREE DES DEUX IMAGES
C  A1= TABLEAU  DE SORTIE
C  NZ=1 SI LE TABLEAU DE SORTIE EST PLUS PETIT OU EGAL AU TABLEAU A1
C    =0 SINON
C  NTABA= TAILLE DES TABLEAUX

C  NF1,ISF1= 1ERE IMAGE
C  NF2,ISF2= 2EME IMAGE
C   NFO,ISFO= IMAGE RESULTAT
C  LFMT1,LFMT2 LFMTO= PARAMETRES DES 3 IMAGES
C  NTYP= TYPE DE L'OPERATION ARITHMETIQUE
C  POUR FAIRE LES OPERATIONS ARITHMETIQUES, ON RAMENERA LES
C  MANTISSES A DES NOMBRES ENTIERS ET ON FERA DONC UN DECALAGE
C  DE L'EXPOSANT.
C  ARIG2 DETERMINE D'ABORD DES PARAMETRES DE L'OPERATION A L'AIDE
C  DE REXP (EXPOSANT,BIT SIZE DU RESULTAT,ET LE NOMBRE DE DECALAGES
C  A EFFECTUER SUR LES POINTS POUR EXCECUTER L'OPERATION) PUIS
C  EXECUTE L'OPERATION EN APPELANT LES SOUS-PROGRAMMES SETUP,LECTUR,
C  ARITIF, ECRITU. POUR EXECUTER ARITIF, IL DOIT D'ABORD 'DECONDEN-
C  SER' LES POINTS S'ILS SONT DE TYPE 'VIRGULE FIXE CONDENSES' A
C  L'AIDE DE UNPKBT. PUIS IL PREND UN POINT DE CHAQUE TABLEAU,
C  ECRIT CHACUN DANS UN MOT A L'AIDE DE PICBYT, FAIT L'OPERATION,
C  LE REMET DANS UN TROISIEME TABLEAU A L'AIDE DE INSBYT,ET AINSI
C  DE SUITE. SI NECESSAIRE IL 'CONDENSE' LES POINTS A L'AIDE DE
C  PACKB. PUIS IL APPELLE ECRITU.
	external btest
	DIMENSION NTABA(2),LFMT1(9),LFMT2(9),LFMTO(9)
	INTEGER A1(1),A2(1)
	INTEGER*2 ISF1,ISF2,ISFO
	INTEGER E1,E2,EO
	LOGICAL BTEST
C
C
C  DETERMINATION DE LA BIT SIZE DE CHAQUE IMAGE
	NB1=LFMT1(3)*8
	IF (LFMT1(3).LT.0) NB1=-LFMT1(3)
	NB2=LFMT2(3)*8
	IF (LFMT2(3).LT.0) NB2=-LFMT2(3)
	NO=LFMTO(3)*8
	IF (LFMTO(3).LT.0) NO=-LFMTO(3)
C
C  DETERMINATION DE NSIG1,NSIG2,NS
	NSIG1=0
	NSIG2=0
	NSIGO=0
	IF (LFMT1(9).LT.0) NSIG1=1
	IF (LFMT2(9).LT.0) NSIG2=1
	NS=IOR(NSIG1,NSIG2)
	IF((NSIG1.EQ.0).AND.(NB1.EQ.32)) CALL ERMESF(6)
	IF((NSIG2.EQ.0).AND.(NB2.EQ.32)) CALL ERMESF(6)
	IF((NS.EQ.1).OR.(NTYP.EQ.1)) NSIGO=1
C
C DANS LE CAS D'IMAGE SANS SIGNE,NB*S REPRESENTE LA BIT SIZE
C +UN BIT DE SIGNE (POUR AVOIR DES POINTS DE MEME NATURE DANS REXP)
	NB1S=NB1
	NB2S=NB2
	IF(NSIG1.EQ.0) NB1S=NB1S+1
	IF(NSIG2.EQ.0) NB2S=NB2S+1
C  NORMALISATION DES EXPOSANTS: PUISQUE LA MANTISSE EST CODEE ENTRE
C  -1 ET 1, IL FAUT SE RAMENER A UN NOMBRE ENTIER AFIN DE POUVOIR
C  EFFECTUER UNE OPERATION SUR DES ENTIERS
	E1=LFMT1(9)
	E2=LFMT2(9)
	IF (E1.LT.0) E1=-E1
	IF (E1.EQ.0) E1= 200
	IF (E2.LT.0) E2=-E2
	IF (E2.EQ.0) E2= 200
	E1=E1-NB1
	E2=E2-NB2
C
C  INITIALISATION DES DECALAGES
	ISH1=0
	ISH2=0
C
	CALL REXP(E1,E2,EO,NB1S,NB2S,NBO,ISH1,ISH2,NS,NTYP)
	IF(NSIGO.EQ.0) NBO=NBO-1
C MISE A JOUR DE L'EXPOSANT DU RESULTAT
	ISHO=NO-NBO
	LFMTO(9)=EO+NBO
	IF((LFMTO(9).GT.300).OR.(LFMTO(9).LT.100)) CALL ERMESF(14)
	IF(NSIGO.EQ.1) LFMTO(9)=-LFMTO(9)
	CALL FMTSET(NFO,LFMTO)
C
C  DETERMINATION DES PARAMETRES J1,J2,DE PICBYT ET DECAL
	J1=-1
	IF((NB1+ISH1).GT.0.AND.(NB1+ISH1).LT.32)J1=ISHFT(J1,NB1+ISH1)
	IF((NB1+ISH1).GE.32) J1=0
	J2=-1
	IF((NB2+ISH2).GT.0.AND.(NB2+ISH2).LT.32)J2=ISHFT(J2,NB2+ISH2)
	IF((NB2+ISH2).GE.32) J2=0
	J3=ISHFT(-1,NO-32)
C
C  DETERMINATION DES BYTES SIZES
	NBY1=(NB1+7)/8
	NBY2=(NB2+7)/8
	NBYO=(NO+7)/8
C
C  DETERMINATION DU NOMBRE DE LIGNES QUI TIENNENT DANS LES TABLEAUX A
	CALL SETUP(NTABA(2),LFMT2,NROW,NREST,NDIMA)
	IF (NROW.LE.0) CALL ERMESF(8)
	NCOUP=LFMT2(2)/NROW
10    KPT1=(NDIMA-1)*NBY1
	KPT2=(NDIMA-1)*NBY2
	KPTO=(NDIMA-1)*NBYO
C
C OPERATION POINT PAR POINT
	DO 40 ICOUP=1,NCOUP
	CALL LECT(NF1,NROW,A1)
	CALL LECT(NF2,NROW,A2)
	IF(LFMT1(4).EQ.-1) CALL UNPKBT(A1,A1,NDIMA,NB1)
	IF(LFMT2(4).EQ.-1) CALL UNPKBT(A2,A2,NDIMA,NB2)
	K1=0
	K2=0
	KO=0
	IF (NZ.EQ.1) GO TO 20
	K1=KPT1
	K2=KPT2
	KO=KPTO
20    DO 31 L=1,NDIMA
	IF((NS.EQ.0).AND.(NTYP.EQ.5)) GO TO 50
C  ON PREND NBY OCTETS SUCCESSIFS (UN POINT) DU TABLEAU A
C ET LES MET DANS I; PUIS EFFECTUE ISH DECALAGES SUR I AVEC
C APPROXIMATION SI C'EST UN DECALAGE VERS LA DROITE,ET COMPLEMENTE
C A GAUCHE PAR DES 1 SI LE POINT EST NEGATIF
C
	II=0
	DO 108 JJ=1,NBY1
	CALL ILBYTE(IV,A1,K1)
	II=IV+ISHFT(II,8)
	K1=K1+1
108    CONTINUE
	NS=32-NB1
	I1=ISHFT(II,ISH1)
	IF(ISH1.GE.0) GOTO 110
	IF(ISH1.LE.-32) GOTO 120
	IF((.NOT.BTEST(II,NS)).OR.(NSIG1.EQ.0)) GOTO 115
	I1=IOR(J1,I1)
115   IF(BTEST(II,32+ISH1)) I1=I1+1
	GOTO 120
110   IF((.NOT.BTEST(II,NS)).OR.(NSIG1.EQ.0)) GOTO 120
	I1=IOR(J1,I1)
120   II=0
	DO 109 JJ=1,NBY2
	CALL ILBYTE(IV,A2,K2)
	II=IV+ISHFT(II,8)
	K2=K2+1
109    CONTINUE
	NS=32-NB2
	I2=ISHFT(II,ISH2)
	IF(ISH2.GE.0) GOTO 210
	IF(ISH2.LE.-32) GOTO 25
	IF((.NOT.BTEST(II,NS)).OR.(NSIG2.EQ.0)) GOTO 215
	I2=IOR(J2,I2)
215   IF(BTEST(II,32+ISH2)) I2=I2+1
	GOTO 25
210   IF((.NOT.BTEST(II,NS)).OR.(NSIG2.EQ.0)) GOTO 25
	I2=IOR(J2,I2)
C    EFFECTUER L'OPERATION CHOISIE
25    GOTO (310,320,330,340,350,360),NTYP
C  ADDITION
310   I1=I1+I2
	GOTO 26
C  SOUSTRACTION
320   I1=I1-I2
	GOTO 26
C  MULTIPLICATION
330   I1=I1*I2
	GOTO 26
C  DIVISION
340   I1=I1/I2
	GOTO 26
C  MINIMUM
350   IF(I2.LT.I1) I1=I2
	GOTO 26
C  MAXIMUM
360   IF(I2.GT.I1) I1=I2
C  RANGEMENT RESULTAT
C  ON EFFECTUE D'ABORD ISH DECALAGES SUR I PUIS
C  ON PREND NBY OCTETS DE I ET LES MET DANS LE TABLEAU A
C  A PARTIR DU KIEME OCTET
 26   I1=IAND(J3,ISHFT(I1,ISHO))
	M=KO+NBYO-1
	DO 410 J=1,NBYO
	CALL ISBYTE(I1,A1,M)
	I1=ISHFT(I1,-8)
	M=M-1
410   CONTINUE
	KO=KO+NBYO
	IF (NZ.EQ.1) GO TO 31
	K1=K1-2*NBY1
	K2=K2-2*NBY2
	KO=KO-2*NBYO
31    CONTINUE
	IF(LFMTO(4).EQ.-1) CALL PCKBT(A1,A1,NDIMA,NO)
	CALL ECR(NFO,NROW,A1)
40    CONTINUE
	IF(NREST.EQ.0) RETURN
	NROW=NREST
	NREST=0
	NCOUP=1
	NDIMA=NROW*LFMT2(1)
	GO TO 10
	RETURN
C
C  CAS DU MINIMUM SANS SIGNE
50    NK=-1
	I1=0
	DO 501 J=1,NBY1
	CALL ILBYTE(IV,A1,K1)
	I1=IV+ISHFT(I1,8)
501   K1=K1+1
	I2=0
	DO 502 J=1,NBY2
	CALL ILBYTE(IV,A2,K2)
	I2=IV+ISHFT(I2,8)
502   K2=K2+1
	IF(ISH1.NE.0) GO TO 70
	IF(ISH2.NE.0) GO TO 60
	GO TO 25
60    NK=ISHFT(NK,31-ISH2)
	IF(IAND(I2,NK).NE.0) GO TO26
	I2=ISHFT(I2,ISH2)
	GO TO 25
70    NK=ISHFT(NK,31-ISH1)
	IF(IAND(I1,NK).EQ.0) GO TO 71
	I1=I2
	GO TO26
71    I1=ISHFT(I1,ISH1)
	GO TO 25
	END
