/* calcul des extremas et eventuellement de la moyenne d'une image
copie input converti en flottant sur output si nfo non nul et  different de nfi
on ne calcule la moyenne que si calc_moy est non nul
 */

#include <stdio.h>
#include <inrimage/image.h>


calparg_(buf,dim,nfi,nfo,calc_moy,min,max,moyenne)

float *buf,*moyenne,*max,*min;
Fort_int *dim, *calc_moy;
struct image **nfi, **nfo;
{
	int flgcp;
	Fort_int lfmt[9];
	Fort_int nrow, lnrow,nb_pixels;
	int i, j, nb, ntot;
	register float *fin_buf,*p,temp,r_max,r_min,r_somme;
	int init = 1;


	cpyfmg_(nfi,lfmt);
	TYPE = REELLE;
	BSIZE = sizeof(float);

	setup_(dim,lfmt,&nrow,&lnrow,&nb_pixels);
	*moyenne = 0.;
	flgcp = 0;
	if((nfo != (struct image **)0) && (*nfo != *nfi)) {
		flgcp = 1;
		
	}
	i = DIMY;
	ntot = DIMX * DIMY;
	nb = nrow * DIMX;
	while (i > 0) {
		c_lecflt(*nfi,nrow,buf);
		if(init) { /* c'est la premiere ligne */

			r_max = *buf;
			r_min = *buf;
			init = 0;
		}
		r_somme = 0. ;  /* la somme est locale a chaque lecture */
		p = buf;
		j = nb;
		if(! *calc_moy) {
			while(j-- > 0) {
				if((temp = *p++) > r_max) r_max = temp;
				else if(temp < r_min) r_min = temp;
			}
		} else { /* avec calcul moyenne */
			
			while(j-- > 0) {
				r_somme += (temp = *p++);
				if(temp > r_max) r_max = temp;
				else if(temp < r_min) r_min = temp;
			}
			*moyenne += r_somme / ntot;
		}
		if(flgcp)
			c_ecrflt(*nfo,nrow,buf);
		i -= nrow;
		if(i < nrow) {
			nrow = i;
			nb = nrow * DIMX;
		}
	}
	*min = r_min;
	*max = r_max;
}
