C* CHOIX
	SUBROUTINE CHOIX(M1,M2,L1,L2,NMEM,IRES)
C CE PROGRAMME EFFECTUE LE CHOIX DE LA METHODE DE FILTRAGE LA
C PLUS RAPIDE APRES UNE ESTIMATION DES DIVERS TEMPS DE MISE EN
C OEUVRE. IL SUPPOSE DE TRAVAILLER SUR UN PERKIN ELMER 34.40
C IL EXISTE UN AUTRE PROGRAMME DE CHOIX DANS LE CAS D UN
C TRAVAIL AVEC UN ARRAY PROCESSEUR
C M1,M2 SONT LES DIMENSIONS DE L IMAGE D ENTREE (DIMX ET DIMY)
C L1,L2 --------------------DU NOYAU DE CONVOLUTION(--- ---)
C NMEM DESIGNE LA TAILLE MEMOIRE DISPONIBLE POUR EFFECTUER
C LA CONVOLUTION.
C IRES DESIGNE LA MISE EN OEUVRE LA PLUS RAPIDE
C      IRES=1 METHODE DIRECTE
C      IRES=2 ------ SPECTRALE
C        IRES=3 ------- BLOCS OPTIMISES
C
	 TDIR=1.E10
	 TSPEC=1.E10
	 TBLOC=1.E10
	 TREC2=1.E10
	 TREC3=1.E10
	 TREC4=1.E10
	 TREC5=1.E10
	 TREC6=1.E10
	 TREC7=1.E10
	 TREC8=1.E10
	 TREC9=1.E10
	TACC=.035
	TTRANS=.000004
	NL=NMEM/M1
	NL1=NL-L2+1
	NACD=M2/NL1
	IF(NACD*NL1.NE.M2)NACD=NACD+1
	NL2=NL-5+1
	NRE1=M2/NL2
	IF(NRE1*NL2.NE.M2)NRE1=NRE1+1
	NL3=NL/2
	NRE2=M2/NL3
	IF(NRE2*NL3.NE.M2)NRE2=NRE2+1
	M1L=M1+L1-1
	M2L=M2+L2-1
	M3L=MAX0(M1L,M2L)
	II=0
	ICAR=1
	DO 1 I=1,15
	IF(ICAR.GE.M3L)GOTO 2
	II=I
	ICAR=ICAR*2
1     CONTINUE
2     M11=ICAR
	M12=M11
	IN=II
	NL11=NMEM/M11
	NL22=NMEM/(2*M11)
	 NL33=NMEM/(M1+M11)
	ICAR=1
	JJ=0
	DO 3 I=1,15
	IF(ICAR.GT.NL11)GOTO 4
	ICAR=ICAR*2
	JJ=I
3     CONTINUE
4     JJ=JJ-1
	IF(NMEM.LT.M1*L2)CALL OUTSTR(0,'PAS DE PLACE MEMOIRE SUFFISANTE PO
     %UR UNE MISE EN OEUVRE DIRECTE.$')
	IF(NMEM.LT.M1*L2)GOTO 5
	TDIR=.000012*M1*M2*L1*L2+2*NACD*TACC+2*M1*M2*TTRANS
5     IF(NMEM.LT.10*M1)CALL OUTSTR(0,'PAS DE PLACE MEMOIRE SUFFISANTE PO
     $UR UNE MISE EN OEUVRE RECCURENTE$')
	IF(NMEM.LT.10*M1)GOTO 6
	TRECIO=6*M1*M2*TTRANS+4*NRE1*TACC+3*NRE2*TACC
	TREC2=TRECIO+M1*M2*.000412
	TREC3=TRECIO+M1*M2*.000702
	TREC4=TRECIO+M1*M2*.00109
	TREC5=TRECIO+M1*M2*.00154
	TREC6=TRECIO+M1*M2*.00210
	TREC7=TRECIO+M1*M2*.00273
	TREC8=TRECIO+M1*M2*.00351
	TREC9=TRECIO+M1*M2*.00450
6     IF(NMEM.LT.2*M11)CALL OUTSTR(0,'PAS DE PLACE MEMOIRE SUFFISANTE PO
     $UR UNE MISE EN OEUVRE SPECTRALE$')
	 IF(NMEM.LT.2*M11)GOTO 988
	NS1=M12/NL11
	IF(NS1*NL11.NE.M12)NS1=NS1+1
	NS2=M2/NL33
	IF(NS2*NL33.NE.M2)NS2=NS2+1
	NS3=M12/NL22
	IF(NS3*NL22.NE.M12)NS3=NS3+1
	NS4=M2/NL11
	IF(NS4*NL11.NE.M2)NS4=NS4+1
	  IFG=IN-JJ+2
	  IF(IN-JJ+2.LT.0)IFG=0
	NS5=2**(IN-JJ+1)+(IN-JJ)*((2**(IFG)))
	 TRAZ=(M11*M12)*TTRANS+NS1*TACC
	 TMEL=(M1*M2+2*M11*M2)*TTRANS+3*NS2*TACC
	 TCEN=2*M11*M12*TTRANS+2*NS3*TACC
	 TEXT=(M2*M11+M2*M1)*TTRANS+2*NS4*TACC
	 TDFTD=7*M11*M12*TTRANS+7*NS3*TACC
	 TDFTI=8*M11*M12*TTRANS+8*NS3*TACC
	 TMULC=18*M11*M12*TTRANS+18*NS3*TACC
	TRSPOS=(2**(IN-JJ+1)+(IN-JJ)*((2**(IFG))))*TACC+2*M11*M12*TTRANS
	 TSPIO=2*TRAZ+2*TMEL+TCEN+2*TDFTD+TDFTI+6*TRSPOS+TMULC+TEXT
	IF(M11.EQ.32)TSPEC=TSPIO+1
	IF(M11.EQ.64)TSPEC=TSPIO+4
	IF(M11.EQ.128)TSPEC=TSPIO+20
	IF(M11.EQ.256)TSPEC=TSPIO+85
	IF(M11.EQ.512)TSPEC=TSPIO+368
	IF(M11.LE.16)TSPEC=TSPIO
988   CALL PCAPOP(M1,M2,L1,L2,NMEM,ITN1,ITN2,ITIB,ITIBB,K3KL,TFG,TSX
     $,TTCF,TBLOC)
	IF(TBLOC.LE.TSPEC)AMIN=TBLOC
	IF(TSPEC.LE.TBLOC)AMIN=TSPEC
	IF(TDIR.LE.AMIN)AMIN=TDIR
	IRES=10
	 IF(AMIN.EQ.1E10) RETURN
	IF(AMIN.EQ.TDIR)CALL OUTSTR(1,'LA CONVOLUTION EST EFFECTUEE PAR
     $LA METHODE DIRECTE $')
	IF(AMIN.EQ.TDIR)IRES=1
	IF(AMIN.EQ.TSPEC)CALL OUTSTR(1,'LA CONVOLUTION EST EFFECTUEE PAR 
     $LA METHODE SPECTRALE $')
	IF(AMIN.EQ.TSPEC)IRES=2
	IF(AMIN.EQ.TBLOC)CALL OUTSTR(1,'LA CONVOLUTION EST EFFECTUEE PAR 
     $LA METHODE DES BLOCS OPTIMISES$')
	IF(AMIN.EQ.TBLOC)IRES=3
	CALL OUTSTR(0,'$')
	RETURN
	END
C
