C* DOD2FF
	SUBROUTINE DOD2FF(A1,A2,FORWAR,NZIP,N2POW,NFOR,ISFOR,NFOI,ISFOI
     :,I,TRNF,TRSF,TINF,TISF,NRW,NDIMA,IFMT,SC)
C  EFFECTUE LA FFT SUR NRW LIGNES D'UNE IMAGE COMPLEXE
C  TRNF,TRSF (PARTIE REELLE) , TINF,TISF (PARTIE IMAGINAIRE)
C  RESULTAT DANS IMAGES NFOR,ISFOR ET NFOI,ISFOI.
C  A1,A2 TABLEAUX DE TRAVAIL (PARTIES REELLE ET IMAG.) DE NDIMA valeurs
C  I=1 SI FFT SUR LIGNES IMAGES ORIGINALE, I=2 SI FFT LIGNES
C    IMAGE TRANSPOSEE (FFT COLONNES)
C  N2POW=PUISS DE 2 DE LA DIM (IMAGE N**2 SUR N**2)
C  NZIP=.TRUE. SI ENTREE COMPLEXE, .FALSE. SI ENTREE REELLE
C   (NFII,ISFII IGNORE)
C   FORWAR=.TRUE. SI FFT DIRECTE, .FALSE. SI FFT INVERSE
C  SC=COEF DIVISEUR DU RESULTAT SI FFT INVERSE ET DANS
C  LA PASSE 2 (I=2) (SC=DIMX*DIMY)
C  IFMT=FORMAT IMAGE, NRW=NB LIGNES EN MEMOIRE
	DIMENSION A1(1),A2(1)
	DIMENSION IFMT(4)
	INTEGER*2 TISF,TRSF,ISFOR,ISFOI
	INTEGER TRNF,TINF,PNT,PDX
	LOGICAL FORWAR,NZIP
	PNT=LPTGET(TRNF)
	PDX=IFMT(1)
	CALL lecflt(TRNF,NRW,A1)
	IF (NZIP) GO TO 2
	CALL ZCOREF(A2,NDIMA)
	GO TO 3
2     CALL lecflt(TINF,NRW,A2)
	IF (FORWAR.OR.I.EQ.2) GO TO 3
	CALL NEGATE(A2,NDIMA)
3     CONTINUE
	  CALL FRXMUL(NRW,N2POW,A1(1),A2(1))
	IF (FORWAR.OR.I.EQ.1) GO TO 4
	CALL NEGATE(A2,NDIMA)
	CALL ISCALE(A1,NDIMA,SC)
	CALL ISCALE(A2,NDIMA,SC)
4     CALL LPTSET(NFOR,PNT)
	CALL LPTSET(NFOI,PNT)
	CALL ECR(NFOR,NRW,A1)
	CALL ECR(NFOI,NRW,A2)
	RETURN
	END
