/* EXTIM
	SUBROUTINE EXTIMG(A,NDIM,NFI,NFO,IXI,IYI,IZI)
	extimg_(a,ndim,nfi,nfo,ixi,iyi,izi)
   extrait, a l'aide du tableau a de ndim mots, un sous-ensemble
 de l'image nfi, commencant au point ixi,iyi,izi , et le transfere
  sur l'image nfo
 la taille de l'extraction est celle de l'image de sortie
 les 2 images doivent etre de type identique et de dim. compatibles
  tous les types sont acceptes
*/
#include <inrimage/image.h>
static Fort_int un= 1;
static Fort_int lfmti[9], lfmto[9];
extimg_(a,ndim,nfi,nfo,ixi,iyi,izi)
unsigned char *a;
struct image **nfi, **nfo;
Fort_int *ndim, *ixi, *iyi, *izi;
{
	register n, i;
	Fort_int ibs, nl;
	int lgl, nlig;
	register ay;
	c_getgfm(*nfi,lfmti,0);
	c_getgfm(*nfo,lfmto,0);
	if((*ixi <= 0) || (*iyi <= 0) || (*izi <= 0))
		imerror(9,"window origin coord. must be >= 1\n");
	if(*ixi + lfmto[I_DIMX] -1 > lfmti[I_DIMX]
	   || *iyi + lfmto[I_NDIMY] -1 > lfmti[I_NDIMY]
	   || *izi + lfmto[I_NDIMZ] -1 > lfmti[I_NDIMZ])
		imerror(7,"dimensions des images incompatibles\n");
	if(lfmti[I_TYPE] != lfmto[I_TYPE] || lfmti[I_BSIZE] != lfmto[I_BSIZE])
		imerror(6,"codages des images incompatibles\n");
	ibs = lfmti[I_BSIZE];
	if(ibs < 0)
		ibs = -ibs;
	else
		ibs *= 8;
	if(lfmti[I_TYPE] >= 0)
		ibs = 8 * ((ibs + 7) / 8);
	lgl = ibs * lfmti[I_DIMX];
	nlig = (8 * *ndim * sizeof(t_aligned)) / lgl;
	if(nlig <= 0)
		imerror(8,"pas assez de memoire : utiliser option -k\n");
	if(nlig > lfmto[I_NDIMY])
		nlig = lfmto[I_NDIMY];
	ay = *iyi  + (*izi - 1) * lfmti[I_NDIMY];
	c_lptset(*nfo,1);
	for(i=0;i<lfmto[I_NDIMZ];i++) {
		c_lptset(*nfi,ay);
		ay += lfmti[I_NDIMY];
		n = lfmto[I_NDIMY];
		nl = (Fort_int)nlig;
		while(n > 0) {
			if(nl > n) nl = n;
			c_lect(*nfi,nl,a);
			trtblb_(a,&lfmti[I_DIMX],ixi,a,&lfmto[I_DIMX],&un,&lfmto[I_DIMX],&nl,&ibs);
			c_ecr(*nfo,(int)nl,a);
			n -= nl;
		}
	}
}
