/* modification du format d'une image , avec recopie sur stdout en cas de filtre 
c-a-d si *nf != *nfo
Le nouveau format est donne dans gfmt
*/

#include <stdio.h>
#include <errno.h>
#include <inrimage/image.h>

extern debug_;


newfmt_(buf,dim,nf,nfo,gfmt)
int *buf;
Fort_int *dim;
struct image **nf, **nfo;
struct nf_fmt *gfmt;
{
	int i, n;
	int ntot;
	
	if ( *nfo != *nf) {	/* fmt est utilise en filtre */

		ntot = *dim * sizeof(t_aligned );
		if(!((*nfo)->hdr_stat & HST_HISTSET))
			(*nfo)->hdr_stat |= HST_HIST2SET;
		wr_imdesc(*nfo);
		while(1) {
			if((i = read((*nf)->fd,buf,ntot)) == 0) break;
			if(i < 0) {
				imerror(1,"read error %d\n",errno);
			}
			if(debug_)
				fprintf(stderr,"Copying %d bytes\n",i);
			if((n = write((*nfo)->fd,buf,i)) != i)
				imerror(1,"write err (%d bytes out of %d), errno %d\n",n,i,errno);
		}
		fermnf_(nfo);
	} else {	/* on modifie simplement le format */
		
		gfmset_(nf,gfmt);
		
	}
	fermnf_(nf);   /* pour etre sur d'ecrire le header */

}
