C* PEFFT
	SUBROUTINE PEFFT(A,NMAX,N2,N1,L1,
     $KK,KA,NDEF,JUL)
C CE PROGRAMME EFFECTUE LA 2D FFT DIRECTE D UN BLOCS COMPLEXE DE
C 2*N1*N2 POINTS RANGES DANS UN TABLEAU A DE DIMENSION MAX NMAX
C EN N1*N2 POINTS COMPOSANT LA PARTIE REELLE ET DE N1*N2 POINTS
C SUIVANTS COMPOSANTS LA PARTIE IMAGINAIRE
C LE BLOC EST SUPPOSE RANGE LIGNE PAR LIGNE
C DANS LE TABLEAU A A PARTIR DE A((KK-1)*JUL+KA*NDEF)
C LES PARTIES REELLES ET IMAGINAIRES FORMENT 2 BLOCS DE N1 POINTS
C PAR LIGNES ET DE N2 COLONNES
	DIMENSION A(NMAX)
	IV1=(KK-1)*JUL+KA*NDEF
	IV2=IV1+N1*N2
	L9=IPOWER(N1)
	L8=IPOWER(N2)
C
C   FFT DES LIGNES DU BLOC COMPLEXE
C
	  CALL FRXMUL(N2,L9,A(1+IV1),A(IV2+1))
C
C   FFT DES COLONNES DU BLOC COMPLEXE
C
	  CALL FFTMUL(N1,L8,A(IV1+1),A(1+IV2),N1)
	RETURN
	END
