#include <inrimage/image.h>

/* T4INIT
	SUBROUTINE T4INIT(KSIZE,IEFF,IBUF)
	c_t4init(ksize,ieff,ibuf)

  ***************
  * erase=esc,ff ('1b0c'), copy=esc,etb ('1b17')
  * mode alpha=us ('1f'), graph=gs ('1d')
  * crosshair=esc,sub ('1b1a') entree 1car= lecture 5 car (1 car frappe
  *    2 car x, 2 car y (bits 3 a 7)
  * tailles 1,2,3,4=esc+; ('3b'), : ('3a'), 9 ('39'), 8 ('38')
  * vecteurs : normaux =esc` ('1b60'), pointilles=esca('1b61'),
  *     mixtes=escb ('1b62'), tirets courts=escc ('1b63'),
  *      tirets longs=escd ('1b64')
  initialisation tektro : effacement si ieff non =0
  definit le buffer et sa taille ksize (nb octets) si ieff=0
  mode non bufferise si ksize<=0
  pour ieff=0, le programme assigne la tektro (par appel a asstek)

 pour avoir un hardcopy sur plotter hp
 modif p. cipiere 3/11/83
*/
extern struct unites unites_;
extern struct tktrnx tktrnx_;

t4init_(ksize,ieff,ibuf)
Fort_int *ksize, *ieff;
char *ibuf;
{
	hpinit_(ksize,ieff,ibuf);
	c_t4init((int)*ksize,(int)*ieff,ibuf);
}

#define A4WIDTH 594

c_t4init(ksize,ieff,ibuf)
int ksize, ieff;
char *ibuf;
{
	int xymin[2], xymax[2];
	float sc;
	if(ieff != 0)  { /* effacement seul */
		t4effa_();
		return 1 /* makes c99 happy */; 
	}
	asstek_();
	if(tktrnx_.tk_psmode) {
		xymin[0] = xymin[1] = 0;
		xymax[0] = xymax[1] = A4WIDTH;
		ps_prologue(1,xymin,xymax);
		ps_tekinit((float)A4WIDTH,(float)A4WIDTH,&sc);
	}
	tktrnx_.tkbuf = (char *)0;
	tktrnx_.tkoff = 0;
	if((tktrnx_.tksize = ksize) <= 0) return 1 /* makes c99 happy */; 
	tktrnx_.tkbuf = ibuf;
}
