/* T4SEND
	SUBROUTINE T4SEND(IBUF,I0,N)
c  envoie sur tektro n caracteres a partir de i0 dans ibuf
c  en mode bufferise ou non

	c_t4send(data,n);
	envoie les n caracteres de data sur tektro
*/
#include <inrimage/image.h>

extern struct tktrnx tktrnx_;
static char c;

t4send_(buf,i0,n)
register char *buf;
register Fort_int *i0, *n;
{
	c_t4send(buf+ ((int)*i0-1),(int)*n);
}

c_t4send(dat,n)
register char *dat;
register n;
{
	register char *pb;
	register nb, nres, i;
	if(n <= 0) return 1 /* makes c99 happy */; 
	if(tktrnx_.tksize > 0) {  /* mode bufferise */
		nres = tktrnx_.tksize - tktrnx_.tkoff;
		pb = tktrnx_.tkbuf + tktrnx_.tkoff;
		while (n > 0) {
			nb = nres > n ? n : nres;
			for(i=0;i<nb;i++)
				*pb++ = *dat++;
			if((nres -= nb) <= 0) {
				t4dspl_();
				nres = tktrnx_.tksize;
				pb = tktrnx_.tkbuf;
			}
			n -= nb;
		}
		tktrnx_.tkoff = tktrnx_.tksize - nres;
		return 1 /* makes c99 happy */; 
	}
	/*  mode non bufferise */
	while(n-- > 0)
		c_t4es(dat++,1,1);
}

