
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <inrimage/image.h>
#include <string.h>

static char lock[]="/usr/spool/devlck/LCK..xxxxxxxxxx";

#define OK 0
#define EXCL 1
#define LOCK 2
#define ERR -1

icklck_(nom,data0)	/* test si nom est de type /dev/xx
	si oui, teste s'il y a un lockfile
	et remplit data avec uid et ctime du fichier lock
	retour 0 si assgn interdit, 1 si pas de lock, 2 si lock utilisateur */
char nom[];
Fort_int data0[2];
{
	int uid;
	int data[2];
	data[0] = (int)data0[0];
	data[1] = (int)data0[1];
	/* preparer le nom du fichier lock */
	if(nom[0] == '/' && nom[4] == '/' &&
	  nom[1] == 'd' && nom[2] == 'e' && nom[3] == 'v') {
		strncpy(&lock[23],&nom[5],10);
		uid=getuid();
		return chklck(lock,uid,data);
	} else  return 1;
}

	
chklck(lck,uid,data) /* renvoie 0 si lock incompatible avec uid,
		1 si pas de lock, 2 si lock par uid */
int uid, data[2];
char *lck;
{
	struct stat buf;
	if(stat(lck,&buf) < 0) return 1;
	data[0] = buf.st_uid;
	data[1] = buf.st_ctime;
	if(data[0] != uid) return 0;
	else return 2;
}
	
prtlck_(data0)	/* imprime par outstr, le nom de l'utilisateur
			et la date de lock */
Fort_int data0[2];
{
	struct passwd *getpwuid();
	struct tm *tm, *localtime();
	char *pass, buf[36];
	int data[2];
	Fort_int icrlf = 1;
	data[0] = (int)data0[0];
	data[1] = (int)data0[1];

	if(data[0] < 0) return 1 /* makes c99 happy */; 
	if((pass = getpwuid(data[0])->pw_name) == 0) return 1 /* makes c99 happy */; 
	outstr_(&icrlf,pass);
	outstr_(&icrlf," , le $");
	tm = localtime(&data[1]);
	frenchdate(tm,buf);
	outstr_(&icrlf,buf);
}
