/* test d'accessibilite d'un fichier image en lecture 
	avec test de validite (par verification du fdescripteur) */

/* on retourne :
	3 si le fichier existe et que son descripteur est correct
		et compatible avec sa taille ou si '<'
	0 si le fichier n'existe pas ou si '>'
	1 le fichier existe mais son descripteur est incorrect
	2 le fichier existe avec un bon descripteur, mais taille trop petite
*/

#include <inrimage/inrfile.h>
#include <sys/types.h>

struct descripteur desc0_;
int imchek_(file)
char file[];
{
	int fd;
	off_t taille;
	if ( file[0] == '<' ) return(3);
	if ( file[0] == '>' ) return(0);

	if ( ( access(file,4) ) == -1 ) return(0);
	if ((fd=open(file,0)) <= 0) return 0;
	if((taille = lseek(fd,(off_t)0,2)) < 0) return (3);  /* cas de pipe */
	lseek(fd,(off_t)0,0);	/* se remettre au debut */
	if(read(fd,&desc0_,DESC) < DESC) return 1;
	switch (i3desc_test(&desc0_,taille)) {
		case 0 : return (3);
		case 1 : return 2;
		case 2 : return 1;
		default : return 0;
	}
}
