/*
  SUBROUTINE NFINFO(NF,LFMT,XFMT)
obtient toute l'info utile de la structure NF
LFMT(9) : contiendra le format habituel
XFMT(8) : infos complementaires
XFMT(1) : nb de bits par ligne
XFMT(2) : nb de bytes par ligne sur fichier (avec padding : XFMT(1) arrondi a l'octet sup.
XFMT(3) : type de flottant (voir image.h)
XFMT(4) : 1 si conversion de flottant necessaire (flottant diff. de celui du host)
		-1 si impossible (type flottant inconnu), 0 sinon
XFMT(5) : type de fichier (voir image.h, champ fl_type de image )
XFMT(6) : version du systeme de fichier (visilog, old/new inrimage )
XFMT(7),XFMT(8) : reserves
*/

#include <inrimage/image.h>

nfinfo_(anf,lfmt,xfmt)
register struct image **anf;
Fort_int lfmt[9];
register struct nf_info *xfmt;
{
	register struct image *nf;
	register i;
	nf = *anf;
	for(i=0;i<9;i++)
		lfmt[i] = nf->lfmt[i];
	xfmt->bits_lig = nf->bits_lig;
	xfmt->hors_tout = nf->hors_tout;
	xfmt->flt_typ = nf->float_typ;
	xfmt->flt_conv = nf->flt_conv;
	xfmt->file_typ = nf->f_type;
	xfmt->i_version = nf->i_version;
}
