/* SUBROUTINE OUVNS(NVOL,NFICH,NF,ISF,IFMT,NFMT,IAGN,IAGS,IPROT)
   ouvns_(nvol,nfich,nf,isf,ifmt,nfmt,iagn,iags,iprot)
   parametres NVOL, ISF, IAGS, IPROT ignores
   n'existe que pour compatibilite avec ancienne version
   Ne DOIT PLUS etre utilise

nouvelle Version appelable C
  struct image *c_ouvimf(nfich,gfmt,iagn)
  char *nfich; struct nf_fmt gfmt; int iagn;
  ouverture d'un fichier image de nom nfich
   si le fichier n'existe pas : creation avec le format donne (lfmt)
   sinon renvoie le format 
   si iagn == 1, le fichier doit exister : ouverture i/o si possible 
   (sinon en lecture)
   si iagn == 2 : le fichier existe mais doit etre ecrase
	si iagn & 0x10 : gfmt est de type struct nf_fmt,
			de type lfmt[9] sinon
retour: pointeur vers structure image, mais 0 si erreur 
(le fichier n'existe pas ou n'est pas une image
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <inrimage/inrlocal.h>
#include <inrimage/inrfile.h>

struct image *c_ouvimf();
struct image *nf_alloc();

extern int khoros_mode;
extern int inr_tstext();

ouvns_(nvol,nfich,nf,isf,ifmt,nfmt,iagn,iags,iprot)
Fort_int *nvol,*isf,ifmt[],nfmt[],*iagn,*iags,*iprot;
char nfich[];
struct image **nf;
{
	register i;
	struct nf_fmt gfm;
	for(i=0;i<4;i++)
		gfm.lfmt[i] = ifmt[i];
	for(i=0;i<5;i++)
		gfm.lfmt[i+4] = nfmt[i];
	if((*nf = c_ouvimf(nfich,&gfm,(int)*iagn & 1)) == 0) {
		imerror(10,"%s : %s is not an image!\n",xargv[0],nfich);
		exit(-1);
	}
	/* restituer les formats */
	for(i=0;i<4;i++)
		ifmt[i] = gfm.lfmt[i];
	for(i=0;i<5;i++)
		nfmt[i] = gfm.lfmt[i+4];
}

/* retoune nf si ok, 0 si le fichier n'est pas une image, appelle imerror si ereur */
struct image *c_ouvimf(nfich,gfmt,iagn)
char *nfich;
struct nf_fmt *gfmt;
int iagn;
{
	register ist;
	int type;
	struct image *anf;
	register struct image *nf;
	register char *nfile;
	int flg_zcat;
	char tmp[256];

	nfile = nfich;
#ifdef INR_KHOROS
	if(khoros_mode) {
		if(strncmp(nfile,"file=",5) == 0) {
			nfile += 5;
		} else if(strncmp(nfile,"shm=",4) == 0) 
			imerror(9,"Sorry! file type shm= not yet implemented");
	}
#endif
	/* sauter '>' si fichier doit exister */
	if((*nfile == '>') && (*(nfile+1) != 0) && (iagn & 1))
		nfile++;
	if((nf = nf_alloc(nfile)) == (struct image *) 0)
		return 0;
	anf = nf;
	type = iagn & VER_EXTEND ? 1 : 0;
	if ( (iagn & ~VER_EXTEND) == 1 ) {  /* le fichier doit exister */
		/* test si compresse */
		if((ist = inr_tstext(nf->nom))) {
			nf->f_type |= FL_SUBPROC;
			nf->cnv_ovf = ist;  /* berk! pour ne pas modifier struct */
		}
		/* ouverture en i/o  sinon en lecture */
		if ((ist = open_image ( nf,IM_RW )) == -1 ) {
			if ((ist =  open_image ( nf,IM_RONLY )) == -1 ) {
				/* on copie car on va faire free dans fermnf_ */
				tmp[255] = 0;
				strncpy(tmp,nf->nom,255);
				fermnf_(&anf);
				imerror(10,"%s open error %d with %s\n",
					xargv[0],errno,tmp);
				exit(-1);
			}
		}
		if(ist > 0) {
			fermnf_(&anf);
			return 0;
		}
		c_getgfm(nf,gfmt,type);
		return nf;
	} else if( (iagn & ~VER_EXTEND) == 2 ) {  /* le fichier doit tre cras */
	  put_gfmt(nf,gfmt,type);
	  if ( creat_image(nf,PMODE) == -1 ) {
	    fermnf_(&anf);
	    imerror(10,"%s create error %d with %s\n",
		    xargv[0],errno,nf->nom);
	    exit(-1);
	  }
	  return nf;
	}
	/* ouverture en io ou en ecriture */
	if ((ist = open_image( nf,IM_RW )) != -1 ) {
		if(ist > 0) {  /* not an image */
			fermnf_(&anf);
			return 0;
		}
		c_getgfm(nf,gfmt,type);
	} else {
		put_gfmt(nf,gfmt,type);
		if ((ist = open_image( nf,IM_WONLY )) == -1 ) {
			if ( creat_image(nf,PMODE) == -1 ) {
				fermnf_(&anf);
				imerror(10,"%s create error %d with %s\n",
					xargv[0],errno,nf->nom);
				exit(-1);
			}
		} else if(ist > 0) {
			fermnf_(&anf);
			return 0;
		}
	}
	return nf;
}


