C* R8TXMU
	SUBROUTINE R8TXMU(NXTLT,NTHPO,LENGT,CR0,CR1,CR2,CR3,CR4,
     XCR5,CR6,CR7,CI0,CI1,CI2,CI3,CI4,CI5,CI6,CI7,NROW)
	DIMENSION CR0(1),CR1(1),CR2(1),CR3(1),CR4(1),CR5(1),CR6(1)
	DIMENSION CR7(1),CI0(1),CI1(1),CI2(1),CI3(1),CI4(1),CI5(1)
	DIMENSION CI6(1),CI7(1)
	DATA TWOPI/6.283185307/,RAC2/.7071067812/
	SCALE=TWOPI/FLOAT(LENGT)
	  DO 40 JNR=1,NROW
	  JCON=(JNR-1)*NTHPO
	DO 109 J=1,NTHPO,LENGT
	  JSUB=J+JCON
	AR0=CR0(JSUB)+CR4(JSUB)
	AR1=CR1(JSUB)+CR5(JSUB)
	AR2=CR2(JSUB)+CR6(JSUB)
	AR3=CR3(JSUB)+CR7(JSUB)
	AR4=CR0(JSUB)-CR4(JSUB)
	AR5=CR1(JSUB)-CR5(JSUB)
	AR6=CR2(JSUB)-CR6(JSUB)
	AR7=CR3(JSUB)-CR7(JSUB)
	AI0=CI0(JSUB)+CI4(JSUB)
	AI1=CI1(JSUB)+CI5(JSUB)
	AI2=CI2(JSUB)+CI6(JSUB)
	AI3=CI3(JSUB)+CI7(JSUB)
	AI4=CI0(JSUB)-CI4(JSUB)
	AI5=CI1(JSUB)-CI5(JSUB)
	AI6=CI2(JSUB)-CI6(JSUB)
	AI7=CI3(JSUB)-CI7(JSUB)
	BR0=AR0+AR2
	BR1=AR1+AR3
	BR2=AR0-AR2
	BR3=AR1-AR3
	BR4=AR4-AI6
	BR5=AR5-AI7
	BR6=AR4+AI6
	BR7=AR5+AI7
	BI0=AI0+AI2
	BI1=AI1+AI3
	BI2=AI0-AI2
	BI3=AI1-AI3
	BI4=AI4+AR6
	BI5=AI5+AR7
	BI6=AI4-AR6
	BI7=AI5-AR7
	TTR=(BR5-BI5)*RAC2
	TTI=(BR5+BI5)*RAC2
	TR=(BR7+BI7)*(-RAC2)
	TI=(BR7-BI7)*RAC2
	CR0(JSUB)=BR0+BR1
	CI0(JSUB)=BI0+BI1
	CI1(JSUB)=BI0-BI1
	CR1(JSUB)=BR0-BR1
	CR2(JSUB)=BR2-BI3
	CR3(JSUB)=BR2+BI3
	CI2(JSUB)=BI2+BR3
	CI3(JSUB)=BI2-BR3
	CR4(JSUB)=BR4+TTR
	CR5(JSUB)=BR4-TTR
	CI4(JSUB)=BI4+TTI
	CI5(JSUB)=BI4-TTI
	CR6(JSUB)=BR6+TR
	CR7(JSUB)=BR6-TR
	CI6(JSUB)=BI6+TI
	CI7(JSUB)=BI6-TI
109    CONTINUE
40      CONTINUE
	  IF(NXTLT.LT.2) RETURN
	DO 20 I=2,NXTLT
	R0=FLOAT(I-1)*SCALE
	C1=COS(R0)
	S1=SIN(R0)
	  CALL R88T(C1,C2,C3,C4,C5,C6,C7,S1,S2,S3,S4,S5,S6,S7)
	  DO 41 JNR=1,NROW
	  JCON=(JNR-1)*NTHPO
	DO 10 J=I,NTHPO,LENGT
	  JSUB=J+JCON
	AR0=CR0(JSUB)+CR4(JSUB)
	AR1=CR1(JSUB)+CR5(JSUB)
	AR2=CR2(JSUB)+CR6(JSUB)
	AR3=CR3(JSUB)+CR7(JSUB)
	AR4=CR0(JSUB)-CR4(JSUB)
	AR5=CR1(JSUB)-CR5(JSUB)
	AR6=CR2(JSUB)-CR6(JSUB)
	AR7=CR3(JSUB)-CR7(JSUB)
	AI0=CI0(JSUB)+CI4(JSUB)
	AI1=CI1(JSUB)+CI5(JSUB)
	AI2=CI2(JSUB)+CI6(JSUB)
	AI3=CI3(JSUB)+CI7(JSUB)
	AI4=CI0(JSUB)-CI4(JSUB)
	AI5=CI1(JSUB)-CI5(JSUB)
	AI6=CI2(JSUB)-CI6(JSUB)
	AI7=CI3(JSUB)-CI7(JSUB)
	BR0=AR0+AR2
	BR1=AR1+AR3
	BR2=AR0-AR2
	BR3=AR1-AR3
	BR4=AR4-AI6
	BR5=AR5-AI7
	BR6=AR4+AI6
	BR7=AR5+AI7
	BI0=AI0+AI2
	BI1=AI1+AI3
	BI2=AI0-AI2
	BI3=AI1-AI3
	BI4=AI4+AR6
	BI5=AI5+AR7
	BI6=AI4-AR6
	BI7=AI5-AR7
	TTR=(BR5-BI5)*RAC2
	TTI=(BR5+BI5)*RAC2
	TR=(BR7+BI7)*(-RAC2)
	TI=(BR7-BI7)*RAC2
	CR0(JSUB)=BR0+BR1
	CI0(JSUB)=BI0+BI1
	CR1(JSUB)=C4*(BR0-BR1)-S4*(BI0-BI1)
	CI1(JSUB)=C4*(BI0-BI1)+S4*(BR0-BR1)
	CR2(JSUB)=C2*(BR2-BI3)-S2*(BI2+BR3)
	CI2(JSUB)=C2*(BI2+BR3)+S2*(BR2-BI3)
	CR3(JSUB)=C6*(BR2+BI3)-S6*(BI2-BR3)
	CI3(JSUB)=C6*(BI2-BR3)+S6*(BR2+BI3)
	CR4(JSUB)=C1*(BR4+TTR)-S1*(BI4+TTI)
	CI4(JSUB)=C1*(BI4+TTI)+S1*(BR4+TTR)
	CR5(JSUB)=C5*(BR4-TTR)-S5*(BI4-TTI)
	CI5(JSUB)=C5*(BI4-TTI)+S5*(BR4-TTR)
	CR6(JSUB)=C3*(BR6+TR)-S3*(BI6+TI)
	CI6(JSUB)=C3*(BI6+TI)+S3*(BR6+TR)
	CR7(JSUB)=C7*(BR6-TR)-S7*(BI6-TI)
	CI7(JSUB)=C7*(BI6-TI)+S7*(BR6-TR)
10    CONTINUE
41      CONTINUE
20    CONTINUE
	RETURN
	END
