C* SPFACT
	SUBROUTINE SPFACT(A,SL,N,DET,EPS,KOD)
C
C   FACTORISATION MATRICE DEFINIE POSITIVE PAR CHOLEVSKI
C AET SL DE DIM N(N+1)/2
C   DETERMINANT DANS DET
C  KOD =-1 SI NON DEF POS
C     K SI L(K,K)<MOD.(EPS*A(K,K))
C    0 SI O.K.
C   MATRICES TRIANGULAIRES SUP. RANGEES PAR COLONNES
	DIMENSION A(1),SL(1)
	IF(A(1).LE.0) GOTO 99
	SL(1)=SQRT(A(1))
	DET=A(1)
	KOD=0
	IF(N.EQ.1)RETURN
	I0=1
	DO 1 I=2,N
	I0=I0+I-1
1     SL(I0)=A(I0)/SL(1)
	J0=1
	DO 2 J=2,N
	K0=J0
	J0=J0+J
	P=A(J0)
	J1=J-1
	DO 3 K=1,J1
	K0=K0+1
3     P=P-SL(K0)*SL(K0)
	IF(P.LE.0.)GOTO 99
	R=ABS(A(J0))
	IF(P.LE.(EPS*R)) GOTO 98
	SL(J0)=SQRT(P)
	DET=DET*P
	IF(J.EQ.N)GO TO 10
	J2=J+1
	I0=J0
	DO 2 I=J2,N
	I0=I0+I-1
	SL(I0)=A(I0)
	DO 4 K=1,J1
	K0=I0-K
	K1=J0-K
4     SL(I0)=SL(I0)-SL(K0)*SL(K1)
2     SL(I0)=SL(I0)/SL(J0)
10    CONTINUE
	RETURN
99    KOD=-1
	RETURN
98    KOD=J
	RETURN
	END
