/*
C*DORDWR
$PROG DORDWR
	INTEGER FUNCTION DORDWR(ISENS,LU,ITYP,IRAND,IBUF,NBYT,NBLU,IST)
	INTEGER ISENS(1),LU(1),IRAND(1),NBYT(1),NBLU(1),IST(1)
	INTEGER IBUF(1),ITYP(1)
C ECRITURE (ISENS=1) OU LECTURE (ISENS NON 1) SUR U.L. LU
C  DE NBYT OCTETS DU BUFFER IBUF SUR le secteur isec ( 1 secteur = 256 bytes )
C  (A PARTIR DE LA POSITION COURANTE SI IRAND<0)
C  FORMAT "ASCII" SI ITYP=0 , "IMAGE" SI NON 0
C RENVOIE DANS NBLU LE NB D'OCTETS EFFECTIFS ET DANS IST
C LE STATUS SVC 1 ; DORDWR VAUT IST
*/

#include <stdio.h>
#include <inrimage/image.h>

extern debug_;

dordwr_(isens,lu,ityp,nsec,ibuf,nbyt,nblu,ist)
Fort_int *isens,*lu,*ityp,*nsec,*nbyt,*nblu,*ist;
char *ibuf;
{

   if ( *isens == 1 )
	{			/* ecriture */

	if ( *nsec < 0 )
		{
		/* ecriture sequentielle */
		if ( debug_ ) fprintf(stderr,"%s dordwrd:ecriture sequentielle\n",xargv[0]);
		*nblu = write(*lu,ibuf,*nbyt);
		}
	else	{
		/* ecriture random */
		if ( debug_ ) fprintf(stderr,"%s dordwr:ecriture random\n",xargv[0]);
		lseek(*lu,256L * (*nsec),0);
		*nblu = write(*lu,ibuf,*nbyt);
		}

	if ( debug_ ) fprintf(stderr,"%s dordwr:lu=%d nsec=%d nbyt=%d nblu=%d ist=%d\n",xargv[0],
				*lu,*nsec,*nbyt,*nblu,*ist);
	return ( *ist = ( *nblu <= 0 ? -1 : 0 ) );

	}

   else
	{			/* lecture */

	if ( *nsec < 0 ) 
		{
		/* lecture sequentielle */
		if ( debug_ ) fprintf(stderr,"%s dordwr:lecture sequentielle\n",xargv[0]);
		*nblu = read(*lu,ibuf,*nbyt);
		}
	else	{
		/* lecture random */
		if ( debug_ ) fprintf(stderr,"%s dordwr:lecture random\n",xargv[0]);
		lseek(*lu,256L * (*nsec),0);
		*nblu = read(*lu,ibuf,*nbyt);
		}

	if ( debug_ ) fprintf(stderr,"%s dordwr:lu=%d nsec=%d nbyt=%d nblu=%d ist=%d\n",xargv[0],
				*lu,*nsec,*nbyt,*nblu,*ist);
	return ( *ist = ( *nblu <= 0 ? -1 : 0 ) );
	}

}
