#include <inrimage/image.h>
#include <stdio.h>

#define DEF_LG_BMAP 512

extern debug_,koctet_;

static char Ucmd[]=
"{image-in | -} contour-file-out [-tek] [-fc] [-obj n1[,n2]] [-ix nn] [-iy nn] [-x nn] [-y nn] [-maxc n]";
static char Udetail[]=
"\timage : image 1 ou 8 bits (- = stdin)\n\
\tcontour-file : fichier de contours\n\
\t-tek: visualisation des contours en mode tektro\n\
\t-fc : forte connexite\n\
\t-obj : definit le ou les seuils pour les objets\n\
\t-ix, -iy, -x, -y : fenetre de travail\n\
\t-maxc : nb max de contour autorises (def 4096)";

main(argc,argv)
int argc;
char **argv;
{

	char in[80],out[80],seuils[12];
	int ix=1,iy=1;
	int ixy0[2],idimxy[2],iseuil[2],ivis=1,iconn=0;
	int maxcont, lg_bmap, dummy;

	inr_init(argc,argv,"2.3",Ucmd,Udetail);

	igetopt1("-ix","%d",&ix);
	igetopt1("-iy","%d",&iy);
	ixy0[0] = ix;
	ixy0[1] = iy;

	idimxy[0] = idimxy[1] = 0;
	igetopt1("-x","%d",&idimxy[0]);
	igetopt1("-y","%d",&idimxy[1]);
	if(  igetopt1("-maxc","%d",&maxcont)) {
	  lg_bmap = (maxcont + 7) / 8;
	  if(lg_bmap <= 0) lg_bmap= DEF_LG_BMAP;
	} else lg_bmap = DEF_LG_BMAP;
	iseuil[0] = 1; iseuil[1] = 255;
	igetopt1("-obj","%s",seuils);
	sscanf(seuils,"%d,%d",&iseuil[0],&iseuil[1]);

	if ( igetopt0("-tek") ) ivis = 3;

	iconn = igetopt0("-fc") ;

	fileopt(in,"i");

	if ( !fileopt(out,"o")) {
		fprintf(stderr,"%s:fichier de contours obligatoire\n",xargv[0]);
		iusage_(Ucmd,Udetail);
	}


	if ( tstopts() ) iusage_(Ucmd,Udetail);

	c_sancon(in,out,ixy0,idimxy,iseuil,&ivis,&iconn,lg_bmap);
	return 0;

}
