#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"image-in image-noyau [image-out] [-dir | -fft | -bloc]";
static char Udetail[]=
"\tconvolution automatique avec choix de la methode\n\
\tsi 'image-in' ou 'noyau' est '-', on prendra stdin\n\
\t-dir, -fft, -bloc : forcer methode directe, par fft ou par blocs optimises\n";

#define CNV_DIRECT 1
#define CNV_FFT 2
#define CNV_BLOCS 3

fcmain_()
{
	char in[128],noyau[128],out[128];
	register i1, i2;
	Fort_int force_type;

	inr_init(0,0,"2.1",Ucmd,Udetail);

	i1 = fileopt(in,"i");
	i2 = fileopt(noyau,"i");
	if((i1 == 0) && (i2 == 0))
		imerror(9,"il faut 1 images d'entree ET un noyau\n");
	fileopt(out,"o");
	force_type = 0;
	if( igetopt0("-dir"))
		force_type = CNV_DIRECT;
	else if( igetopt0("-fft"))
		force_type = CNV_FFT;
	else if( igetopt0("-bloc"))
		force_type = CNV_BLOCS;

	if ( tstopts() )
		iusage_(Ucmd,Udetail);

	scnvlg_(in,noyau,out,&force_type);
	return 0;

}
