#include <inrimage/image.h>
#include <stdio.h>
#include "fcmain.h"

extern debug_,koctet_;


static char Ucmd[]=
"[-eb | -di] [-g] [-t n | -f ccord-file] [image-in] [image-out]";
static char Udetail[]=
"\t-t : taille de la fenetre (1-4 pour 4,8,12,20 pts)\n\
\t-f : \n\
\t-eb : erosion aux bords\n\
\t-di : dilatation\n\
\t-g: methode generalisee (en niveaux de gris)\n\
\t images 1 ou 8 bits\n";

f_c_main
{
	char inname[128],outname[128], coordname[128];
	Fort_int itype,iopt[3];
	int dummy;

	inr_init(ARGC,ARGV,"2.1",Ucmd,Udetail);

	iopt[0] = 1; iopt[1] = 0;	/* erosion sans le bord par defaut */
	iopt[2]= 0;
	itype = 1;		/* fenetre de type 1 par defaut */

	if(!igetopt("-f","",0,"%s",coordname,"",0)) {
	  if( igetopt("-t","",0,"%d",&dummy,"",0))
	    itype = dummy;
	} else
		itype = 5;

	if ( igetopt("-eb","",0,"",0,"",0) ) {
		iopt[0] = 1; /* erosion */
		iopt[1] = 1; /* au bord */
	} else if ( igetopt("-di","",0,"",0,"",0) ) {
		iopt[0] = 2; /* dilatation */
		iopt[1] = 0;
	}
	iopt[2] = igetopt("-g","",0,"",0,"",0);
	fileopt(inname,"i");
	fileopt(outname,"o");


	if ( tstopts() ) iusage_(Ucmd,Udetail);

	serode_(inname,outname,&itype,iopt,coordname);
	return 0;

}
