#include <inrimage/image.h>
#include <stdio.h>
#include <string.h>

#include "fcmain.h"

static mkseuils();

static char Ucmd[]=
"{-vs liste-des-seuils | -fs fichier-des-seuils} [image-in] [image-out]";
static char Udetail[]=
"\tseuillage par N seuils :\n\
\t -vs : liste des seuils separes par ','\n\
\t -fs : les seuils sont dans un fichier (format image)";

f_c_main
{
	char inname[80],outname[80],sname[80];
	int rm_flag;

	inr_init(ARGC,ARGV,"2.1",Ucmd,Udetail);
	
	if(!igetopt("-fs","",0  ,"%s",sname  ,"",0)) {

		if ( igetopt("-vs","",0,"%s",sname,"",0) ) {
			rm_flag = 1;
		} else
			iusage_(Ucmd,Udetail);
	}

	fileopt(inname,"i");
	fileopt(outname,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);

	if(rm_flag)
		mkseuils(sname);
	smults_(inname,outname,sname);

	if (rm_flag) unlink(sname);
	return 0;


}

static mkseuils(seuils)
char *seuils;
{
	int i;
	Fort_int lfmt[9];
	char *p_seuils;
	float buf[256];
	char *index();
	struct image *nf;

	p_seuils = seuils;

	for ( i=0 ; i<256 ; i++ )
		{
		sscanf(p_seuils,"%f",&buf[i]);
		p_seuils = index(p_seuils,',');
		if ( p_seuils++ == 0 ) break;
		}

	strcpy(seuils,"/tmp/mulsXXXXXX");
	mktemp(seuils);

	DIMX = i + 1;
	DIMY = 1;
	TYPE = REELLE;
	BSIZE = sizeof(float);
	nf = image_(seuils,"c","a",lfmt);
	c_ecr(nf,DIMY,buf);
	fermnf_(&nf);

}
