#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"[-D] [-k octets] [-I] [-rd input-ascii-file] [-ix n] [-iy n] [-iz n] [-idx n] [-idy n] [-idz n] [-f=scanf_format] [options-de-format] [image-out]";
static char Udetail[]=
"\tentree de donnees ascii dans une image\n\
\t-I : mode interactif (chaque espace ou return est une fin de nb)\n\
\t\tsinon lecture en continue sur stdin ou sur fichier(par scanf)\n\
\t-rd : lecture sur fichier\n\
\t-f=format : format pour scanf de chaque valeur\n\
\t -idx, -idy, -idz : choix de la taille de fenetre a remplir (par defaut toute l'image)\n\
\t -ix, -iy, -iz : choix de l'origine de fenetre a remplir (par defaut toute l'image)\n\
";

static Fort_int ixyz[3],idxyz[3];
static char format[256];
extern int errno;

extern int khoros_mode;

main(argc,argv)
int argc;
char **argv;
{
	Fort_int lfmt[9];
	struct image *nf;
	char image[128];
	Fort_int tout, inter;
	FILE *inf;
	int dummy;

	inr_init(argc,argv,"2.1",Ucmd,Udetail);

	ixyz[0] = ixyz[1] = ixyz[2] = 1;
	idxyz[0] = idxyz[1] = idxyz[2] = 0; /* toute l'image par defaut */
	tout = 1;
	if ( igetopt("-ix","",0,"%d",&dummy,"",0) ) {
	  tout = 0;
	  ixyz[0] = dummy;
	}
        if ( igetopt("-idx","",0,"%d",&idxyz[0],"",0) ) {
	  tout = 0;
	  idxyz[0] = dummy;
	}
	if ( igetopt("-iy","",0,"%d",&ixyz[1],"",0) ) {
	  tout = 0;
	  ixyz[1] = dummy;
	}
        if ( igetopt("-idy","",0,"%d",&idxyz[1],"",0) ) {
	  tout = 0;
	  idxyz[1] = dummy;
	}
	if ( igetopt("-iz","",0,"%d",&ixyz[2],"",0) ) {
	  tout = 0;
	  ixyz[2] = dummy;
	}
        if ( igetopt("-idz","",0,"%d",&idxyz[2],"",0) ) {
	  tout = 0;
	  idxyz[2] = dummy;
	}
#ifndef NONINTERACTIF
	inter = igetopt("-I","",0,"",0,"",0);
#else
	inter = 0;
#endif
	format[0] = 0;
	igetopt("-f=","%s",format,"",0,"",0);
	if((inf = asciifileopt("-rd",0)) == NULL) {
		if(khoros_mode)
			imerror(9,"-rd option required!\n");
		else
			inf = stdin;
	}
	fileopt(image,"o");
	nf = image_(image,"s","",lfmt);
	sonsim_(nf,lfmt,&tout,&inter,ixyz,idxyz,format,inf);
	return 0;

}
