#include <inrimage/image.h>
#include <stdio.h>


static char Ucmd[]=
"[-D] [-k octets] [-wr output-ascii-file] [-ix n] [-x n] [-iy n] [-y n] [-iz n] [-z n] [-c | -cz] [-l n] [-f=format] [image | -]";
static char Udetail[]=
"\timpression (sur stderr) d'une fenetre (x,y,z) d'origine (ix,iy,iz),\n\
\t  de l'image image (stdin par defaut)\n\
\t -wr: fichier de sortie (defaut stdout, -wr stderr => sortie stderr)\n\
\t-l n: nb max de valeurs par ligne d'impression (def. 5 ou 10 , 0=> DIMX)\n\
\t-c : format compact, supprime l'impression des numeros de ligne et plan\n\
\t-cz : format compact, mais avec impression des numeros de plans\n\
\t-f=format : format pour printf de chaque valeur (taille max 256 chars)";

static Fort_int ixyz[3],idxyz[3];
static char format[256];
static Fort_int compactf, lgout= -1;

extern int errno;
static char *tabcod[]= {"-c","-cz"};

extern FILE *asciifileopt();

main(argc,argv)
int argc;
char *argv[];
{
	char inname[128];
	FILE *outf;
	register i;
	Fort_int choix = 1; /* toute l'image par defaut */
	int dummy;

	inr_init(argc,argv,"2.1",Ucmd,Udetail);
	ixyz[0] = ixyz[1] = ixyz[2] = 1;
	idxyz[0] = idxyz[1] = idxyz[2] = 0; /* toute l'image par defaut */


	if ( igetopt("-ix","",0,"%d",&dummy,"",0) ) {
	  choix = 2;
	  ixyz[0] = dummy;
	}
        if ( igetopt("-x","",0,"%d",&dummy,"",0) ) {
	  choix = 2;
	  idxyz[0] = dummy;
	}

	if ( igetopt("-iy","",0,"%d",&dummy,"",0) ) {
	  choix = 2;
	  ixyz[1] = dummy;
	}
        if ( igetopt("-y","",0,"%d",&dummy,"",0) ) {
	  choix = 2;
	  idxyz[1] = dummy;
	}

	if ( igetopt("-iz","",0,"%d",&dummy,"",0) ) {
	  choix = 2;
	  ixyz[2] = dummy;
	}
        if ( igetopt("-z","",0,"%d",&dummy,"",0) ) {
	  choix = 2;
	  idxyz[2] = dummy;
	}
	
	compactf = 0;
	if((i = itoggleopt("-choix1",tabcod,2)) >= 0) {
		compactf = (i == 0) ? 1 : -1;
	}
	if(igetopt("-l","",0,"%d",&dummy,"",0)) lgout = dummy;

	format[0] = 0;
	igetopt("-f=","%s",format,"",0,"",0);

	fileopt(inname,"i");
	if((outf = asciifileopt("-wr",1)) == NULL)
		outf = stdout;
		
	if ( tstopts() )
		iusage_(Ucmd,Udetail);
	sprint_(&choix,inname,ixyz,idxyz,format,&lgout,&compactf,outf);
	return 0;

}


