C* SCNVLG
	SUBROUTINE SCNVLG(entree,noyau,sortie,iftyp)
C CONVOLUTION DE L IMAGE NFE,SFE,IFMTE PAR LE NOYAU NFN,SFN,IFMTN
C ET RESULTATS DANS NFS,SFS,(IFMTS=IFMTE)
C  CONVOLUTION NORMALE (Y(I,J)=SOM X(I-K,J-L)*F(K,L))
C   POUR K DE -N2 A N1 ET L DE -M2 A M1 (N1+N2+1=N, M1+M2+1=M),
C    AVEC N1=(N-1)/2, N2=N/2, M1=(M-1)/2, M2=M/2
C M ET N SONT LES DIMENSIONS DU FILTRE DE CONVOLUTION
C LA CONVOLUTION EST EFFECTUEE SUIVANT LA METHODE LA PLUS RAPIDE
C PARMI LES 3 METHODES -DIRECTE-SPECTRALE ET BLOCS OPTIMISES
C LE PROGRAMME PSUPCO PERMET DE FAIRE UNE ESTIMATION EN TEMPS TOTAL
C DES 3 MISES EN OEUVRE ET DE CHOISIR LA METHODE LA PLUS RAPIDE
C ACONDI EFFECTUE LA CONVOLUTION DIRECTEMENT
C ACOBLO ----- ----- ------  --- PAR BLOCS OPTIMISES
C COSPEC ----- ------ ------ --- PAR FOURIER
C LES 3 PROGRAMMES FONT INTERVENIR L ARRAY PROCESSEUR
C POUR LES MISES EN OEUVRE DIRECTE ET SPECTRALES LES POINTS
C RESULTATS AUX BORDS SONT CALCULES EN RAJOUTANTS DES LIGNES
C NULLES AUX BORDS DE L IMAGE D ENTREE
C POUR LA MISE EN OEUVRE PAR BLOCS ,LES DERNIERES LIGNES
C DE L IMAGE D ENTREE SONT REPETEES
C
C si IFTYP n'est pas nul on force la methode
	integer entree(1),noyau(1),sortie(1)
	DIMENSION LFMTE(9),LFMTN(9),MAXL(1),LFMTS(9)
        COMMON /TYPSZ/LGFLT,LGFINT,LGLONG,LGINT,LGINT4,LGPTR,LGALGN
	logical ispipe, isstdo
	EXTERNAL RAZ,SUPCO,cpimag,convrg,xxchoix
	INTEGER*8 nfe,nfs,nfn,nfte,nftn,nfts,image

	nfe=image(entree,"e ","  ",lfmte)

	call cpyfmg(nfe,lfmts)
	lfmts(3)=LGFLT
	lfmts(4)=1
	nfs=image(sortie,"s ","a ",lfmts)

	nfn=image(noyau,"e ","  ",lfmtn)

 	MAXL(1)=1
	if(iftyp.le.0) goto 10
	ires = iftyp
	call exec(ier,0,0,1,maxl,xxchoix,nmem,ier)
	goto 20
 10	CALL EXEC(IER,0,0,1,MAXL,SUPCO,NFE,SFE,LFMTE,NFN,SFN,LFMTN,NFS
     $,SFS,LFMTS,IRES,NMEM,IER)
 20	IF(IER.NE.0) GOTO 900
c------------------------------------------------------------------------
c		methode directe
c------------------------------------------------------------------------

	IF(IRES.EQ.1) then
	CALL CONDI(NFE,SFE,LFMTE,NFN,SFN,LFMTN,NFS,SFS,NMEM)
	endif

c------------------------------------------------------------------------
c		methode spectrale
c------------------------------------------------------------------------

	IF(IRES.EQ.2) then

c	NDI=1
c	CALL EXEC(IER,0,0,1,NDI,RAZ,NFS,SFS,LFMTS,IER)
c	IF(IER.NE.0)GOTO 900
c	CALL SETPNT(NFS,SFS,1)

	if ( lfmte(4) .ne. 1 ) then
		lfmte(3)=LGFLT
		lfmte(4)=1
		nfte=image("/tmp/scnvlgXXXXXX\0","t ","a ",lfmte)
		ntabv=1
		call exec(ier,0,0,1,ntabv,convrg,nfe,sfe,nfte,sfte,ier)
	else
		nfte=nfe
	endif

	if ( lfmtn(4) .ne. 1 ) then
		lfmtn(3)=LGFLT
		lfmtn(4)=1
		nftn=image("/tmp/scnvlgXXXXXX\0","t ","a ",lfmtn)
		ntabv=1
		call exec(ier,0,0,1,ntabv,convrg,nfn,sfn,nftn,sftn,ier)
	else
		nftn=nfn
	endif

	CALL COSPEC(NFtE,SFE,LFMTE,NFtN,SFN,LFMTN,NFS,SFS,LFMTS,NMEM)

	if(nfte.ne.nfe) call rmnf(nfte)
	if(nftn.ne.nfn) call rmnf(nftn)

	endif

c------------------------------------------------------------------------
c		methode par blocs
c------------------------------------------------------------------------

	IF(IRES.EQ.3) then

c	NDI=1
c	CALL EXEC(IER,0,0,1,NDI,RAZ,NFS,SFS,LFMTS,IER)
c	IF(IER.NE.0)GOTO 900
c	CALL SETPNT(NFS,SFS,1)

	if ( ispipe(nfe) ) then
		nfte=image("/tmp/scnvlgXXXXXX\0","t ","a ",lfmte)
		ntabv=1
		call exec(ier,0,0,1,ntabv,cpimag,nfe,nfte,ier)
	else
		nfte=nfe
	endif

	if ( isstdo(nfs) ) then
		nfts=image("/tmp/scnvlgXXXXXX\0","t ","a ",lfmts)
	else
		nfts=nfs
	endif


	CALL COBLO(NFtE,SFE,LFMTE,NFN,SFN,LFMTN,NFtS,SFS,LFMTS,NMEM)

	if ( isstdo(nfs) ) then
		ntabv=1
		call exec(ier,0,0,1,ntabv,cpimag,nfts,nfs,ier)
		call rmnf(nfts)
	endif

	if ( ispipe(nfe) ) call rmnf(nfte)
		
	endif

	IF(IRES.LE.0.OR.IRES.GE.4)CALL OUTSTR(0,'AUCUNE MISE EN OEUVRE N E
     $ST POSSIBLE PAR MANQUE DE PLACE MEMOIRE$')

900   CALL IMPERR(IER)
	CALL FPANIC
	RETURN
	END

	subroutine xxchoix(a,maxl,nmem)
	nmem = maxl
	return
	end
