/* SNORMI
	SUBROUTINE SNORMI(in,out,temp)
	snormi_(in,out,temp)

	normalisation d'image (pour la ramener entre 0 et 1)
	tous types acceptes (conversion automatique en Read et Write)
	si l'entree est un pipe, on copiera
	sur un fichier temporaire (temp doit etre de la forme
	utilisee pour mktemp() )
	la copie ne sera pas effectuee par "normim" si tout tient
	en memoire
*/


#include <inrimage/image.h>
static struct image *nfi, *nfo, *nft;
static  Fort_int ier, zero= 0, un= 1;
extern int normim_();
extern Fort_int ispipe_();

void snormi_(in,out,temp)
char *in, *out, *temp;
{
	Fort_int lfmt[9];
	 Fort_int n;
	nfi = image_(in,"e","",lfmt);
	nfo = image_(out,"s","a",lfmt);
/*!!	if(ispipe_(&nfi) || (TYPE != REELLE)) { */
	if(ispipe_(&nfi)) {
		TYPE = REELLE;
		BSIZE = sizeof(float);
		nft = image_(temp,"t","a",lfmt);
	} else
		nft = nfi;
	n=1;
	exec_(&ier,&zero,&zero,&un,&n,normim_,&nfi,&nfo,&nft,&ier);
	imperr_(&ier);
	if(nft != nfi) rmnf_(&nft);
	fpanic_();
}
