/*
 SPRINT
	SUBROUTINE SPRINT(I,image,ixyz,idxyz,format,lgout,compactf)
	sprint_(I,image,ixyz,idxyz,format)
 impression sur stdout de tout (I=1) ou partie (I=2)
 d'une image reelle ou virg fixe
 Si I=1, IXYZ donne les origines en X,Y,Z (>= 1) et IDXYZ les tailles
 FORMAT : chaine vide ou format pour printf
 LGOUT : nb max de valeurs par ligne d'impression (<0 => default, 0=> max)
 COMPACTF != 0 => format  compact : sans num ligne ni plan si >0, avec num plans si < 0
*/

#include <stdio.h>
#include <inrimage/image.h>

extern printi_();
struct image *nf;
static Fort_int nb, un= 1, zer= 0, ier;
static Fort_int lgo;

sprint_(i,image,ixyz,idxyz,format,lgout,compactf,outf)
Fort_int *i;
char *image, *format;
Fort_int *ixyz, *idxyz;
Fort_int *lgout, *compactf;
FILE *outf;
{
	Fort_int lfmt[9];
	char *pfmt;
	nf = image_(image,"e","",lfmt);
	lgo = *lgout;
	if(*i == 1) {
		ixyz[0] = 1; ixyz[1] = 1; ixyz[2] = 1;
		idxyz[0] = DIMX;
		idxyz[1] = NDIMY;
		idxyz[2] = NDIMZ;
	} else if(*i != 2)
		imerror(9,"sprint: argument errone\n");
	else {
		if(NDIMZ == 1) {
			ixyz[2] = 1;
			idxyz[2] = 1;
		}
		if(ixyz[0] <= 0) ixyz[0] = 1;
		if(ixyz[1] <= 0) ixyz[1] = 1;
		if(ixyz[2] <= 0) ixyz[2] = 1;
		if(idxyz[0] <= 0) idxyz[0] = DIMX - ixyz[0] + 1;
		if(idxyz[1] <= 0) idxyz[1] = NDIMY - ixyz[1] + 1;
		if(idxyz[2] <= 0) idxyz[2] = NDIMZ - ixyz[2] + 1;
	}
	if(*format == 0) {
		if(BSIZE > 1 || BSIZE < -8)
			pfmt = compactf ? "%g" : "%14g";
		else
			pfmt = compactf ? "%d" : "%5d";
	} else
		pfmt = format;
	if(lgo == 0)
		lgo = idxyz[0];
	else if(lgo < 0) {
		if(BSIZE > 1 || BSIZE < -8)
			lgo = 5;
		else
			lgo = 10;
	}
	nb = 1;
	exec_(&ier,&zer,&zer,&un,&nb,printi_,&nf,ixyz,idxyz,outf,pfmt,&lgo,compactf,&ier);
}
