#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

/* ajoute le point defini par pseg au contour correspondant
iy = num de ligne (>=1) */
void c_adtchn(pseg,iy)
struct iseg *pseg;
int iy;
{
	int ix, i, j, k;
	int flg_deb, num;
	struct chn *pchn, *pchn1, *pchn2;
	struct cont_desc *pdesc;
	ix = pseg->x;
	pdesc = anac_desc - pseg->idesc;
	pchn2 = anac_chn + pdesc->d_bloc -1;  /* on va chercher la longueur dans dernier bloc */
	pchn1 = anac_chn + pdesc->p_bloc -1;
	num = pdesc->num;
	if(pchn2->inext & 1) {  /* 2e point : calcul surface */
		if(num < 0) { /* sens neg */
			flg_deb = 1;   /* ajouter au debut */
			i = pchn2->ip0 -2;
			pdesc->surf -= (ix - pchn2->pts[2*i] -1);
		} else {
			flg_deb = 0;  /* ajouter a la fin */
			i = pchn1->ip0;
			pdesc->surf += (ix - pchn1->pts[2*i] + 1);
		}
	} else { /* 1e pt d'un segment */
		if(num < 0) 
			flg_deb = 0;  /* ajouter a la fin */
		else
			flg_deb = 1;  /* ajouter au debut */
	}
	if(flg_deb) { /* ajouter au debut */
		if(pchn1->ip0 <= 0) { /* ajouter un bloc au debut */
			if((anac_info.ipvid <= 0) && ((anac_info.ix_chn + sizeof(struct chn)) >= anac_info.ix0_desc)) c_libchn();
			k = c_gtbloc();
			j = pdesc->p_bloc;
			pchn = anac_chn + k -1;
			pchn->inext = j;
			pchn->ip0 = NBPTS_BLOC;
			pdesc->p_bloc = k;
		} else
			pchn = pchn1;
		i = pchn->ip0--;
	} else {  /* ajouter a la fin */
		if(pchn2->ip0 > NBPTS_BLOC) { /* ajouter bloc a la fin */
			if((anac_info.ipvid <= 0) && ((anac_info.ix_chn + sizeof(struct chn)) >= anac_info.ix0_desc)) c_libchn();
			
			k = c_gtbloc();
			pchn = anac_chn + k -1;
			j = pchn2->inext;
			pchn->inext = j;  /* copie lgr */
			pchn2->inext = k;
			pchn->ip0 = 1;
			pchn2 = pchn;
			pdesc->d_bloc = k;
		} else
			pchn = pchn2;
		i = pchn->ip0++;
	}
	i = 2 * (i - 1);
	pchn->pts[i++] = ix;
	pchn->pts[i] = iy;
	pchn2->inext++;  /* incr nb pts du contour */
}
