#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

/*
   compresse la table pseg et la table des descripteurs
 pour eliminer le contour de descr. num idesc
*/

void c_comprs(idesc,pseg,lseg)
int idesc, lseg;
struct iseg *pseg;
{
	int i, n;
	i = idesc * sizeof(struct cont_desc);
	n = anac_info.ix0_desc - i;
	if((idesc <= 0) || (n < anac_info.ix_cont_desc))
		imerror(9,"comprs: mauvais numero de descripteur\n");
	n -= anac_info.ix_cont_desc;
	if(n > 0) {   /* compression table descripteurs */
		register char *pi, *po;
		pi = anac_heap+anac_info.ix_cont_desc + n - 1;
		po = pi + sizeof(struct cont_desc);
		while(n-- > 0)
			*po-- = *pi--;
	}
	 anac_info.ix_cont_desc += sizeof(struct cont_desc);
	 /* compression de pseg */
	 for(i=0;i<lseg;i++, pseg++) {
		 if(pseg->idesc < idesc) continue;
		 if(pseg->idesc > idesc) {
			 pseg->idesc--;
		 } else {
			 pseg->idesc = 0;
		 }
	 }
		 
}
