C* PAFFIN
	  SUBROUTINE PAFFIN(A,NTABF,B,C,NTABV,NF,SF,NFO,SFO,LFMT)
C
C     NUMEROTATION DES ELEMENTS D`UNE FENETRE 3*3
C        +-----+-----+-----+
C        I  6  I  7  I  8  I
C        I-----I-----I-----I
C        I  5  II0,J0I  1  I
C        I-----I-----I-----I
C        I  4  I  3  I  2  I
C        +-----+-----+-----+
C     UN POINT(I0,J0) DU CONTOUR NE SERA ELLIMINE QUE SI LA
C     CONNECTIVITE DE SES 8 VOISINS N'EST PAS DETRUITE LORS DE
C     ELIMINATION
C     ON DEFINIT ALORS UNE FONCTION LOGIQUE DES 4 VARIABLES
C     F(6),F(4),F(8),F(2) :CONNECTIVITE
C     SI LE POINT I EST EGAL A 1 F(I) EST VRAIE (F(I)=T)
C     F(I)=F DANS LE CAS CONTRAIRE
C     CONNECTIVITE=T SI LA CONNECTIVITE N'EST PAS DETRUITE
C     DANS LES CAS (F(1)=F,F(7)=F,F(3)=F) ET
C                  (F(1)=F,F(7)=T,F(3)=T) LA CONNECTIVITE EST
C     TOUJOURS DETRUITE  (ON GARDE DONC LE POINT)
C     DANS LE CAS (F(1)=T,F(7)=T,F(3)=T) LA CONNECTIVITE N'EST
C     JAMAIS DETRUITE (ON PEUT ENLEVER LE POINT)
C     CAS (F(1)=F,F(7)=F,F(3)=T) CONNECTIVITE=K001
C     CAS(F(1)=F,F(7)=T,F(3)=F)    CONNECTIVITE=K010
C     CAS(F(1)=T,F(7)=F,F(3)=F)  CONNECTIVITE=K100
C     CAS(F(1)=T,F(7)=F,F(3)=T)    CONNECTIVITE=NOT(F(6))
C     CAS(F(1)=T,F(7)=T,F(3)=F)    CONNECTIVITE=NOT(F(4))
C
	external btest
	DIMENSION   NTABV(2),LFMT(9)
	  INTEGER B(1),A(1),C(1)
	LOGICAL BTEST
	 IDIMX=LFMT(1)
	 IDIMY=LFMT(2)
	 N=0
	IPAS=0
C   NB DE MOTS ENTIERS (32 BITS) POUR 1 LIGNE
	IM0=IDIMX/32
	IM1=32*IM0
C  BOUCLE DE TRAITEMENT : TRAITER L'IMAGE JUSQU'A CE QU'IL N'Y AIT PLUS
C          DE MODIF A FAIRE
2     CALL NCOUP(32*NTABV(1),3,NF,SF,IDIMX,IDIMY,NLIG,IPT)
	NLL=(NLIG-1)*IDIMX
C  FIXER LE NUM. DE LA 1ERE LIGNE A LIRE
	 CALL LPTSET(NF,IPT)
C  LIRE NLIG LIGNES DANS B
	 CALL LECT(NF,NLIG,B)
C  TRANSFERER B DANS C (ID2 MOTS)
	ID2=(IDIMX*NLIG+31)/32
	 DO 60 K=1,ID2
	C(K)=B(K)
60    CONTINUE
	 IF(IPT.EQ.1) GOTO 5
C  RECOPIER DERNIERE LIGNE DU TABLEAU PRECEDENT AU DEBUT DE C ET B
	DO 32 I=1,IM0
	C(I)=A(I)
	B(I)=A(I)
32    CONTINUE
C   IDIMX-IM1 BITS DU DERNIER MOT
	 DO 20 I=IM1,IDIMX-1
	IF(.NOT.BTEST(A,I)) GOTO 21
	CALL BSET(C,I)
	CALL BSET(B,I)
	GOTO 20
21    CALL BCLR(C,I)
	CALL BCLR(B,I)
 20    CONTINUE
C   TRAITER LE TABLEAU
   5   CALL GAFFIN(B,C,N,IDIMX,NLIG,IPAS)
	 CALL LPTSET(NFO,IPT)
C   RECOPIER LA DERNIERE DU RESULTAT DANS A
	DO 6 I=1,IM0+1
6     A(I)=0
	J=NLL-IDIMX-1
	 DO 1 I=0,IDIMX-1
	J=J+1
	IF(BTEST(C,J)) CALL BSET(A,I)
 1     CONTINUE
C    ECRIRE LE RESULTAT
	 CALL ECR(NFO,NLIG,C)
	IF(LPTGET(NF).LT.IDIMY) GOTO 2
C  FIN D'UN BALAYAGE DE L'IMAGE
	 WRITE(0,55) N
 55    FORMAT(' NOMBRE DE MODIFICATIONS  ',I5)
	 IF(N.EQ.0) RETURN
C   IMAGE A LIRE= IMAGE RESULTAT
	 NF=NFO
	 SF=SFO
	 IPT=1
C  INCREMENTER NOMBRE DE PASSES
	IPAS=IPAS+1
	 CALL LPTSET(NFO,1)
	 N=0
	 GOTO 2
 50    CALL ERMESF(8)
	 END
