#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

/*
   sort un contour (fichier/ visu)
  pdesc :  descripteur du contour
*/

void c_wrtchn(pdesc)
struct cont_desc *pdesc;
{
	int is, j, isens, i, num, dmax;
	is = pdesc->num < 0 ? -1 : 1;
	j = pdesc->p_bloc;
	if(anac_info.flg_res & 1) {  /* ecriture fichier */
		num = pdesc->num;
		if(num < 0) num = -num;
		c_wrctev(anac_info.anac_ct_out,num,pdesc->numext);
		if(! j) return;
		c_wrctpa(anac_info.anac_ct_out,num,&pdesc->surf,1);
		c_wrctls(anac_info.anac_ct_out,num,anac_chn,pdesc->p_bloc,NBPTS_BLOC,-1);
	}
	if(anac_info.flg_res & 2) {  /* sortie tek */
		if(! j) return;
		isens = is > 0 ? 1 : -1;
		dmax = (anac_info.dx < anac_info.dy) ? anac_info.dy : anac_info.dx;
		
		c_ecchtk(anac_chn,j,isens,1,NBPTS_BLOC,dmax);
	}
	if(! j) return;
	pdesc->p_bloc = 0;
	pdesc->d_bloc = (anac_chn + j - 1)->ip0;  /* transfert lgr */
	c_rlschn(j);
}
