#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
#include "imext.h"

extern char *i_malloc(), *i_calloc();
extern errno;

int imext_err(pnf,code,txt,p1,p2,p3,p4)
struct extimage **pnf;
int code;
char *txt;
char *p1, *p2, *p3, *p4;
{
	fermimext(pnf);
	imerror(code,txt,p1,p2,p3,p4);
}

struct extimage *openimext(name,mode)
char *name;
int mode;   /* 0= read ("r") 1= read/write ("w+") */
{
	FILE *f;
	char *p;
	char *flag;
	register x, n;
	register unsigned char *pc;
	register struct bmp_info *pb;
	struct extimage *nfext;
	nfext = (struct extimage *)i_calloc(1,sizeof(struct extimage));
	if(name) {
		p = name;
		n = strlen(name) + 1;
	} else {
		p = mode ? ">" : "<";
		n = 2;
	}
	flag = mode ? "w+" : "r";
	nfext->name = i_malloc(n);
	strcpy(nfext->name,p);
	f = (FILE *)0;
	if((*(p + 1) != 0) || ((*p != '<') && (*p != '>'))) {
		if(!(f = fopen(p,flag)))
			imext_err(&nfext,2,"open err %d on %s\n",errno,p);
	} else if((*p == '<') && ! mode)
		f = stdin;
	else if((*p == '>') && mode)
		f = stdout;
	if(! f) imext_err(&nfext,9,"openimext : Mauvais arguments \n");
	nfext->file = f;
	return nfext;
}

/* lit n bytes */
int imext_read1(pnf,buf,n)
struct extimage **pnf;
register char *buf;
register n;
{
	register i, nb;
	register char *pc;
	if(n <= 0)
		return 0;
	pc = buf;
	nb = 0;
	while(n > 0) {
		if((i = fread(pc,1,n,(*pnf)->file)) < 0) {
			fermimext(pnf);
			imerror(1,"read err %d\n",errno);
		}
		if(i == 0) break;
		nb += i;
		pc += i;
		n -= i;
	}
	return nb;
}

fermimext(pnf)
register struct extimage **pnf;
{
	register struct extimage *nfext;
	if(!(nfext = *pnf)) return 1 /* makes c99 happy */;
	if(nfext->file == NULL) return 1 /* makes c99 happy */;
	fclose(nfext->file);
	if(nfext->data)
		i_Free((char **)&nfext->data);
	i_Free(&nfext->name);
	if(nfext->cindex)
		i_Free((char **)&nfext->cindex);
	if(nfext->x_params) {
		if(nfext->free_params)
			(*nfext->free_params)(pnf);
		i_Free((char **)&nfext->x_params);
	}
	i_Free((char **)pnf);
}
