/* convrg
	subroutine convrg(a,ndim,nfi,sfi,nfo,sfo)
 convertit l'image nfi,sfi, en l'image nfo,sfo,
   en utilisant le tableau a de ndim mots
   (bit size et types quelconques)
*/

#include <inrimage/image.h>
static Fort_int er7= 7, er8= 8;
static Fort_int nrow, ndima, nrest;
static Fort_int ibsi, ibso;
extern Fort_int ligbit_();

convrg_(a,ndim,pnfi,sfi,pnfo,sfo)
register unsigned char *a;
Fort_int *ndim;
char *sfi, *sfo;
struct image **pnfi, **pnfo;
{
	register struct image *nfi, *nfo;
	register ntot;
	Fort_int icodi[2], lfmt[9], lfmto[9];
	nfi = *pnfi;
	nfo = *pnfo;
	getfmg_(pnfi,sfi,lfmt);
	getfmg_(pnfo,sfo,lfmto);
	c_lptset(nfi,1);
	c_lptset(nfo,1);
	if(DIMX != lfmto[0] || DIMY != lfmto[1])
		ermesf_(&er7);
	icodi[0] = lfmt[2];
	icodi[1] = lfmt[3];
	ligbit_(lfmt,&ibsi);
	ligbit_(lfmto,&ibso);
	if(ibsi < ibso) ibsi = ibso;
	lfmt[3] = 0;
	lfmt[2] = (ibsi + 7) / 8;
	setup_(ndim,lfmt,&nrow,&nrest,&ndima);
	if(nrow <= 0)
		ermesf_(&er8);
	ntot = DIMY;
	while(ntot > 0) {
		if(nrow > ntot) {
			nrow = ntot;
			ndima = DIMX*nrow;
		}
		ntot -= nrow;
		c_lect(nfi,nrow,a);
		c_cnvtbg(a,a,ndima,icodi,&lfmto[2],EXP,lfmto[8]);
		c_ecr(nfo,nrow,a);
	}
}
