C* D2FFT
	SUBROUTINE D2FFT(A1,A2,NDI,NFIR,NFII,NFOR,NFOI,ISFIR,
     :ISFII,ISFOR,ISFOI,FORWAR,NZIP)
C   FFT D'UNE IMAGE REELLE OU COMPLEXE (NFIR,ISFIR= PARTIE REELLE,
C   NFII,ISFII= PARTIE IMAGINAIRE), RESULTAT DANS IMAGES
C   NFOR,ISFOR (PARTIE REELLE) ET NFOI,ISFOI (PARTIE IMAGINAIRE)
C   TABLEAUX DE TRAVAIL A1 ET A2 (POUR PARTIES RELLES ET IMAG.)
C     DE DIMENSION NDI(1) ET NDI(2) MOTS (NDI(1)=NDI(2))
C    FORWAR=.TRUE. SI FFT DIRECTE, .FALSE. SI FFT INVERSE
C   NZIP=.TRUE. SI L'ENTREE EST COMPLEXE (PARTIE IMAGINAIRE NFII,ISFII
C  PRESENTE), .FALSE. SI ELLE EST REELLE (NFII,ISFII IGNORE)
	LOGICAL FORWAR,NZIP
        COMMON /TYPSZ/LGFLT,LGFINT,LGLONG,LGINT,LGINT4,LGPTR,LGALGN
	DIMENSION A1(1),A2(1),NDI(1)
	DIMENSION IFMT(9)
	INTEGER*8 NFIR,NFII,NFOR,NFOI
	INTEGER*8 TRNF,TINF
	INTEGER*2 ISFIR,ISFII,ISFOR,ISFOI,TRSF,TISF
	TRNF=NFIR
	TINF=NFII
	TRSF=ISFIR
	TISF=ISFII
	CALL GETFMG(TRNF,TRSF,IFMT)
	NDIM=NDI(1)
c setup en considerant des images reelles
	IFMT(3)=LGFLT
	ifmt(4)=1
	CALL SETUP(NDIM,IFMT,NRW,IRWRST,NDIMA)
	CALL GETFMG(TRNF,TRSF,IFMT)
	IF(NRW.EQ.0)CALL ERMESF(8)

	NEL1=IFMT(1)
	N2POW=0
	NEL=1
50    NEL=NEL*2
	N2POW=N2POW+1
	IF(NEL-NEL1)50,70,60
60    CALL ERMESF(3)
70    SC=1./(NEL*NEL)
	NEL=NEL-IRWRST
	NRW1=NRW
	NDIMA1=NDIMA
	DO 10 I=1,2
	NDIMA=NDIMA1
	DO 1 J=1,NEL,NRW
	CALL DOD2FF(A1,A2,FORWAR,NZIP,N2POW,NFOR,ISFOR,NFOI,ISFOI
     :,I,TRNF,TRSF,TINF,TISF,NRW,NDIMA,IFMT,SC)
1     CONTINUE
	IF (IRWRST.EQ.0) GO TO 2
	NDIMA=IRWRST*NEL1
	NRW=IRWRST
	CALL DOD2FF(A1,A2,FORWAR,NZIP,N2POW,NFOR,ISFOR,NFOI,ISFOI
     :,I,TRNF,TRSF,TINF,TISF,NRW,NDIMA,IFMT,SC)
	NRW=NRW1
2     CALL LPTSET(NFOR,1)
	CALL LPTSET(NFOI,1)
	IF (I.EQ.2) GO TO 10
	NDIM=2*NDIMA1
	CALL TRANSP(A1,NDIM,NFOR,ISFOR,NFOR,ISFOR)
	CALL TRANSP(A1,NDIM,NFOI,ISFOI,NFOI,ISFOI)
	CALL LPTSET(NFIR,1)
	IF (.NOT.NZIP) GO TO 3
	CALL LPTSET(NFII,1)
3     TRNF=NFOR
	TINF=NFOI
	TRSF=ISFOR
	TISF=ISFOI
	NZIP=.TRUE.
10    CONTINUE
	IER=1
	RETURN
	END
