C* MODIMA
	SUBROUTINE MODIMA(A,NDIS,NLIG1,NDIMX,RALPHA,NIVEAU)
C
C  EFFECTUE UN MOYENNAGE SUR UN VOISINAGE CARRE IMPAIR
C  DE TAILLE (2*NDI1+1)*(2*NDIS+1)AUTOUR DE CHAQUE POINT D'IMAGE
C  UTILISE LE PROGRAMME 'AUGMENTA' QUI CREE UN TABLEAU AGGRANDI
C  A LA SUITE DU TABLEAU INITIAL;DANS CE TABLEAU
C  ON A BORDE LIGNES ET COLONNES EN PROLONGEANT LES BORDS
C  DE L'IMAGE PAR UNE APPROXIMATION D'ORDRE 0.
C
C     A:TABLEAU GLOBAL
C     NDIS :RAYON DU VOISINAGE EN PIXELS
C     NLIG1:NOMBRE DE LIGNES A TRAITER
C     NDIMX:TAILLE EN X DE L'IMAGE ENTREE
C     RALPHA:PARAMETRE DE MOYENNAGE
C     NIVEAU:TABLEAU 256*1 CONTENANT L'HISTOGRAMME DE L'IMAGE
C     MOYENNEE.C
C
C      * ********
C        *      *
C      N *      *
C      L *      *
C      I *      *
C      G *  A   *
C      1 *      *
C      * *      *
C *********      *********
C *       N              *
C *NDIS--*D------*NDIS---*
C *       I              *
C *       S              *
C *       ********       *
C *       *NDIMX *       *
C *     N *      *       *
C *     L *      *       *
C *     I *  A   *       *
C *     G *      *       *
C *     1 *      *       *
C *      ********        *
C *       N              *
C *       D              *
C *       I              *
C *       S              *
C ************************
C
C  POUR TOUT POINT X ,L TRANSFORMEE VAUT Y
C      Y=RALPHA*X+(1-RALPHA)*SOM(X'),X' APPARTIENT
C         AU VOISINAGE CARRE.
	INTEGER A(1),NIVEAU(1)
	NBA=NDIMX*NLIG1
	ND2=2*NDIS
	ALPHAS=(1.-RALPHA)/((ND2+1)*(ND2+1))
	IF(NDIS.GT.0) GOTO 5
C  HISTOGRAMME SIMPLE, SANS MOYENNAGE
	DO 4 K=1,NBA
	CALL ILBYTE(JV,A,K-1)
	NIVEAU(JV+1)=NIVEAU(JV+1)+1
4     CONTINUE
	RETURN
C  HISTOGRAMME APRES MODIFICATION
5     N1=NDIMX+ND2
	K1=NBA+NDIMX+N1*(NLIG1-1)-1
	INITL=0
C   C'EST LE POINT SUPERIEUR GAUCHE DE LA FENETRE DE MOYENNAGE DU DERNIE
C        INITIALISATION DU MOYENNAGE
C      ON EFFECTUE LE MOYENNAGE POUR LE DERNIER
C      POINT EN BAS ET A DROITE DU TABLEAU A.
C      SINITL CONTIENT LA VALEUR DU MOYENNAGE
C      POUR LE POINT PRECEDENT(A DROITE).
C      SINITC CONTIENT LA VALEUR DU MOYENNAGE
C      POUR LE POINT PRECEDENT DE LA DERNIERE
C      COLONNE DU TABLEAU A.(MISE A JOUR A CHAQUE
C      SAUT DE LIGNE)
C  MODIFICATION DU DERNIER POINT
	DO 20 I=1,ND2+1
	I0=(I-1)*N1+ND2
	I1=I0+K1
	DO 10 J=1,ND2+1
	CALL ILBYTE(JV,A,I1)
	INITL=INITL+JV
10    I1=I1-1
20    CONTINUE
	INITC=INITL
	K2=NBA-1
	CALL ILBYTE(JV,A,K2)
	JV=RALPHA*FLOAT(JV)+ALPHAS*FLOAT(INITL)
	IF(JV.LT.0) GOTO 21
	IF(JV.LE.255) GOTO 22
	JV=255
	GOTO 22
21    JV=0
22    CALL ISBYTE(JV,A,K2)
	NIVEAU(JV+1)=NIVEAU(JV+1)+1
C   BOUCLE SUR LES LIGNES
	I=NLIG1
100   J=NDIMX-1
C  BOUCLE SUR LES COLONNES
110   K1=K1-1
	K2=K2-1
	I0=ND2*N1+K1
	DO 91 J1=1,ND2+1
	CALL ILBYTE(JV,A,I0)
	INITL=INITL+JV
	I1=I0+ND2+1
	CALL ILBYTE(JV,A,I1)
	INITL=INITL-JV
91    I0=I0-N1
	CALL ILBYTE(JV,A,K2)
	JV=RALPHA*FLOAT(JV)+ALPHAS*FLOAT(INITL)
	IF(JV.LT.0) GOTO 101
	IF(JV.LE.255) GOTO 102
	JV=255
	GOTO 102
101   JV=0
102   CALL ISBYTE(JV,A,K2)
	NIVEAU(JV+1)=NIVEAU(JV+1)+1
	J=J-1
	IF(J.GT.0) GOTO 110
	I=I-1
	IF(I.LE.0) RETURN
	I0=K1-1
	K1=K1-ND2-1
	K2=K2-1
	DO 92 K=1,ND2+1
	CALL ILBYTE(JV,A,I0)
	INITC=INITC+JV
92    I0=I0-1
	I0=K1+N1*(ND2+1)+ND2
	DO 93 K=1,ND2+1
	CALL ILBYTE(JV,A,I0)
	INITC=INITC-JV
93    I0=I0-1
	INITL=INITC
	CALL ILBYTE(JV,A,K2)
	JV=RALPHA*FLOAT(JV)+ALPHAS*FLOAT(INITL)
	IF(JV.LT.0) GOTO 111
	IF(JV.LE.255)  GOTO 112
	JV=255
	GOTO 112
111   JV=0
112   CALL ISBYTE(JV,A,K2)
	NIVEAU(JV+1)=NIVEAU(JV+1)+1
	GOTO 100
	RETURN
	END
