C* PBLOC
C PROGRAMME PRINCIPALE REALISANT LA CONVOLUTION PAR BLOCS OPTIMISES
C SUIVANT L ALGORITHME DECRIT DANS LA THESE DE R DERICHE
	 SUBROUTINE PBLOC(A,MAXL,NFE,SFE,IFMTE,NFN,SFN,IFMTN,NFS,SFS,
     $IFMTS)
	COMMON /TABVOL/ NVOL
	DIMENSION AMEM(1024),IBIT(1024),MAXL(1),A(1),IFM
     $TE(9),IFMTN(9),IFMTS(9),IFMTO(9),NFIC(3)
	INTEGER*8 NFE,NFN,NFS
	INTEGER*8 NFO,IMAGE
C
	 M1=IFMTE(1)
	 M2=IFMTE(2)
	 L1=IFMTN(1)
	 L2=IFMTN(2)

C   DEFINITION DES VARIABLES DE TRAVAIL
C
	MI=1024
	NMAX=MAXL(1)
C DETERMINATION DES PARAMETRES N1,N2,IB,IBB OPTIMAUX
	CALL PCAPOP(M1,M2,L1,L2,NMAX,N1,N2,IB,IBB,K333,TF,TS,TC,TTO)
	IF(N1.EQ.0.OR.N2.EQ.0) RETURN
	MEMX=1024
	N3=N1-L1+1
	N4=N2-L2+1
	JULO=2*N3
	N2M=N2*(L1-1)
	N2N=N2*N3
	NDEF=2*N1*N2
	IBN=IB*N3
	JUL=2*N2N
	L11=L1/2
	IF(L11*2.NE.L1)L11=L11+1
	L12=L1-L11
	L21=L2/2
	IF(L21*2.NE.L2)L21=L21+1
	L22=L2-L21
C   CALCUL DE LA DIMENSION DU TABLEAU IBIT
	IISSL=M1/(IB*(N1-L1+1))
	IF(IISSL*IB*(N1-L1+1).NE.M1)IISSL=IISSL+1
	IINNE=IISSL*IB*N2/32
	IF((IINNE*32).NE.IISSL*IB*N2)IINNE=IINNE+1
C   CALCUL DE LA DIMENSION DU TABLEAU AMEM
	IIYYTT=IB*(N1-L1+1)
	IF(IIYYTT.LT.N1)IIYYTT=N1
	IF(IIYYTT.LT.2*N2) IIYYTT=2*N2
      IF(IINNE.GT.1024) CALL OUTSTR(0,'LA DIMENSION DE IBIT A ETE FIXE
     %E A 1024 DANS CE PROGRAMME! changer sa dimension $')
      IF(IIYYTT.GT.1024) CALL OUTSTR(0,'LA DIMENSION DE AMEM A ETE FIX
     %EE A 1024 DANS CE PROGRAMME! changer sa dimension $')
	IF(IIYYTT.GT.1024.OR.IINNE.GT.1024) RETURN
C
C   TEST SUR LA CAPACITE DE LA MEMOIRE
C
	IF(NMAX.LT.(NDEF+IB*N2N+3*N2M)) CALL ERMESF(8)
	IF(NMAX.LT.(NDEF+2*N2*N1+N2M+M1)) CALL ERMESF(8)
C
C    LECTURE SUR LE TABLEAU A DU NOYAU DE CONVOLUTION
C
	call zcore(a,n1*n2)
	CALL LPTSET(NFN,1)
	  CALL lecflt(NFN,L2,A(NDEF+1))
C
C   DISPOSITION DES L1*L2 POINTS DU NOYAU DANS UN BLOC
C   DE N1*N2 POINTS EN LE BORDANT DE VALEURS NULLES
C
	    CALL FILQUA(L1,L2,N1,N2,NDEF,A,NMAX)
C
C   CALCUL DE LA FFT DU NOYAU COMPLEXE (PARTIE REELLE:NOY
C   AU DE CONVOLUTION ,PARTIE IMAGINAIRE:BLOC PLEINS DE ZEROS)
C
	CALL PEFFT(A,NMAX,N2,N1,L1,1,0,NDEF,JU
     $L)
C
C   CALCUL DE JOF:NOMBRE DE BOUCLES VERTICALES
C   DEFINITION DE M2MO ET DE IAZ
C
	JOF=M2/N4
	M2MO=M2-(JOF-1)*N4
	IAZ=0
	IF((JOF*N4).EQ.M2)GOTO10
	JOF=JOF+1
	M2MO=M2-(JOF-1)*N4
	IAZ=1
C
C   CALCUL DU NOMBRE D'ITERATIONS HORIZONTALES:IOF
C   DEFINITION DE IFN ET DE IRZ
C
10    IOF=M1/IBN
	IFN=(IOF-1)*IBN
	IRZ=0
	IF((IOF*IBN).EQ.M1) GOTO 15
	IOF=IOF+1
	IFN=(IOF-1)*IBN
	IRZ=1
	IF(IBB.EQ.0) GOTO 15
	IRZ=3
	IF(M1.EQ.(IFN+IBB*N3)) GOTO 15
	IRZ=2
C
C   DEFINITION DU FICHIER INTERMEDIAIRE
C
 15   IFMTO(1)=IBN
	IFMTO(2)=JOF*IOF*2*N4

	ifmto(3) = 4
	ifmto(4) = 1
	nfo = image("/tmp/pblocXXXXXX\0","t ","a ",ifmto)

	  IBZ=0
	 IF((IOF-1)*IBN.LT.M1.AND.(IOF-1)*IBN+L12.GT.M1)IBZ=1
	 ICZ=0
	 IF((JOF-1)*N4.LT.M2.AND.(JOF-1)*N4+L22.GT.M2)ICZ=1
C
C   BOUCLE DE TRAITEMENT VERTICALE
C
	DO 1 J=1,JOF
C
C   MISE A ZERO DES N2*(L1-1) DERNIERS POINTS DE A CONSTITUANTS
C   LA ZONE DE RESERVE
C
	DO 16 I16=1,N2M
	A(NMAX-N2M+I16)=0.
16    CONTINUE
C
C   BOUCLE DE TRAITEMENT HORIZONTALE
C
	DO 1000 I=1,IOF
C
 
C   CALCUL DE IXI(IXI+1:ORDONNEE EN X DE LA 1 ERE DONNEE A LIRE)
C   JXI(ORDONNEE EN Y DE LA 1ERE DONNEE A LIRE),ICC1(DIMENSION EN
C   X DE LA PARTITION DE L'IMAGE A LIRE),ITE(DIMENSION EN Y DE LA
C   PARTITION DE L'IMAGE A LIRE)
C
 
	  CALL PREQUA(I,M1,IOF,M1MO,J,L2,N2,M2,NMAX,JOF,
     %IAZ,IB,IBB,IRZ,L1,A,JXI,NFE,SFE,IFMTE,INB,IXI,N1,NDEF)
C
C   TRANSFORMATION DU BLOC DE N2 LIGNES DE INB*N3 POINTS CHACUNE
C   EN INB BLOCS SEQUENTIELS DE N2 LIGNES DE N3 POINTS CHACUNE
C
	IRET=NDEF+2*N2M
	CALL TRSPOS(A,IRET,N2,N3,INB,IBIT,MI,AMEM,NMAX,MEMX)
C
C   BOUCLE DE TRAITEMENT DES BLOCS DEUX PAR DEUX
C
	DO 29 K29=1,INB/2
C
C   DECALAGE DU 1ER BLOC A TRAITER DE N2*(L1-1) PTS A GAUCHE
C
	IVP=NDEF+N2M+(K29-1)*JUL
	IVP2=IVP+N2M
	DO 30 I30=1,N2N
	A(IVP+I30)=A(IVP2+I30)
30    CONTINUE
C
C   TRANSFORMATION DU 1ER BLOC EN UN BLOC DE N1*N2 PTS
C   GRACE AUX VALEURS DE LA RESERVE
C
	IX=1+(K29-1)*JUL
	CALL COLBLC(A,NMAX,N1,N2,L1,IX,NDEF,N2M,N3)
C
C   MISE A JOUR DE LA RESERVE
C
	CALL METRES(A,NMAX,N1,N2,L1,L2,IX,N2M,NDEF,N3)
C
C   TRANSFORMATION DU 2EME BLOC EN UN BLOC DE N1*N2 PTS
C   GRACE AUX VALEURS DE LA RESERVE
C
	ICE=IX+N1*N2
	CALL COLBLC (A,NMAX,N1,N2,L1,ICE,NDEF,N2M,N3)
C
C   MISE A JOUR DE LA RESERVE
C
	CALL METRES(A,NMAX,N1,N2,L1,L2,ICE,N2M,NDEF,N3)
C
C   CALCUL DE LA FFT DU BLOC COMPLEXE(1ER BLOC:PARTIE
C   REELLE,2EME BLOC:PARTIE IMAGINAIRE)
C
	CALL PEFFT(A,NMAX,N2,N1,L1,K29
     $,1,NDEF,JUL)
C
C   MULTIPLICATION DE LA FFT DU NOYAU AVEC LA FFT DU BLOC COMPLEXE
C
	CALL DEMULC(A,NMAX,N1,N2,L1,L2,K29,JUL,NDEF)
C
C   LE CALCUL DE LA FFT INVERSE NECESSITE LES OPERATIONS
C   SUIVANTES:
C   LE CALCUL DE LA FFT INVERSE NECESSITE LES OPERATIONS
C   SUIVANTES:
C   PRENDRE LA PARTIE CONJUGUEE DU RESULTAT DE LA MULTIPLICATION
C
	CALL DPRTCJ(A,NMAX,N1,N2,L1,K29,JUL,NDEF)
C
C   FFT DU BLOC COMPLEXE OBTENU
C
	CALL PEFFT(A,NMAX,N2,N1,L1,K29
     $,1,NDEF,JUL)
C
C   PRENDRE LA PARTIE CONJUGUEE DU BLOC RESULTAT
C
	CALL DPRTCJ(A,NMAX,N1,N2,L1,K29,JUL,NDEF)
C
C   DERNIERE OPERATION POUR LA FFT INVERSE:DIVISION DES PTS
C   RESULTATS PAR N1*N2
C   POUR FAIRE MOINS D'OPERATIONS CETTE DIVISION NE SE
C   FERA QUE POUR LES PTS JUSTES AVANT LEUR TRANSFERT
C
C   RANGER LES PTS RESULTATS JUSTES
	CALL COLRES(A,NMAX,N1,N2,L1,L2,K29,N3,N4,JUL,NDEF)
29    CONTINUE
C
C   TRANSFORMATION DES INB BLOCS DE N4 LIGNES DE N3 PTS CHACUNE
C   EN UN BLOC DE N4 LIGNES DE INB*N3 PTS CHACUNES
C
	CALL TRSPOS(A,NDEF,INB,N3,N4,IBIT,MI,AMEM,NMAX,MEMX)
	IPP=N1*N2
	INBY=INB*N3*N4
	DO 154 JYT=1,INBY
	A(JYT+NDEF)=A(JYT+NDEF)/IPP
154   CONTINUE
C
C   TRANSFERT DES RESULTATS DANS LE FICHIER INTERMEDIAIRE
C
C   DEFINITION DE IXM1(DIMENSION EN X ,POUR I=IOF,DE LA PARTIE
C   A TRANSFERER),INL(NOMBRE DE LIGNES A TRANSFERER)
C   IPR1,IPR2,IPR3 DEFINISSENT L'ALGORITHME DE TRANSFERT
C
	IPR1=0
	IPR2=0
	IPR3=0
	KPRC1=0
	KPRC2=0
	KPRC3=0
	IF(IBB.EQ.0) GOTO 33
	IF(IB.EQ.IBB) GOTO 33
	IF(IBB.EQ.2) GOTO 34
	IPR3=1
	IXM1=IBB*N3
	INL=NMAX/(IXM1+IFN)
	GOTO 35
33    IF(IB.GT.2) GOTO 36
	IF((M1-IFN).GE.N3) GOTO 36
34    IPR1=1
	IXM1=M1-IFN
	INL=NMAX/(M1+IXM1)
	GOTO 35
36    IPR2=1
	IXM1=IBN
	INL=NMAX/(IOF*IBN)
35    CONTINUE
	CALL TXEST(INL,N4,M2MO,KPRC1,KPRC2,KPRC3)
	IF(I.NE.IOF) GOTO 37
	IF(IRZ.EQ.1) GOTO 38
	IF(IRZ.EQ.2)GOTO 38
	GOTO 37
38    IF(IPR1.NE.1) GOTO 37
C   ARANGER LE BLOC DE N4 LIGNES DE INB*N3 PTS EN UN
C   BLOC DE N4 LIGNES DE IXM1 PTS JUSTES SEULEMENT A TRANSFERER
C
	KJV=N2-L2
	IF(J.EQ.JOF)KJV=M2-JXI
	DO 3900 J39=1,KJV
	DO 39 I39=1+NDEF,NDEF+IXM1
	A(J39*IXM1+I39)=A(J39*INB*N3+I39)
39    CONTINUE
3900  CONTINUE
C
C   CALCUL DE NDLIGN:NOMBRE DE LIGNES A TRANSFERER A CHAQUE COUP
C   DE A VERS LE FICHIER INTERMEDIAIRE,IPNTO:POSITION
C   DU POINTEUR D'ECRITURE
C   TRANSFERT DES RESULTATS
C
37    KN3=N4/INL
	IF((KN3*INL).NE.N4) KN3=KN3+1
	KN4=M2MO/INL
	IF((KN4*INL).NE.M2MO) KN4=KN4+1
	IF(KPRC1.EQ.1) GOTO 890
	IF(KPRC2.EQ.1) GOTO 891
	GOTO 892
890   KN3=1
891   KN4=1
892   KNT=N4
	IF(J.EQ.JOF)KNT=M2MO
	KN=KNT/INL
	IF((KN*INL).NE.KNT)KN=KN+1
	NDL2=INL*IXM1/IBN
	IF((NDL2*IBN).NE.(INL*IXM1)) NDL2=NDL2+1
	NDL4=(N4-(KN3-1)*INL)*IXM1/IBN
	IF((NDL4*IBN).NE.((N4-(KN3-1)*INL)*IXM1)) NDL4=NDL4+1
	NDL6=(M2MO-(KN4-1)*INL)*IXM1/IBN
	IF((NDL6*IBN).NE.((M2MO-(KN4-1)*INL)*IXM1))NDL6=NDL6+1
	DO 40 I40=1,KN
	IPNTO=1+(J-1)*INL*IOF*KN3+(I-1)*INL+(I40-1)*IOF*INL
	NDLIGN=INL
	IF(I.EQ.IOF)GOTO 42
	IF(((J-JOF).NE.0).AND.(I40.EQ.KN)) NDLIGN=N4-(KN3-1)*INL
	IF((J.EQ.JOF).AND.(I40.EQ.KN)) NDLIGN=M2MO-(KN4-1)*INL
	GOTO 41
42    NDLIGN=NDL2
	IF(((J-JOF).NE.0).AND.(I40.EQ.KN)) NDLIGN=NDL4
	IF((J.EQ.JOF).AND.(I40.EQ.KN)) NDLIGN=NDL6
41    KC=IBN
	IF(I.EQ.IOF)KC=IXM1
	IT=NDEF+(I40-1)*INL*KC+1
	CALL LPTSET(NFO,IPNTO)
	CALL ECR(NFO,NDLIGN,A(IT))
40    CONTINUE
1000  CONTINUE
1     CONTINUE
C
C
C   LA SECONDE GRANDE ETAPE DE CET ALGORITHME COMMENCE ICI.
C   LES RESULTATS ETANTS RANGES DANS LE FICHIER INTERMEDIAIRE,
C   IL S'AGIT MAINTENANT DE LES ARANGER ET DE LES SORTIR
C   DANS L'IMAGE DE RECEPTION
C
	DO 60 J=1,JOF
	IF((KPRC1+KPRC2+KPRC3).NE.1) CALL ERMESF(61)
	NBLIGO=INL*(IFN+IXM1)/IBN
	IF((NBLIGO*IBN).NE.(INL*(IFN+IXM1))) NBLIGO=NBLIGO+1
	KNT=N4
	IF(J.EQ.JOF) KNT=M2MO
	KN=KNT/INL
	IF((KN*INL).NE.KNT)KN=KN+1
	DO 601 IS=1,KN
C
C   LECTURE DES RESULTATS SE TROUVANT DANS LE FICHIER INTER
C   MEDIAIRE(NBLIGO=NOMBRE DE LIGNES A LIRE,IPNTO=POSITIONNEMENT
C   DU POINTEUR DE LECTURE)
C
	IF(KPRC1.EQ.1)GOTO 758
	IPNTO=1+IOF*INL*(IS-1)+(J-1)*IOF*INL*KN3
	IF(IS.NE.KN) GOTO 74
	IT=0
	DO 70 IK=1,IOF
	IPNTO=1+(IK-1)*INL+(KN-1)*IOF*INL+(J-1)*IOF*INL*KN3
	NBLIGO=KNT-(KN-1)*INL
	NBLIGA=(IXM1*(KNT-(KN-1)*INL))/IBN
	IF((NBLIGA*IBN).NE.(IXM1*(KNT-(KN-1)*INL)))
     $NBLIGA=NBLIGA+1
	IF(IK.EQ.IOF)NBLIGO=NBLIGA
	CALL LPTSET(NFO,IPNTO)
	CALL LECT(NFO,NBLIGO,A(IT+1))
	IT=IK*NBLIGO*IBN
70    CONTINUE
	GOTO 759
74    CONTINUE
	CALL LPTSET(NFO,IPNTO)
	CALL LECT(NFO,NBLIGO,A)
	GOTO 759
758   NBLIGO=N4*(IFN+IXM1)/IBN
	IF((NBLIGO*IBN).NE.(N4*(IFN+IXM1))) NBLIGO=NBLIGO+1
	IPNTO=1+(J-1)*IOF*N4
	IF((J-JOF).NE.0) GOTO 74
	IT=0
	DO 951 IL=1,IOF
	IPNTO=1+(JOF-1)*IOF*N4+(IL-1)*N4
	NBLIGO=M2MO
	NBLIGA=(M2MO*IXM1)/IBN
	IF((NBLIGA*IBN).NE.(M2MO*IXM1)) NBLIGA=NBLIGA+1
	IF(IL.EQ.IOF) NBLIGO=NBLIGA
	CALL LPTSET(NFO,IPNTO)
	CALL LECT(NFO,NBLIGO,A(IT+1))
	IT=IL*NBLIGO*IBN
951   CONTINUE
C
C   ARANGEMENT DES RESULTATS ET SORTIE SUR L'IMAGE DE RECEPTION
C
C
C   CALCUL DU NOMBRE DE LIGNES NBLIGS A POUVOIR ECRIRE EN SORTIE
C
759   IF(J.EQ.JOF) GOTO 931
	NBLIGS=INL
	IF((KPRC2.EQ.1).AND.(IS.EQ.KN)) NBLIGS=N4-(KN-1)*INL
	IF((KPRC3.EQ.1).AND.(IS.EQ.KN))NBLIGS=N4-(KN-1)*INL
	GOTO 932
931   NBLIGS=M2MO
	IF((KPRC3.EQ.1).AND.(IS.NE.KN))NBLIGS=INL
	IF((KPRC3.EQ.1).AND.(IS.EQ.KN))NBLIGS=M2MO-(KN-1)*INL
C
C   TRANSFERT DES RESULTATS
C
C   TRANSFERT POUR IPR1=1
C
932   IF((IPR2+IPR3).NE.0) GOTO 80
	IF(IPR1.NE.1) CALL ERMESF(9)
	IF(IRZ.EQ.0) GOTO 90
C
C   TRANSPOSITION DES (IOF-1) GRANDS BLOCS POUR FORMER UN BLOC
C   DE NBLIGS LIGNES DE (IOF-1)*IB*N3 PTS
C
	IF(IOF.EQ.2) GOTO 956
	CALL TRSPOS(A,0,IOF-1,IBN,NBLIGS,IBIT,MI,AMEM,NMAX,MEMX)
C
C   ARANGEMENT DES RESULTATS
C
956   IV65=NMAX-NBLIGS*IXM1
	IV6=IFN*NBLIGS
	DO 6500 J65=1,NBLIGS
	IVA6=IV65+(J65-1)*IXM1
	IVT6=IV6+(J65-1)*IXM1
	DO 65 I65=1,IXM1
	A(I65+IVA6)=A(I65+IVT6)
65    CONTINUE
6500  CONTINUE
	DO 6600 J66=1,NBLIGS
	IV66=M1*(NBLIGS-J66+1)-IXM1
	IVW=IFN*(NBLIGS-J66+1)+1
	IV77=NMAX-IXM1*J66
	DO 77 I77=1,IXM1
	A(IV66+I77)=A(IV77+I77)
77    CONTINUE
	NWQX=IV66
	NWQY=IVW-1
	DO 66 I66=1,IFN
	A(NWQX)=A(NWQY)
	NWQX=NWQX-1
	NWQY=NWQY-1
66    CONTINUE
6600  CONTINUE
	GOTO 888
C
C   TRANSPOSITION DES IOF GRANDS BLOCS
C
90    CONTINUE
	CALL TRSPOS(A,0,IOF,IBN,NBLIGS,IBIT,MI,AMEM,NMAX,MEMX)
	GOTO 888
C
C   TRANSFERT POUR IPR2=1
C
80    IF((IPR1+IPR3).NE.0) GOTO 81
	IF(IPR2.NE.1) CALL ERMESF(9)
C
C   TRANSPOSITION DES IOF GRANDS BLOCS EN UN BLOC
C
	CALL TRSPOS(A,0,IOF,IBN,NBLIGS,IBIT,MI,AMEM,NMAX,MEMX)
	IF(IRZ.EQ.0) GOTO 888
C
C   ARANGEMENT DES RESULTATS
C
	DO 1001 J10=1,NBLIGS
	IV10=(J10-1)*M1
	IV1L=(J10-1)*IOF*IBN
	DO 100 I10=1,M1
	A(I10+IV10)=A(I10+IV1L)
100   CONTINUE
1001  CONTINUE
	GOTO 888
C
C   TRANSFERT DES RESULTATS POUR IPR3=1
C
81    CONTINUE
	IF((IPR1+IPR2).NE.0) CALL ERMESF(9)
	IF(IPR3.NE.1) CALL ERMESF(9)
	IFOIS=IB/IBB
	IF((IFOIS*IBB).EQ.IB) GOTO 120
C
C   TRANSPOSITION DES IOF GRANDS BLOCS EN DES BLOCS DE TAILLES EN X
C   2*N3 POINTS
C
	DO 110 I11=1,IOF
	IRET=(I11-1)*IBN*NBLIGS
	IBON=IB/2
	IF(I11.EQ.IOF) IBON=IBB/2
	CALL TRSPOS(A,IRET,NBLIGS,JULO,IBON,IBIT,MI,AMEM,
     $NMAX,MEMX)
110   CONTINUE
C
C   TRANSPOSITION GENERALE POUR LA SORTIE
C
	JAL=(IOF-1)*IB/2+(IBB/2)
	CALL TRSPOS(A,0,JAL,JULO,NBLIGS,IBIT,MI,AMEM,NMAX,MEMX)
	GOTO 130
C
C   TRANSPOSITION DES IOF-1 GRANDS BLOCS EN DES BLOCS DE
C   TAILLE EN X IBB*N3 POINTS
C
120   CONTINUE
	DO 140 I14=1,IOF-1
	IRET=(I14-1)*IBN*NBLIGS
	IBW=IBB*N3
	CALL TRSPOS(A,IRET, NBLIGS,IBW,IFOIS,IBIT,MI,
     $AMEM,NMAX,MEMX)
140   CONTINUE
C
C   TRANSPOSITION GENERALE POUR LA SORTIE
C
	ITS=(IOF-1)*IFOIS+1
	ITB=IBB*N3
	CALL TRSPOS(A,0,ITS,ITB,NBLIGS,IBIT,MI,AMEM,NMAX,MEMX)
C
C   ARANGEMENT DES RESULTATS
C
130   CONTINUE
	DO 1601 J16=1,NBLIGS
	IV16=(J16-1)*M1
	IV26=(J16-1)*(IFN+IBB*N3)
	DO 160 I16=1,M1
	A(I16+IV16)=A(I16+IV26)
160   CONTINUE
1601  CONTINUE
C
C   ECRITURE DES RESULTATS  DANS L'IMAGE DE SORTIE
C
888   IPNTS=1+(J-1)*N4+(IS-1)*INL
	CALL LPTSET(NFS,IPNTS)
	CALL ECR(NFS,NBLIGS,A)
601   CONTINUE
60    CONTINUE
	CALL FPANIC
	CALL rmnf(nfo)
	RETURN
	END
