C* REXP
	SUBROUTINE REXP(E1,E2,EO,NB1,NB2,NBO,ISH1,ISH2,NS,NTYP)
C  REXP DETERMINE EN FONCTION DE L'OPERATION NTYP L'EXPOSANT
C  ET LA BIT SIZE DU RESULTAT,AINSI QUE LES DECALAGES A
C  EFFECTUER SUR LES IMAGES D'ENTREE
C       E1,E2,EO:EXPOSANTS
C       NB1,NB2,NBO:BIT SIZES
C       NTYP:CODE OPERATION(0 A 5)
C       ISH1,ISH2:VALEURS DES DECALAGES
C            ISH NEGATIF:DECALAGE VERS LA DROITE
C            ISH POSITIF:DECALAGE VERS LA GAUCHE
C       NS=1:SIGNE,NS=0:SANS SIGNE
C
	INTEGER E1,E2,EO
	NTYP=NTYP+1
	GO TO (10,10,30,40,50,50),NTYP
C  ADDITION ET SOUSTRACTION
10    ND=E1-E2
	IF((ND.EQ.0).AND.(NB1+NB2).EQ.64) GO TO 17
	IF(ND)11,12,12
11    EO=E2
	ISH1=ND
	GO TO 13
12    EO=E1
	ISH2=-ND
13    L=MAX0(NB1+ISH1,NB2+ISH2)
	IF(L.LT.32) GO TO 14
	EO=EO+1
	ISH1=ISH1-1
	ISH2=ISH2-1
14    NBO=MIN0(32,L+1)
	RETURN
C
17    ISH1=-2
	ISH2=-2
	NBO=32
	EO=E1+2
	RETURN
C
C  MULTIPLICATION
30    NBO=NB1+NB2-1
	IF(NBO.LE.32) GO TO 31
C   CAS OU  LE RESULTAT NE TIENT PAS SUR 32 BITS
	ISH1=MIN0(0,16-NB1)
	ISH2=MIN0(0,16-NB2)
	NBO=31
31    EO=E1-ISH1+E2-ISH2-200
	RETURN
C
C  DIVISION
40    ISH1=32-NB1
	EO=E1-E2-ISH1+200
	NBO=32
	RETURN
C
C  MINIMUM  ET MAX0IMUM
50    IF(NS.EQ.0) GO TO 54
	EO=MAX0(E1,E2)
	IF(E1-E2) 52,51,53
51    NBO=MAX0(NB1,NB2)
	RETURN
52    NBO=MAX0(NB2,NB1-E2+E1+1)
	ISH1=E1-E2
	RETURN
53    NBO=MAX0(NB1,NB2-E1+E2+1)
	ISH2=E2-E1
	RETURN
54    IF(NTYP.EQ.6) GO TO 58
C  MIMNIMUM SANS SIGNE
	IF(E1-E2)60,59,55
60    EO=E1
	NBO=MIN0(NB1,NB2-E1+E2 )
	ISH2=E2-E1
	RETURN
55    EO=E2
	NBO=MIN0(NB2,NB1+E1-E2)
	ISH1=E1-E2
	RETURN
59    NBO=MIN0(NB1,NB2)
	EO=E2
	RETURN
58    IF(E1-E2) 61,56,57
C  MAXIMUM SANS SIGNE
61    EO=E2
	NBO=MAX0(NB1+E1-E2+1,NB2)
	ISH1=E1-E2
	RETURN
56    EO=E2
	NBO=MAX0(NB1,NB2)
	RETURN
57    EO=E1
	NBO=MAX0(NB2+E2-E1+1,NB1)
	ISH2=E2-E1
	RETURN
	END
