/* procedure de test de validite du descripteur d'image inrimage */

/* retourne 0 si ok
	1 si correct mais taille fichier trop petite 
	2 si descripteur incorrect
*/
#include <inrimage/inrfile.h>

#define	MMM	0x40
#define COMMENT	0x20
#define F_MASK (FLOAT | MMM | COMMENT | BITS | PACKED)

i3desc_test(desc,taille)
struct descripteur *desc;	/* tableau contenant le descripteur */
{
	int n;
	if (desc->dimx <= 0 ||
		desc->ndimx <= 0 || desc->ndimy <= 0 ||
		desc->ndimv <= 0 || desc->ndimz <= 0) return 2;
	if (desc->dimx != (desc->ndimx * desc->ndimv)) return 2;
	if (desc->bsize <= 0 || desc->bsize >32) return 2;
	if(desc->flag & ~F_MASK) return 2;
	if(desc->im_magic != 0 && desc->im_magic != IM3_MAGIC) return 2;
	if(desc->res[0] != 0) return 2;
	if (desc->flag & BITS)
		n= (desc->flag & PACKED ? desc->bsize :
				((desc->bsize + 7) & ~07));
	else n = desc->bsize * 8;
	
	if(taille <= DESC) return 0;  /* on ne connait pas la taille (pipe par ex.)*/
	if(taille < (DESC+((n * desc->dimx * desc->ndimy * desc->ndimz + 7) >> 3)))
		return 1;
	else  return 0;
}
