/* hxdonn
	subroutine hxdonn(chain,i0,i2,i,ier)
	c_hxdonn(chain,i0,i2,ier)
   decode la chaine de carac. contenue dans chain des octets i0 a i2
   sous forme hexadecimale et renvoie le resultat dans i ou comme valeur de c_hxdonn
  ier=1 si caractere incorrect
   i0 et i2 comptes a partir de 1 dans hxdonn, et de 0 dans c_hxdonn
*/

#include <inrimage/image.h>
#include <ctype.h>

hxdonn_(chain,i0,i2,i,ier)
char *chain;
Fort_int *i0, *i2, *i, *ier;
{
	*i = c_hxdonn(chain,(int)(*i0 -1),(int)(*i2 -1),ier);
}

int c_hxdonn(chain,i0,i2,ier)
register char *chain;
register int i0, i2;
register Fort_int *ier;
{
	register i, c;
	register char *pend;
	i = 0;
	*ier = 0;
	if(i0 > i2 || i0 < 0) return 0;
	pend = chain + (i2 - i0);
	while (chain <= pend) {
		if((c = *chain++) == 0) break;
		if(!isxdigit(c)) {
			*ier = 1;
			return i;
		}
		if(isdigit(c))
			c &= 0xf;
		else
			c = (c & 0xf) + 9;
		i = (i << 4) + c;
	}
	return i;
}
