/* 
  function iempty(nf)
  int c_iempty(nf) struct image *nf;

  determine si un fichier image est vide (sans data)
retourne 0 si non vide
	1 si vide
	-1 si erreur ou seek impossible
*/

#include <sys/types.h>
#include <inrimage/image.h>
extern off_t lseek();

int iempty_(nf)
struct image **nf;
{
	return c_iempty(*nf);
}

c_iempty(nf)
struct image *nf;
{
	register off_t i, pos;
	if((pos = lseek(nf->fd,(off_t)0,1)) < 0) return -1;  /* keep current position */
	i = lseek(nf->fd,(off_t)0,2);
	if(i < 0) return -1;
	lseek(nf->fd,(off_t)pos,0);
	if(i == 0 || i <= nf->desc_size) return 1;
	return 0;
}
