/*
C*IQUEL    
	FUNCTION IQUEL(ICMD,BRK,NBRK,IH)
	FUNCTION IQUEL1(ICMD,BRK,NBRK,IH)
	int cmdget(cmdtab,prompt)
	int cmdget1(cmdtab,prompt)
	struct cmdtab *cmdtab; char *prompt;

  reconnaisseurs de commandes
IQUEL, IQUEL1 :
 imprime le "herald char." cadre a gauche dans ih
 lit une chaine de car. terminee par l'un des nbrk breaks de brk
 puis recherche si elle correspond a une commande de icmd
 les commandes "?" et "??" provoquent le listing de 20 commandes
  de icmd (en commencant au debut si "??")
 commande vide ignoree , message "?" si cmde inconnue et attente
 nouvelle cmde (mais err 6111 en macro)
  complete la commande si arret par espace
  IQUEL1 si on ne desire pas de passage a la ligne

cmdget, cmdget1 : la liste des break est imposee (espace et return),
 et le prompt est une chaines terminees par 0;
cmdtab est une structure (struct cmdtab: voir dialog.h)
cmdget1, comme iquel1 ne passe pas a la ligne et retourne 0 si cmde vide

   notes : si mrkcd#0 dans /mmacro/ (1/2 mot 39), alors il contient le
        caractere de fin de phrase de commande : iquel (mais pas iquel1
          et en mode macro "vrai" seulement (pas semi-interactif),
        ignore tous les caracteres jusqu'au prochain car. mrkcd (2e oct
        mrkcd), en sautant les commentaires.
        si la commande est suivie de "?", alors on met a 1 istpti de /d
*/

/*	integer*2 ih,icmd(1),brk(1),jpt,brkch,ibuf,imac,ilgmac,nmmac,ires
	integer*2 mrkcd
	common /codcar/ibrk,iretc,ilf,ibell,ictra,ictrb,ictrc,iblan
     1,IBACK,IPV,IDOLL,IADS,IEXCN,INFR,ISLSH,IPLUS,IMOINS,ISTAR
     2,IEGAL,IPOINT,I2P,IC0,IC9,ICA,ICZ,ICPA,ICPZ,IPTI,MBCK,NCRLF
	COMMON /DIALG/ NBCHR,NUMBRK,ICRBRK,LIGBUF(21),ISTPTI,IFLMIN
	COMMON /SCBUFF/IBUF(130)
	COMMON/MMACRO/IMAC(38),MRKCD,IRES(3),ITBETQ(48),ITABVD(300),
     !ILGMAC(7),NMMAC(21),MACRF(3)
*/

#include <inrimage/image.h>
#include <inrimage/dialog.h>

static int nprog= 41;
static void list_fincmd();

static Fort_int is1=0, is2= 0, brkch;
static CHAR *idb;
#define LG_INP 80
static char ibuf[LG_INP];
extern struct dialg dialg_;
extern struct mmacro mmacro_;
static char prpt[]= "  ";

Fort_int iquel_(icmd,brk,nbrk,ih)
CHAR *icmd, *brk, *ih;
Fort_int *nbrk;
{
	prpt[0] = *ih;
	return (Fort_int)get_cmde(0,0,icmd,brk,(int)*nbrk,prpt);
}

Fort_int iquel1_(icmd,brk,nbrk,ih)
CHAR *icmd, *brk, *ih;
Fort_int *nbrk;
{
	prpt[0] = *ih;
	return (Fort_int)get_cmde(1,0,icmd,brk,(int)*nbrk,prpt);
}

static char defbrk[]= "\r \t";
#define NBRK 3

cmdget(cmd,prompt)
register struct cmdtab *cmd;
register CHAR *prompt;
{
	return get_cmde(0,1,(CHAR *)cmd,defbrk,NBRK,prompt);
}

cmdget1(cmd,prompt)
register struct cmdtab *cmd;
register CHAR *prompt;
{
	return get_cmde(1,1,(CHAR *)cmd,defbrk,NBRK,prompt);
}

get_cmde(icrlf,type,cmd,brk,nbrk,prompt)
int icrlf, type;
register CHAR *cmd, *brk, *prompt;
register nbrk;
{
	register nch, numc;
	int flag;
redo:	is1 = is2 = 0;
	c_outstr(icrlf,prompt);
	dialg_.istpti = 0;
	while((nch = c_ltchai(ibuf,LG_INP-1,brk,nbrk,(char *)&brkch)) == 0) {
		/* ignorer cmde vide pour iquel, return pour iquel1 */
		if(icrlf == 1) return 0;
	}
	flag = type > 0 ? 0x80 : 0;
	if(ibuf[0] == '?') {  /* list cmdes ? */
		if(nch == 1) {  /* list 20 next ones */
			c_lstcmd(cmd,flag);
			goto redo;
		} else if(nch == 2 && ibuf[1] == '?') {  /* list from begining */
			c_lstcmd(cmd,flag + 1);
			goto redo;
		}
	}
	if(ibuf[nch-1] == '?') {
		dialg_.istpti = 1;
		nch--;
	}
	ibuf[nch] = 0;  /* forcer 0 en fin de chaine */
	if((numc =find_cmd(type,cmd,ibuf,nch,&idb)) != 0) {
		/* lister fin cmde si break= Sp ou \t */
		if(dialg_.icrbrk == ' ')
			list_fincmd(0,idb);
		else if (dialg_.icrbrk == '\t')
			list_fincmd(ibuf,idb);
		return numc;
	}
	if(mmacro_.imac[0] > 0) {
		is1= 11 + 100 * nprog;
		ermess_(&is1,&is2);
	}
	c_outstr(1,"?");
	goto redo;
}

static void list_fincmd(deb,cmd)
register unsigned char *deb, *cmd;
{
	register i, c;
	char ibufo[LG_INP];
	if(deb != (unsigned char *) 0) {
		ibufo[0] = '\r';
		for(i=1;i<LG_INP-1;i++) {
			if((c = *deb++) == 0) break;
			ibufo[i] = c;
		}
	} else {
		ibufo[0] = '\b';
		i = 1;
	}
	for(;i<LG_INP-1;i++) {
		c = *cmd++;
		if(c == 0 || c == 255) break;
		ibufo[i] = c;
	}
	ibufo[i++] = ' ';
	ibufo[i] = 0;
	c_outstr(1,ibufo);
}
