/*
C*LSTCMD
	SUBROUTINE LSTCMD(ICMD,IOP)
	c_lstcmd(icmd,iop)
	char *icmd; int iop;
 listing (par outstr) de 20 commande de la table ICMD
 on repart du debut si IOP=0 ou si l'adresse de ICMD a changee
si IOP contient 0x80, ICMD est de type struct cmdtab, pour c_lstcmd seulement
*/

#include <inrimage/image.h>
#include <inrimage/dialog.h>

static unsigned char *oldcmd = (unsigned char *) 0;
static unsigned char *lastcmd= (unsigned char *) 0;
#define NBLIG 20

lstcmd_(icmd,iop)
register unsigned char *icmd;
register Fort_int *iop;
{
	c_lstcmd(icmd,(int)*iop & ~0x80);
}

c_lstcmd(icmd,iop)
unsigned char *icmd;
register iop;
{
	register unsigned char *pc;
	register struct cmdtab *pcm;
	register nbl, n;
	int flag;
	flag = iop & 0x80;
	iop &= ~0x80;
	if(iop == 0)
		if(oldcmd != icmd)
			iop = 1;
	if(iop == 1) {
		oldcmd = icmd;
		lastcmd = icmd;
	}
	if(lastcmd == icmd)
		c_outstr(0,"commandes : ");
	nbl = 0;
	while (1) {
		if(flag == 0) {
			pc = lastcmd;
			while(1) {  /* chercher nb car min. */
				if(*pc == 0 || *pc == 255) break;
				pc++;
			}
			n = *(++pc);
			prt_cmde1(lastcmd,n);
			lastcmd = pc + 1;
			if(*(pc-1) == 255) {
				lastcmd= icmd;
				return 1 /* makes c99 happy */; 
			}
		} else {
			pcm = (struct cmdtab *) lastcmd;
			n = pcm->nbmin;
			prt_cmde1(pcm->cmd,n);
			pcm++;
			if(pcm->cmd == (char *) 0) {
				lastcmd = icmd;
				return 1 /* makes c99 happy */; 
			}
			lastcmd = (CHAR *)pcm;
		}
		nbl++;
		if(nbl >= NBLIG) {
		  c_outstr( 0, "? pour voir davantage de commandes.");
		  return 1 /* makes c99 happy */; 
		}
	}
}

prt_cmde1(pc,n)
register CHAR *pc;
register n;
{
	register CHAR *pb;
	register i, c;
	unsigned char buf[80];
	pb = buf;
	i = 0;
	while(1) {
		c = *pc++;
		if(c == 0 || c == 255) break;
		if(i == n)
			*pb++ = '[';
		*pb++ = c;
		i++;
	}
	if(i > n)
		*pb++ = ']';
	*pb++ = ' ';
	*pb = 0;
	c_outstr(0,buf);
}


/*
	COMMON /CODCAR/IBRK,IRETC,ILF,IBELL,ICTRA,ICTRB,ICTRC,IBLAN
     1,IBACK,IPV,IDOLL,IADS,IEXCN,INFR,ISLSH,IPLUS,IMOINS,ISTAR
     2,IEGAL,IPOINT,I2P,IC0,IC9,ICA,ICZ,ICPA,ICPZ
	DATA IOLD/0/,IND/0/
	IADR=ADRESS(ICMD)
	IF(IOP.EQ.0) GO TO 10
	IF(IADR.EQ.IOLD)GO TO 40
10      IOLD=IADR
	IND=0
40    NBL=0
	IF(IND.GT.0) GO TO 45
	CALL OUTSTR(0,'LES COMMANDES SONT: $')
	NBL=1
45    J=0
46    CALL ILBYTE(J2,ICMD,IND)
	IF(J2.EQ.0.OR.J2.EQ.255)GO TO 50
	CALL ISBYTE(J2,IBUF,J)
	J=J+1
	IND=IND+1
	IF(J.GE.80)GO TO 47
	GO TO 46
47    IND=IND+1
	CALL ILBYTE(J2,ICMD,IND)
	IF(J2.NE.0.AND.J2.NE.255)GO TO 47
50    IND=IND+1
	CALL ILBYTE(N,ICMD,IND)
	IND=IND+1
	IF(N.GE.J)N=J
	J0=N+1
	J1=J0+1
	NBYT=J-N
	CALL MVBYTE(IBUF,IBUF,J0,J1,NBYT)
	CALL ISBYTE(ISLSH,IBUF,J0-1)
	CALL ISBYTE(IBLAN,IBUF,J+1)
	CALL ISBYTE(IDOLL,IBUF,J+2)
	CALL OUTSTR(0,IBUF)
	NBL=NBL+1
	IF(J2.EQ.255)GO TO 60
	IF(NBL.LT.20) GO TO 45
	RETURN
60    IND=0
	RETURN
	END
*/
