/*
C*FDNOUV
	SUBROUTINE FDNOUV(N,ITAIL,ITYP,IFD,LU)
C  ASSIGNE LE FICHIER IFD A UNE U.L.
C  DU POOL RENVOYEE DANS LU ET PLACEE DANS LE MOT N DE /UNITES/
C  ITYP=1 : ASSIGNATION SIMPLE (SRW), ITYP=2 : CREATION+ ASSIGN
C  ITYP=3 : DEL+CREAT+ASSIGN (DEL ET CREAT SANS ERR.)
C  ITYP+4 SI ASSIGNATION LONGUE (NON FERMEE PAR ERREUR)
C  ITYP+8 SI ASSIGNATION PROTEGEE EN MACRO (IDEM ASS. LONGUE TANT
C  QU'ON RESTE EN MODE MACRO ACTIF, MAIS PAS EN SEMI-INTERACTIF)
C  FERMETURE AVANT ASSIGN
C  ITAIL=TAILLE ENREG. LOGIQUE FICHIER IN SI >0, -TAILLE FICHIER
C  CO SI <0 ???????
*/
#include <stdio.h>
#include <inrimage/image.h>


extern debug_;
extern struct unites unites_;
extern int errno;


fdnouv_(n,itail,ityp,ifd,lu)
Fort_int *n,*itail,*ityp,*lu;
char ifd[];
{
	char nom[80];
	int i, is1= 2, er9= 9;

	if ( *n <= 0 || *n > 16 )
		{
		fprintf(stderr,"%s fdnouv:numero errone(%d)\n",xargv[0],*n);
		ermesf_(&er9);
		}


	closef_(n);
	for ( i = 0 ; i < 80 ; ++i )
		if ( ifd[i] == ' ' )
			{
			nom[i] = '\0';
			break;
			}
		else
			{
			nom[i] = ifd[i];
			}

	if (debug_) fprintf(stderr,"%s fdnouv:ouverture de %s , type=%d ",xargv[0],
				nom,*ityp);

	switch ( *ityp & 0x3 )
		{
		case 1: /* ouverture en i/o ou en lecture */
		if (debug_) fprintf(stderr,"%s en io ",xargv[0]);
		if ( (*lu = unites_.lus[*n-1] = open(nom,2) ) == -1 )
			{
			if (debug_) fprintf(stderr,"%s en in ",xargv[0]);
			if ( (*lu = unites_.lus[*n-1] = open(nom,0) ) == -1 )
			  {
err2:			  fprintf(stderr,"%s fdnouv:probleme avec %s\n",xargv[0],nom);
			  perror("fdnouv");
			  ermess_(&is1,&errno);
			  }			
			}
		break;

		case 2: /* ouverture en creation */
		case 3:
		if ( (*lu = unites_.lus[*n - 1] = creat(nom,PMODE) ) == -1 )
			{
			if (debug_) fprintf(stderr,"%s en creation ",xargv[0]);
				goto err2;
			}
		close(*lu);
		*lu = unites_.lus[*n -1] = open(nom,2);
		break;

		default:
			fprintf(stderr,"%s fdnouv:probleme avec %s\n",xargv[0],nom);
			fprintf(stderr,"%s fdnouv:%d ouverture non prevue\n",xargv[0],
								*ityp);
			ermesf_(&er9);

		}

	if (debug_) fprintf(stderr,"%s fd=%d\n",xargv[0],unites_.lus[*n - 1] );

}
