C*WRBINP
      SUBROUTINE WRBINP(LU,ADTAB,N,IBS,IBUF)
C  ECRITURE BINAIRE : ON ECRIT, SUR L'UNITE LOGIQUE LU,
C   LES N TERMES DU TABLEAU DONT L'adresse EST DONNEE PAR ADTAB, ET CODES
C    SUR IBS OCTETS CHACUN.
C  (IBS=1 POUR CARACTERES, 2 POUR INTEGER*2, 4 POUR INTEGER OU
C   REELS SIMPLE PRECISION, 8 POUR DOUBLE PRECISION, PAR EXEMPLE).
C   IBUF EST UN TABLEAU DE TRAVAIL : LE PREMIER MOT DOIT CONTENIR
C   LA TAILLE DE LA LIGNE DU FICHIER EN OCTETS, LE 2EME EST LE
C   POINTEUR DANS LA LIGNE ET DOIT OBLIGATOIREMENT ETRE INITIALISE
C   A 0 AVANT LA PREMIERE ECRITURE SUR LE FICHIER. LES MOTS SUIVANTS
C   SERVIRONT A STOCKER UNE LIGNE DU FICHIER.
C   IL FAUT ABSOLUMENT TERMINER L'ECRITURE DU FICHIER PAR UN
C   DERNIER APPEL A WRBINP APRES AVOIR CHANGE DE SIGNE IBUF(2)
C    (EVENTUELLEMENT AVEC N=AVEC N N{GATIF, POUR VIDER LE DERNIER
C   BUFFER SUR LE FICHIER.
C   DIM. DEIBUF DOIT ETRE AU MOINS (LREC+3)/4+2 SI LREC EST LE NB D'OCTETS
C  PAR LIGNE.
C
      INTEGER A(1),ADRESS,IBUF(3),ADTAB
      I0=IAND(ADTAB,3)+1
      IA=ISHFT(ADTAB,-2)-ISHFT(ADRESS(A),-2)+1
      CALL WRBINR(LU,A(IA),I0,N,IBS,IBUF)
      RETURN
      END
