/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/
#include "xvis.h"

/* all help messages */

char *m_help[]= {
"      Cette fenetre peut etre obtenu avec\n\
	les touches H ou ? dans la fenetre image\n\n\
   xvis permet d'editer une image\n\
   ou de visualiser en continu ou en pas a pas\n\
    soit une liste d'images (liste circulaire),\n\
    soit une suite d'images lues sur stdin\n\
   l'option [-f dimx dimy] permet de lire des images sans header\n\
\n\
   essayez 'xvis -help' pour connaitre l'usage de la commande\n\
\n\
   Pour avoir un help particulier :\n\
   cliquez sur un mot-cle dans la fenetre ci-dessus\n\
   cliquez sur 'close' pour sortir du mode help\n\
\n\
  Les boutons comportant un '>' sont des boutons de menu.",
	0};

char xm_txtclick[]=
"                  Btn1 : +1 \n\
                  Btn1 + SHIFT : +10 \n\
                  Btn2 : -1\n\
                  Btn2 + SHIFT : -10 \n\
                  Btn3 : met 0\n\
                  Btn3 + SHIFT : met 255";


char xm_pick[]=
"    Btn1:  pixel pour le point 1\n\
    Btn1 + SHIFT: couleur pour le point 1\n\
    Btn3: pixel pour le point 2\n\
    Btn3 + SHIFT: couleur pour le point 2";

char xm_imkbd[]=
"Raccourcis clavier dans fenetre image\n\
	q Ctrl-c : exit\n\
	r : re-read\n\
	p : previous image\n\
	n, space, return : next image\n\
	Ctrl-p : previous Z\n\
	Ctrl-n : next Z\n\
	l : image loop\n\
	z : Z loop\n\
	e : toggle edit mode\n\
	Ctrl-l : move to (1,1)\n\n\
	H, ? : open HELP window\n\
	C : open COLORS window\n\
	S : open SHELL window\n\
	X : exp&exec current script\n\
	E : exec current script (continue if paused)\n\
	A : abort current script\n\n\
	Ctrl-f : show/modif file list\n\
	Meta-c : copy\n\
	Meta-p : paste\n\
	Meta-t : paste text\n\
	Meta-i : invert\n\
	Meta-u : undo\n\n\
	Up / Shift-Up : brightness +1 / +10\n\
	Down / Shift-Down : brightness -1 / -10\n\
	=:	reset brightness\n\
";

char *m_imag[]= {
"MODE NORMAL :\n\
    AnyButton:    affiche les coordonnees du point (comptees a partir de 1)\n\
    Btn3:  liste les coordonnees sur stdout (3 nbs : x y z)\n\
    Btn3:  liste les coordonnees sur stdout (-ix n -iy n -iz n)\n\
    deplacement Btn1 down: \n\
		avec option 'move image with mouse-1' : deplace l'image\n\
		sans option 'move image ...' : affiche les coordonnees en continu\n\
  \n\
  Boite delimitant une zone d'interet (3D si image 3D):\n\
    Btn1 + SHIFT:  valide/devalide la boite (alternativement)\n\
    Btn3 + SHIFT:  definit 1e sommet de la boite\n\
    Btn3 + SHIFT:  definit 2e sommet\n\
     (definir 1e et 2e sommet au meme point pour annuler la boite)\n\
\n\
 Attention : sur image sans boutons (option -nu) :\n\
     Btn*+SHIFT => exit\n\
     Btn1 -> NEXT, Btn2 -> PREV\n\
\n\
MODE EDIT :\n\
    Btn1:  met un point 'noir'\n\
    Btn2: met un point 'blanc'\n\
    Btn3: trace un segment vers le point precedent dans sa couleur\n\
    Btn3 + SHIFT: remplit un rectangle vers le point precedent, avec sa couleur\n\
\n\
MODE PICK (bouton 'pick' de la fenetre xvis-cmap) :",
	xm_pick,
"\n\n",
	xm_imkbd,
	0};

char *m_files[]= {
" Fait apparaitre la liste des fichiers sous forme de menu\n\
  S'il y a plus de 20 fichiers, on utilise 2 etages de menus\n\
  sortir par la droite du 1e menu pour faire apparaitre un sous-menu\n\
   de noms d'images\.n\n\
    Le fichier selectionne est affiche\n",
	0};
char *m_exit[]= {
	"        EXIT du programme!",
	"         (apres sauvegarde en mode EDIT)",
	0};

char xm_loop[]=
"   cliquer une 2e fois pour arreter la boucle";

char *m_loop[]= {
"start/stop du mode affichage en continu : \n\
   on affiche successivement les images de la liste\n\
   avec un temps d'attente de n secondes, donne par l'option '-l n'\n\
               (0 par defaut)\n\
   pas de rebouclage si les images sont lues sur stdin\n\
   visualisation periodique d'une image s'il n'y a qu'un nom\n",
	  xm_loop,
"   Le meme effet peut etre obtenu par \n\
    la touche 'l' dans la fenetre image\n",
	0};
char *m_same[]= {
	"relecture et affichage de l'image courante",
	" (avec relecture des tables couleurs si option -tc ou -tcf)",
	"  dans le cas d'une seule image, le meme effet est obtenu par",
	"       kill -1 xvis-process-id   (ou   kill -1 %job-number)",
	"   Le meme effet peut etre obtenu par ",
	"  la touche 'r' dans la fenetre image",
	0};
char *m_param[]= {
"modification des parametres d'affichage \n\
   Valider les modifications avec <Return> <Meta-r> ou <Meta-n> :\n\
    <Return> : validation; (cliquer sur 're_read' pour relire l'image)\n\
    <r>|<Meta-r> : validation et relecture de l'image\n\
    <n>|<Meta-n> : validation et lecture image suivante\n\
    <p>|<Meta-p> : validation et lecture image precedente\n\n\
  exp : permet de diviser les valeurs de l'image par 2**exp\n\
           (= nb de decalages a droite).\n\
	    utile avec les images de plus de 8 bits\n\n\
  zloop : facteur de repetition pour la fonction z-loop\n\n\
  nbhz : nb de plans affiches horizontalement si on a valide l'option\n\
		'display z horizontally'\n\
",
	0};
char *m_edit[]= {
	"passage en mode edition :",
	"  ecriture de points 'noirs' (bouton gauche) ou 'blancs' (bouton droite)",
	"  ecriture continue si deplacement souris avec bouton enfonce",
	"  bouton milieu : trace 1 droite jusqu'au point precedent et dans sa couleur",
	"  bouton milieu + SHIFT: remplit un rectangle",
	"",
	"les modifs sont sauvees periodiquement et lorsqu'on fait 're-read', 'edit' ou 'exit'",
	 0};
char *m_zloop[]= {
"start/stop de la boucle d'affichage successif des plans de l'image\n\
 un effet de ralenti est obtenu par affichages multiple\n\
     de chaque plan (option -zl)",
	 xm_loop,
"   Le meme effet peut etre obtenu par ",
"  la touche 'z' dans la fenetre image",
	0};
char *m_nextz[]= {
"met le plan suivant en haut a gauche (equivalent a z-loop en pas a pas)",
"   Le meme effet peut etre obtenu par ",
"  'Ctrl-n' dans la fenetre image",
0};
char *m_prevz[]= {
"met le plan precedant en haut a gauche (equivalent a z-loop en pas a pas)",
"   Le meme effet peut etre obtenu par ",
"   'Ctrl-p' dans la fenetre image",
0};
char *m_nextv[]= {
"met la composante suivante a gauche ",
"   Le meme effet peut etre obtenu par ",
"  'Ctrl->' dans la fenetre image",
0};
char *m_prevv[]= {
"met la composante precedente a gauche ",
"   Le meme effet peut etre obtenu par ",
"   'Ctrl-<' dans la fenetre image",
0};
char *m_upleft[]= {
"met le dernier point sur lequel on a clique en haut a gauche",
0};
char *m_center[]= {
"met le dernier point sur lequel on a clique au centre de la fenetre",
0};
char *m_next[]= {
	"   affichage de l'image suivante",
	"   (avec rebouclage sur la 1ere en fin de liste)",
	"       le meme effet est obtenu par",
	"       kill -1 xvis-process-id   (ou   kill -1 %job-number)",
	"   Le meme effet peut etre obtenu par ",
	"  les touches 'n' 'espace' ou 'return' dans la fenetre image",
	0};
char *m_prev[]= {
	"   affichage de l'image precedente",
	"   (avec rebouclage sur la derniere)",
	"",
	0};
char *m_options[]= {
" menu de choix de diverses options:\n\
   nombre de couleurs (256 ou 254) : 254 preserve background et foreground\n\
\n\
   calcul min max : si le calcul n'est pas fait le chargement sera un peu plus rapide\n\
\n\
   move image with mouse-1 : dans ce mode, en deplacant la souris avec le 1e bouton\n\
	enfonce, on deplace l'image\n\
\n\
   print points : controle l'impression sur stdout des coord. lorsqu'on clique sur 1 point image\n\
   print pixel value : controle l'impression sur stdout des valeurs de pixels\n\
   print edit actions : en mode edit add/sup impression sur stdout\n\
\n\
   get pixel from file : on lit les valeurs dans fichiers (8bits) au lieu de l'ecran\n\
\n\
   show/modif file list : fait apparaitre une fenetre avec la\n\
        liste des fichiers. En mode select, le double click \n\
        sur un nom fait afficher l'image\n\
        En mode modif, on peut modifer la liste\n\
	On valide les modifications en cliquant sur le bouton 'set',\n\
        on reaffiche alors la 1ere image si l'image courante\n\
        a ete supprimee.\n\
	cette fenetre peut aussi etre obtenue par 'Ctrl-f' dans la fenetre image\n\
\n",
"   display z horizontally : affichage des plans par rangees horizontales \n\n\
   Z-loop auto-reverse : la boucle en z change de sens a chaque extremite\n\
   loop auto-reverse : la boucle images change de sens a chaque extremite\n\n\
   horiz double cursor : le curseur est constitue de 2 fleches distantes d'une\n\
       1/2 largeur d'images (comparaison de 2 images cote a cote)\n\
   define double cursor : fait apparaitre une fenetre de definition de curseur double\n\
         les 2 fleches peuvent etre placees horizontalement (bouton 'horiz') ou \n\
         verticalement (bouton 'vert'). Leur distance est donnee par 'curs. interval'\n\
        (NDIMX/2 ou NDIMY si 0)\n\
        On clique sur le bouton 'set' pour activer le curseur,\n\
        sur 'unset' pour le desactiver et sur 'cancel' pour ne rien changer\n\
   use dble curs. in edit: si un curseur double est defini, il sera utilise\n\
        en mode edit (tout sera trace en double, mais seules les actions\n\
        du trace principal peuvent etre listees sur stdout)\n\
\n\
   text with background : le texte est ecrit sur un fond de background (blanc)\n\
\n\
   debug mode : passe en mode debug (messages sur stderr)",
0};

char xm_cmdes[]=
"     Les commandes speciales:\n\
          Elles correspondent generalement a un bouton ou une fonction de menu\n\
     Quelques commandes particulieres :\n\
        - center ([x][,[y][,z[,v]]]): place le point x,y,z,v au centre de la fenetre\n\
        - upleft ([x][,[y][,z[,v]]]) : met le point x,y,z,v en haut a gauche.\n\
        - params (...) : agit comme la fenetre de modification de parametres\n\
                    par ex: params(pas -2,nz 2)\n\
	- imlist(image1 ... imagen) : nouvelle liste de fichiers.\n\
        - edit(cmde,...,cmde) : pour effectuer les actions d'edit.\n\
             (C color,z plan,p x y,l x y) ... (color peut aller de 0 a 255)\n\
        - draw(cmde,..cmde) : trace des points et des lignes\n\
             commandes semblables a edit, + :\n\
                (L x1 y1   xn yn) pour ligne polygonale\n\
		(a x1 y1 w h ang1 ang2) pour arc(angles debut et lgr en degres)\n\
                (m0,m1) : mode cache' ou visible\n\
                (s x0 y0 z0 v0 dx dy dz dv) : show zone (utile en mode cache')\n\
        - ct_set(rgb,Rpix Gpix Bpix,Rcol Gcol Bcol) : change 1 point dans les tables\n\
               indiquees par rgb. Il faut donner 2 triplets de valeurs.\n\
        - ct_interp(rgb,pix1,col1,pix2,col2) : interpolation des tables\n\
               entre 2 points (pixi, coli : 3 valeurs R G B)\n\
        - ct_interp3(..) double interpolation\n\
        - colors, shell : font apparaitre les fenetres table couleur et shell\n\
        - texte(val[/background],string) : ecrit le texte string avec la couleur val,\n\
	      et le fond background, s'il est precise,\n\
              dans le coin haut gauche de la boite courante (dans tous les plans)\n\
        - ptexte([x y z v],val[/background],string) : ecrit le texte string avec la couleur val,\n\
	      et le fond background, s'il est precise,\n\
              a la position x y z v\n\
	- font(font_name) : choix d'une font pour le texte\n\
	- zscroll([incr],[use-zloop-count]) : copie, en haut de la fenetre image,\n\
	  le plan situe a la distance incr du plan courant (meme methode que zloop)\n\
        - echo(string) : envoie 'string' sur stdout\n\
        - dialog(label,value,button1, ... , buttonN) : \n\
            fenetre popup avec boite de dialogue (si label non vide) et boutons.\n\
            Quand on clique sur un bouton on reoit le nom du bouton\n\
            suivi de ':' et du contenu de <value> (vide par dfaut).\n\
";

char xm_shvar[]=
"  les principales variables sont :\n\
   $im : image d'entree (3 noms si couleur)\n\
   $ims : les images courantes (y compris image d'edition)\n\
   $im2 : image de sortie d'edition \n\
   $imr $img $imb : composantes couleur si couleur en 3 fichiers)\n\
   $x0, $y0, $z0, $v0 : coordonnees du coin haut gauche de la zonne d'interet\n\
   $x1, $y1, $z1, $v1 : coordonnees du coin bas droite de la zonne d'interet\n\
   $dx, $dy, $dz, $dv : taille de la zonne d'interet\n\
   $dimx, $dimy, $ndimx, $ndimy, $ndimz, $ndimv : taille image";

char *m_shell[]= {
"  cree une fenetre de generation de commandes qui comprend notamment :\n\
    une boite a boutons\n\
    une fenetre d'execution (commandes pretes pour le shell)\n\
    une fenetre d'entree des commandes\n\
    une fenetre a 3 boutons toggle (wait, csh, sh)\n\
    une fenetre d'entree de nom de fichier\n\
    une fentre d'affichage du contenu du fichier\n\
\n\
       le texte des fenetres d'execution et de commande est modifiable.\n\
\n\
    executer la commande   ##!$\n\
       pour avoir la liste des variables predefinies\n\
   et  ##!!\n\
       pour avoir la liste des commandes 'internes'\n\n",
	   xm_shvar,
	"   Le meme effet peut etre obtenu par ",
	"  'Shift-S' dans la fenetre image",
	   0};

char *msh_box[]= {
" boutons de commande (voir detail)",
	0};

char *msh_cancel[]= {
	"  fin du shell",
	0};
char *msh_expand[]= {
" copie la fenetre de commandes dans la fenetre d'execution avec\n\
    substitution des variables predefinies\n\n",
	xm_shvar,
	0};
char *msh_aexpand[]= {
" ajoute a la fenetre d'execution le contenu de la fenetre de commandes\n\
    apres substitution des variables predefinies\n\n",
	xm_shvar,
	0};
char *msh_exec[]= {
" mode normal :\n\
    copie la fenetre de commandes dans la fenetre d'execution avec\n\
    substitution des variables predefinies\n\
    puis execute les commandes obtenues (avec /bin/sh ou /bin/csh)",
	"   Le meme effet peut etre obtenu par ",
	"  'Shift-X' dans la fenetre image",
	0};
char *msh_repeat[]= {
"   execute le contenu de la fenetre d'execution telle quelle\n\
   mode pause :\n\
      continue l'execution\n",
	   xm_cmdes,
	"   Le meme effet peut etre obtenu par ",
	"  'Shift E' dans la fenetre image",
	0};
char *msh_kill[]= {
" tue le process courant s'il y a lieu",
0};
char *msh_abort[]= {
" tue le process courant s'il y a lieu et termine l'execution en cours",
	"   Le meme effet peut etre obtenu par ",
	"  'Shift-A' dans la fenetre image",
0};
char *msh_close[]= {
" ferme le pipe correspondant au standard input de la commande shell\n\
    utile pour simuler une fin de fichier pour le programme qui lit\n\
    les donnees fournies par xvis",
0};

char xm_shsyntx[]=
"   syntaxe de commande :\n\
      Si une ligne commance par les 3 caracteres '##!'\n\
        ce qui suit est une commande interne de  xvis\n\
           (executer '##!!' pour avoir la liste des commandes)\n\
      Tout groupe de lignes  entre 2 lignes commencant par '##!'\n\
        est une commande shell (shell script),\n\
        (en l'absence de '##!', l'ensemble du texte est une script)\n\n\
     On traite a part les sequences '|' '<|' et '>|' placees en debut de script :\n\
       '|' ou '<|' : cree un pipe reliant stdout de xvis a stdin du shell\n\
       '>|' : cree un pipe reliant stdout du shell a l'entree de commande de xvis\n\
            (sur cette entree on attend des commandes commencant par '##!')\n\
";

char *msh_wexec[]= {
" le texte contenu dans cette fenetre peut etre modifie au clavier\n\
    il est execute par le bouton 'exec'\n",
	xm_shsyntx,
	xm_cmdes,
	0};
char *msh_wcmde[]= {
" le texte contenu dans cette fentre peut etre modifie au clavier.\n\
   Lorsqu'on clique sur les boutons 'expand', 'expand+' ou 'exp&exec'\n\
    il est copie dans la fenetre d'execution avec substitution des variables prdefinies.\n\
    Si on a clique sur 'exp&exec', on enchaine sur l'execution.\n\
\n\
   Pour avoir la liste des variables (sur stderr de xvis) executer '##!$'\n",
	xm_shsyntx,
	xm_cmdes,
	0};

char *msh_wmode[]= {
	" cette fenetre contient les boutons suivants:\n\
\tpaused : de type label, est en video inverse losrque le script courant\n\
\t  est das l'etat 'paused', c-a-d apres ##!pause\n\
\twait : (toggle) pour valider ou devalider le mode wait\n\
\t    en mode wait xvis n'accepte plus d'interaction avant la fin du script courant\n\
\tcsh, sh, perl : choix de l'interprete pour les scripts",
	0};
char *msh_file[]= {
"  fenetre de dialogue pour lire un fichier de commandes\n\n\
  Bouton load :\n\
     charge le fichier choisi, dans la fenetre de texte du bas de l'ecran shell\n\
  Bouton select_all :\n\
     copie tout le fichier dans la fenetre d'entree de commandes\n\n\
  Dans la fenetre texte :\n\
    Btn1Up       =>  remplacer le contenu de la fenetre de commande\n\
                     par la ou les lignes selectionnees\n\
    Btn2Up       =>  selectionner le texte entre curseur et souris et\n\
                     remplacer le contenu de la fenetre de commande\n\
                     par la ou les lignes selectionnees\n\
                     Pour selectionner plusieurs lignes : cliquer avec Btn1\n\
                     sur la 1e et avec Btn2 sur la derniere\n\
    Shift Btn1Up =>  ajouter a la fenetre de commande\n\
                     la ou les lignes selectionnees\n\n\
    Si on clique sur une ligne commencant par ##!BEGIN, on selectionne\n\
		le bloc de lignes jusqu'au prochain ##!END ou ##!BEGIN\n\
    Si on clique sur une ligne commencant par '##!SELECT nom-de-bloc',\n\
                on selectionne le bloc correspondant (commencant par '##!BEGIN nom-de-bloc'",
	0};


char *m_fill[]= {
"  bouton fill :\n\
        remplit la zone choisie avec la valeur prise dans la fenetre 'fill value:'\n\
\n\
  fenetre de dialogue 'fill value:'\n\
       permet de rentrer la valeur de remplissage\n\
       RETURN => effectuer le remplissage\n\
       utilisation de la souris:",
	       xm_txtclick,
	       0};

char *m_clear[]= {
	"  met a 'blanc' la zone choisie",
	0};

char *m_set[]= {
	"  met a 'noir' la zone choisie",
	0};

char *m_inv[]= {
	"  inverse la zone choisie",
	"   Le meme effet peut etre obtenu par ",
	"  'Meta-i' dans la fenetre image",
	0};

char *m_copy[]= {
	"  copie la description de la zone choisie dans CUT BUFFER 7",
	"  Ce bloc sera utilisable par PASTE tant qu'on ne changera pas",
	"    l'image affiche'e (y compris par RE-READ)",
	"   Le meme effet peut etre obtenu par ",
	"  'Meta-c' dans la fenetre image",
	0};

char *m_paste[]= {
"  met dans la zone choisie de l'ecran courant\n\
    la partie d'image definie dans CUT BUFFER 7\n\
    le bloc peut provenir d'une autre fenetre xvis\n\
    a condition que celle-ci affiche toujours la meme image",
	"   Le meme effet peut etre obtenu par ",
	"  'Meta-p' dans la fenetre image",
	0};

char *m_ptext[]= {
"  met dans le coin haut gauche de la boite courante\n\
    le texte selectionne (CUT BUFFER 0)\n\
    Le texte est ecrit avec la couleur 'fill value'.\n\
    et avec la font courante (modifiable par la commande ##!font)\n\
    Il peut etre ou non sur fond blanc (voir  options)\n\
    Note: le texte est repete dans chaque plan de la boite",
	"   Le meme effet peut etre obtenu par ",
	"  'Meta-t' dans la fenetre image",
	0};

char *m_pmode[]= {
	"  choix de la fonction graphique utilisee par 'paste'",
	0};

char *m_undo[]= {
	"  annulle la derniere operation CLEAR SET INVERT ou PASTE",
	"   Le meme effet peut etre obtenu par ",
	"  'Meta-u' dans la fenetre image",
	0};

char *m_umode[]= {
	"  menu qui valide ou invalide UNDO",
	0};

char *m_dump[]= {
	" dump sur fichier de la partie selectionnee de l'image affiche'e\n\
	pour savoir comment definir la boite de selection\n\
	voir help de la fenetre image (cliquer sur image)\
",
	0};

char xm_colors[]=
" elle controle differentes tables:\n\
      -  les 3 tables RGB\n\
      -  une table de luminosite qui permet de modifier l'intensite des tables RGB\n\
          (independamment de leur contenu)\n\
     -   3 tables de masquage (RGB) dont on peut appliquer une fenetre sur les tables RGB\n\
\n\n\
La fenetre comporte 5 parties:\n\
 . fentre de commandes globales\n\
 . fenetre pour les noms de fichiers tables couleur en lecture et ecriture\n\
 . fenetre de commande de modification\n\
 . fenetre de definition des parametres\n\
      Voir help correspondant pour l'utilisation de la souris\n\
 . fenetre contenant une mire (256 niveaux)";

char *m_cmap[]= {
	"  ouvre une fenetre de modification des tables couleur",
	xm_colors,
	"   Le meme effet peut etre obtenu par ",
	"  'Shift-C' dans la fenetre image",
	0};

char *m_labels[]= {
	"cette boite contient 5 messages :\n\
  - min et max de l'image\n\
  - position (x,y,z,v) et valeur eventuelle du pixel designe a la souris\n\
  - parametres actuels de l'image (options -s et -p de xvis)\n\
  - nom de l'image, numero dans la liste, taille\n\
  - infos sur la boite courante : origine, taille, lgr diagonales",
	0};

char *m_colors[]= {
	"fenetre popup pour la modification des tables couleur",
	xm_colors,
	0};
char *m_cm_b1[]= {
	"boutons d'interet general\n\
   quit       : ferme la fenetre\n\
   valid      : valide les modifications de tables (si auto est off)\n\
   auto       : les modifications sont immediates (sinon APPLY)\n\
   grey *     : menu choisissant la table initiale :\n\
   ordre RGB *: menu de choix de l'ordre des composantes RGB\n\
   save       : ecrit la table courante dans le fichier 'out file'\n\
                (exceptionnellement l'en-tete si nom == image courante)\n\
   Brigthness : s'il est allume, on applique la table de luminosite\n\
                 sur les tables indiquees par les boutons RGB\n\
   Adjust     : initialise la table de luminosite a partir de min et max\n\
                 (modification de pix1, pix2 + 'interp3')\n\
   +/-        : permet de modifier la luminosite. Equivalent a cliquer sur le\n\
                 4e nb de la fenetres pix2 :",
	   xm_txtclick,
	0};

char *m_cm_menu[]= {
"menu de choix des tables RGB initiales (installees a chaque lecture)\n\
 - from image : tables  prises dans l'en-tete image\n\
 - from file : tables lues dans le fichiers 'in file' (3 lignes)\n\
           le fichier est lu a chaque selection et pour chaque image\n\
 - grey : tables lineiares\n\
 - current : a chaque lecture d'image on garde les tables courantes\n\
 - previous : recharger les tables precedentes\n\
 - table1 table2 : 2 tables de pseudo couleur\n\
 - random : table aleatoire avec condition initiale fixe\n\
 - random+ : table aleatoire avec condition initiale variable\n\
 - editG editR : associent une couleur verte ou rouge au pixel 254 (pour edit)",
0};

char *m_cm_files[]= {
"  2 fenetres de type dialog pour donner des noms de fichier table couleur\n\
     - in file : nom du fichier (3 lignes) pour le choix 'from file' du menu\n\
     - out file : nom du fichier (3 lignes) d'ecriture des tables RGB par le bouton 'save'\n\
                (l'ecriture a lieu dans l'en-tete image si nom == image courante)",
0};

char *m_cm_b2[]= {
"fenetre de choix des operations\n\
    se composde d'une sous-fenetre d'options et d'une sous-fenetre d'actions\n\
 - options :\n\
      R G B Br : choix des tables a modifier\n\
      MASK (toggle) : mise en service ou arret du 'masquage'\n\
      fenetre texte : affiche 4 valeurs correnpondant a la position courante des operations de 'shift'\n\
 - actions: \n\
      Les boutons agissent sur les table R G B ou Br selectionnees,\n\
       ou sur les rables R G B de masque (bouton MASK on)\n\
",
	0};
char *m_cm_b3[]= {
"fenetre de modification des parametres\n\
    se composde d'une sous-fenetre d'options et d'une sous-fenetre de parametres\n\
\n\
 - options :\n\
      R G B Br : choix des tables a modifier\n\
      Pick : Si ce bouton est 'ON' on pourra modifier les parametres (pixel, color)\n\
             en cliquant sur l'image:",
	      xm_pick,
"    Auto-Set : si ce bouton est 'ON', toute modification de parametre\n\
                a un effet immediat\n\
\n\
 - parametres :\n\
   On gere 5 parametres.\n\
   A chacun correspond un bouton et une fentre texte de 4 nombres\n\
   Action de la souris:\n\
    - sur un bouton :  on agit sur tous les termes correspondants aux tables selectionnees\n\
    - sur une fentre texte ; on agit sur le nombre pointe, independamment des boutons R G B Br\n\
   utilisation de la souris:\n",
	    xm_txtclick,
	0};

char xm_rgb[]= " R G B Br : boutons de type toggle\n\
       definissent a quelles tables (RGB ou luminosite)\n\
       les autres boutons de la fenetre s'appliquent\n\
\n\
   action de la souris sur R G B :\n\
     - Btn1 : inverse le bouton\n\
     - Btn2 : inverse le bouton et met les 3 dans le meme etat\n\
     - Btn3 : inverse les 3 boutons\n\
  action de la souris sur Br :\n\
     - Btn1 : inverse le bouton\n\
     - Btn2 : inverse le bouton et met RGB dans l'etat inverse\n\
     - Btn3 : inverse les 4 boutons\n";

char *m_cm_b2rgb[]= {
	xm_rgb,
	0};
char *m_cm_b3rgb[]= {
	xm_rgb,
	0};
char *m_cm_set[]= {
"modifie le point correspondant aux parametres {pix1,col1} ou {pix2,col2}",
0};

char *m_cm_interp[]= {
"modifie les tables couleurs entre 'pix1' et 'pix2'\n\
  par interpolation lineaire entre {pix1,col1} et {pix2,col2}",
0};

char *m_cm_interp3[]= {
"calcule les tables couleurs par une triple interpolation:\n\
  entre {0,0} et {pix1,col1}\n\
  entre {pix1,col1} et {pix2,col2}\n\
  et entre {pix2,col2} et {255,255}\n\
",
0};

char *m_cm_invert[]= {
"  invert : inverse les bits de chaque cellule des tables couleur\n\
   reverse : inverse l'ordre des cellules des tables couleur (permute f[0]-f[255], etc)\n\
",
0};
char *m_cm_shft[]= {
" operations de permutation des cellulles des tables. A chaque fois, \n\
   on effectue un decalage supplementaire d'une quantite donnee par le parametre 'delta'\n\
\n\
  mode normal (MASK OFF): \n\
    -->> : decalage vers la droite (on complete a gauche par 0)\n\
    <<-- : decalage vers la gauche (on complete a droite par 255)\n\
    <0>  : annulation du decalage\n\
    >--> : permutation circulaire vers la droite\n\
    <--< : permutation circulaire vers la gauche\n\
    loop>> : boucle sur permutation circulaire vers la droite\n\
\n\
  mode MASK :\n\
   les boutons controlent l'endroit des tables RGB ou on applique le masque\n\
",
0};

char *m_xv_b1[]= {
"boite a boutons principale : affichage des images",
0};

char *m_xv_b2[]= {
"boite a boutons pour modification de regions",
0};

struct hlp_tab hlp_tab[]= {
	{"xvis fenetre principale\n",m_help},
	{"\tboite de messages\n",m_labels},
	{"\t1e boite a boutons\n",m_xv_b1},
	{"\t\tEXIT<C-c,q>",m_exit},
	{" HELP<H>",m_help},
	{" Files",m_files},
	{" Loop<l>",m_loop},
	{" re-Read<r>\n",m_same},
	{"\t\tNext<n,Sp>",m_next},
	{" Prev<p>",m_prev},
	{" Nextz<C-n>",m_nextz},
	{" Prevz<C-p>",m_prevz},
	{" Z-Loop<z>\n",m_zloop},
	{" Nextv<C-n>",m_nextv},
	{" Prevv<C-p>",m_prevv},
	{"\t\tOptions",m_options},
	{" Upleft",m_upleft},
	{" Center",m_center},
	{" Edit<e>",m_edit},
	{" COLORS<C>",m_cmap},
	{" SHELL<S>\n",m_shell},
	{"\t2e boite a boutons\n",m_xv_b2},
	{"\t\tclear",m_clear},
	{" set",m_set},
	{" invert<M-i>",m_inv},
	{" fill",m_fill},
	{" copy<M-c>",m_copy},
	{" paste<M-p>",m_paste},
	{" paste-text<M-t>\n",m_ptext},
	{"\t\tmenu-graphic_op",m_pmode},
	{" menu-undo-mode",m_umode},
	{" undo<M-u>\n",m_undo},
	{"\tfenetre parametres\n",(char **)0},
	{"\t\tparametres-image",m_param},
	{"  fill value:",m_fill},
	{"  dump\n",m_dump},
	{"\timage\n",m_imag},
/* colors */
	{"colors\n",m_colors},
	{"\tcolors: 1e boite a boutons\n",m_cm_b1},
	{"\t\tmenu de choix des tables\n",m_cm_menu},
	{"\tcolors: fenetre d'entree de noms de fichiers\n",m_cm_files},
	{"\tcolors: 2e boite a boutons(modifications)\n",m_cm_b2},
	{"\t\tR G B Br\n",m_cm_b2rgb},
	{"\t\tset_1 set_2",m_cm_set},
	{" interp",m_cm_interp},
	{" interp3",m_cm_interp3},
	{" invert reverse\n",m_cm_invert},
	{"\t\tloop>> -->> <0> >--> <--<\n",m_cm_shft},
	{"\tcolors: fenetre de modification de parametres\n",m_cm_b3},
	{"\t\tR G B Br\n",m_cm_b3rgb},
/* shell */
	{"shell\n",m_shell},
	{"\tboite a boutons\n",msh_box},
	{"\t\tquit",msh_cancel},
	{" expand",msh_expand},
	{" expand+",msh_aexpand},
	{" exec<E>",msh_repeat},
	{" exp&exec<X>",msh_exec},
	{" kill",msh_kill},
	{" abort<A>",msh_abort},
	{" close pipe\n",msh_close},
	{"\tfenetre d'execution\n",msh_wexec},
	{"\tfenetre de commandes\n",msh_wcmde},
	{"\tcontrole du mode d'execution\n",msh_wmode},
	{"\tfenetres pour un fichier de commandes\n",msh_file},
};
#define NBHLP (sizeof(hlp_tab)/sizeof(struct hlp_tab))
short hlp_ends[NBHLP];
int nb_hlp_msg= NBHLP;
