/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/X.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/AsciiText.h>
#include "xvis.h"

Widget hlp_widget, hlp_shell= 0, hlp_child, hlp_box, hlp_lst;
extern Widget par_dial_widget, image_widget;
extern GC defgc;
extern Colormap defcmap;
extern Display *dpy;
extern Window toplevel;
extern Visual *mydefvisual;
extern struct button *lbtn_help[];
extern int Nboutons, nbt_cutp;
extern struct button *b_list[], *l_bcutp[];
extern struct button *l_cmapbtn[], *l_dump[];

extern int coord_imag();
extern char *i_malloc();

extern char *m_imag[];
/* les help messages */
extern char **p_msg, *m_help[], *m_param[];
extern char **old_msg;
extern char *message;

unsigned char *hlp_liste= NULL;
extern struct hlp_tab hlp_tab[];
extern int nb_hlp_msg;
extern short hlp_ends[];

static Arg args[7];
static XtTranslations hlpparsed_trans;
static char *hlptxtTrans= "<Btn1Up>: txt_hlp()";

prt_msg()
{
	create_hlpw();
}

init_hlp_msg()
{
	register struct hlp_tab *ph;
	register unsigned char *p1, *pc;
	register char **pp;
	register i, l;
	register lmax;
	l = 0;
	lmax = 0;
	ph = hlp_tab;
	for(i=0;i<nb_hlp_msg;i++) {
		l += strlen(ph->label);
		hlp_ends[i] = l;
		ph++;
	}
	hlp_liste = (unsigned char *)i_malloc(l+2);
	ph = hlp_tab;
	pc = hlp_liste;
	for(i=0;i<nb_hlp_msg;i++,ph++) {
		p1 = (unsigned char *)ph->label;
		while((*pc = *p1++))
			pc++;
		if((pp = ph->msg) == NULL) continue;
		l = 0;
		while(*pp != NULL) {
			l += strlen(*pp) + 1;
			pp++;
		}
		if(l > lmax)
			lmax = l;
	}
	message = (char *)i_malloc(lmax + 4);
}

create_hlpw()
{
	Dimension w, h;
	if(!hlp_shell) {
		if(hlp_liste == NULL) {  /* init table de messages */
			init_hlp_msg();
			hlpparsed_trans = XtParseTranslationTable(hlptxtTrans);
		}
		XtSetArg(args[0], XtNvisual, mydefvisual);
		XtSetArg(args[1], XtNcolormap, defcmap);
		hlp_shell = XtCreatePopupShell("xvis-help",topLevelShellWidgetClass,toplevel,args,2);
		hlp_child = XtCreateManagedWidget("xvhlp",panedWidgetClass,hlp_shell,args,2);
		hlp_box = XtCreateManagedWidget("xvhlpbox",boxWidgetClass,hlp_child,args,0);
		createbuttons(hlp_box,lbtn_help,1);
		xvmanagebuttons(lbtn_help,1);

		XtSetArg(args[0],XtNstring,(XtArgVal)hlp_liste);
		XtSetArg(args[1],XtNtype,XawAsciiString);
		XtSetArg (args[2], XtNscrollVertical,XawtextScrollWhenNeeded);
		XtSetArg (args[2], XtNscrollVertical,XawtextScrollAlways);
		XtSetArg (args[3], XtNscrollHorizontal,XawtextScrollWhenNeeded);
		XtSetArg (args[3], XtNscrollHorizontal,XawtextScrollWhenNeeded);
		XtSetArg (args[4], XtNresizable,True);
		XtSetArg (args[5], XtNuseStringInPlace,True);
		hlp_lst = XtCreateManagedWidget ("xvhlplist", asciiTextWidgetClass, hlp_child,args,6);
		XtOverrideTranslations(hlp_lst,hlpparsed_trans);
		XtSetArg(args[0],XtNstring,(XtArgVal)message);
		hlp_widget = XtCreateManagedWidget ("help", asciiTextWidgetClass, hlp_child,args,5);
		XtRealizeWidget(hlp_shell);
		XtPopup(hlp_shell,XtGrabNone);
		XFlush(dpy);
	} else {
		XtSetArg(args[0],XtNstring,(XtArgVal)message);
		XtSetValues(hlp_widget,args,1);
	}
}


show_msg()
{
	old_msg = NULL;
	create_hlpw();
	set_msg(m_help);
}

static char help_trans[80];
static XtTranslations par_dial_trans;



close_help()
{
	XtDestroyWidget(hlp_shell);
	hlp_shell = 0;
	p_msg = NULL;
	XFlush(dpy);
}

xvtxt_hlp(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;			
Cardinal *num_params;		
{
	XawTextPosition pos;
	register i;
	if(w != hlp_lst)
		imerror(9,"xvtxt_hlp : bad widget\n");
	pos = XawTextGetInsertionPoint(w);
	i = d_search(hlp_ends,nb_hlp_msg,(int)pos);
	if(i >= 0 && hlp_tab[i].msg != NULL) {
		set_msg(hlp_tab[i].msg);
	}
}

d_search(buf,n,i)
register unsigned short *buf;
register n, i;
{
	register j, j1;
	j1 = 0;
	while(j1 < (n-1)) {
		j = (j1 + n) / 2;
		if(i >= (int)*(buf + j)) {
			j1 = j;
		} else {
			n = j;
		}
	}
	if(i < (int)*(buf+j1))
		return j1;
	else
		return (j1 + 1);
}
